///////////////////
//Functions for the
//special abilities system.
///////////////////

use uo;
use os;
use util;
use cfgfile;

include "include/client";
include "saevent";
include "include/magic";
include "include/poison";
include "include/effects";
include "../pkg/character/poisons/poisons";

function cast_special_ability (byref zSelf, byref myTarg)
var MyTemplateElem := GetNpcTemplateElem (me.npctemplate);
	var abilityNum := GetConfigString (MyTemplateElem, "ability");
	
	if (!abilityNum)
		return;
	endif
	var chance := GetConfigInt (MyTemplateElem, "ability_chance");
	if (!(Cint(chance)>0))
		chance :=50;
	endif

	
	If (RandomInt ( 80 ) < Cint( chance))
		handleabilityEvents (zSelf, abilityNum, myTarg);
	Endif
endfunction


///////////////////////////////////////////
//handleSpellEvents( zSelf, spellNum )
///////////////////////////////////////////
function handleabilityEvents( zSelf, abilityNum, myTarg )
UnloadConfigFile( ":sabilities:sabilities" );
var sacfg := ReadConfigFile( ":sabilities:sabilities" );
var sElem := FindConfigElem( sacfg, abilityNum );
var sDamage := GetConfigInt( sElem, "damage" );
var sEffect := SplitWords( GetConfigString( sElem, "theEffect" ) );
var sOption := SplitWords( GetConfigString( sElem, "theOption" ) );
var sEventArray := {};


foreach sEvent in sEffect
	sEventArray.append( sEvent );
endforeach
foreach sEvent in sOption
	sEventArray.append( sEvent );
endforeach


if( sDamage > 0 )
	ApplyRawDamage( myTarg, calcDamage( zSelf, myTarg, sDamage ) );
endif


foreach sEvent in sEventArray
	if( sEvent )
	    if( myTarg.dead || !myTarg )
	        break;
	    endif
		
	    evalEvent( sEvent, zSelf, myTarg  );
	endif
	sleepms(2);
endforeach

return 1;

endfunction



////////////////////
//evalEvent( event )
////////////////////
function evalEvent( event, caster, victim,  )
	AlertGM("Firing ability : " + event );
	var mager := GetAttribute( caster, ATTRIBUTEID_MAGERY );
	var parms;
	
	case( event )
		///////////////////////////////////
		//First are the "theEffect" options
		///////////////////////////////////
		"expa": PlayStationaryEffect( victim.x, victim.y, victim.z, 0x36b0, 7 , 0x10 );
			return;
		"expb": PlayStationaryEffect( victim.x, victim.y, victim.z, 0x36bd, 7 , 0x10 );
			return;
		"expc": PlayStationaryEffect( victim.x, victim.y, victim.z, 0x36ca, 7 , 0x10 );
			return;
		"oball": PlayStationaryEffect( victim.x, victim.y, victim.z, 0x36fe, 7 , 0x10 );
			return;
		"fstrike": PlayStationaryEffect( victim.x, victim.y, victim.z, 0x3709, 7 , 0x10 );
			return;
		"bsmoke": PlayStationaryEffect( victim.x, victim.y, victim.z, 0x3728, 7 , 0x10 );
			return;
		"ssmoke": PlayStationaryEffect( victim.x, victim.y, victim.z, 0x3735, 7 , 0x10 );
			return;
		"lightb": PlayLightningBoltEffect( victim );
			return;
		"lavaSpank": lavaFall( victim );
			return;
		"grpFball": grpFball( caster, victim );
			return;
		"grpFstrike": grpFstrike( caster, victim );
			return;
		"destruction": zDestruction( victim );
			return;
		"sumElem": summonStuff( victim, "succubus", "succubus", "succubus", "succubus" );
			return;
		"sumBadDem": summonStuff( victim, "hezrou", "bebilith", "hezrou", "bebilith" );
			return;
		"sumDragon": summonStuff( victim, "dragon1", "dragon2", "shamandrake", "shamandrake" );
			return;

		///////////////////////////////
		//Next, the "theOption" options
		///////////////////////////////
		"blindL": victim.setlightlevel( 30, mager * 200 );
			return;
		"blindS": victim.setlightlevel( 27, mager * 200 );
			return;
		"endanger": endanger( caster, victim );
			return;
		
		"vampiricL": 
			parms := { caster, victim, 120, Cint(mager/10) };
			start_script( ":sabilities:vampiric", parms );
			return;
		"vampiricS": 
			parms := { caster, victim, 200, Cint(mager/20) };
			start_script( ":sabilities:vampiric", parms );
			return;
		"mvampiricS": 
			parms := { caster, victim, 200, 15 };
			start_script( ":sabilities:vampiricMana", parms );
			return;
		"massvampiric": 
			parms := { caster, victim, 140, calcDamage( caster, victim, 14 ) };
			start_script( ":sabilities:massVampiric", parms );
			return;
		"dropDex":
			parms := { victim, 80, calcDamage( caster, victim, 14 ) };
			AddPoison(victim, "dropdex", Cint(mager/2));
			return;
		"fof":
			parms := { victim, Cint(mager/3) };
			start_script( ":sabilities:fof", parms );
			return;
		"fop":
			parms := { victim, Cint(mager/3) };
			start_script( ":sabilities:fop", parms );
			return;
		"lPoison": SetPoison (victim, 2, "You've been poisoned!");
			PlayObjectCenteredEffect (victim, EFFECT_BLUE_SPARKLE, 10, 10);
			return;
		"poison": SetPoison (victim, 4, "You've been poisoned!");
			PlayObjectCenteredEffect (victim, EFFECT_BLUE_SPARKLE, 10, 10);
			return;
		"gPoison": SetPoison (victim, 7, "You've been poisoned!");
			PlayObjectCenteredEffect (victim, EFFECT_BLUE_SPARKLE, 10, 10);
			return;
		"dPoison": SetPoison (victim, 10, "You've been poisoned!");
			PlayObjectCenteredEffect (victim, EFFECT_BLUE_SPARKLE, 10, 10);
			return;
		"weaken":
			PlaySoundEffect (victim, SFX_SPELL_CURSE);
			PlayObjectCenteredEffect (victim, FX_CURSE_EFFECT, 7, 7);
                	AddPoison(victim, "spellweaken", Cint(mager/2));
			return;
		"para":
			AddPoison(victim, "para", Cint(mager/3));
			return;
		"trashtalk":	
						
				case (RandomInt (10))
					0:	PrintTextAbove (caster, "I'm coming for you " + victim.name );
					1:	PrintTextAbove (caster, " Do I smell fear on you " + victim.name );
					2:	PrintTextAbove (caster, "Omni hits harder than you do");
					3:	PrintTextAbove (caster, "Is that all you got big boy");
					4:	PrintTextAbove (caster, "*yawn*");
					5:	PrintTextAbove (caster, "Do you really want to make me angry?");
					6:	PrintTextAbove (caster, victim.name + " smells of elderberrys");
					7:	PrintTextAbove (caster, "How about a take that sword and shove it up..");
					8:	PrintTextAbove (caster, "Come back when you have more people");
					9:	PrintTextAbove (caster, "*gets really super pissed*");
				endcase
		
			return;
		"firerain":
			parms := {"#SPECIALNONE" , victim };
			start_script (":special:firerain", parms);
			return;
		"snowstorm":
			parms := {"#SPECIALNONE" , victim };
			start_script (":druid_spells:snowstorm", parms);
			return;
	endcase

endfunction

function calcDamage( caster, caston, basedmg )

	var cres := cInt(GetAttribute( caston, ATTRIBUTEID_MAGICRESISTANCE ));
	var cmag := cInt(GetAttribute( caster, ATTRIBUTEID_MAGERY ));
	var ceis := cInt(GetAttribute( caster, ATTRIBUTEID_INVOCATION ));
	var resC;
	var sDmg := basedmg;

	var ctra := cres / 5;
	var ctrb := cres - ( ( (cmag - 20) / 5) + 30 );

	if( ctra > ctrb )
		resC := ctra;
	elseif( ctrb > ctra )
		resC := ctrb;
	else
		resC := ctra;
	endif

	

	if( RandomInt(100) <= resC )
		//Spell was resisted
	
		SendSysMessage( caston, "You feel yourself resist " + caster.name + "'s ability!" );
		
		sDmg := sDmg / 2;
	endif

	var dmgMod;

	if( cres > ceis )
		//Resistance is higher than attackers Evaluating Intelligence
		dmgMod := 1 + ( ceis - cres ) / 200;
	else
		//Evaluating Intelligence is higher than Resistance
		dmgMod := 1 + ( ceis - cres ) / 500;
	endif

	sDmg := sDmg * dmgMod;

	return sDmg;

endfunction

