////////////////////////////////////////////
//Some spell options are here...
////////////////////////////////////////////

include "include/eventid";
include "include/spawn";

Const ENDANGER_RANGE := 12;


//////////////////////////////////////
//Endager (make nearby animals attack)
//////////////////////////////////////
function endanger( caster, who )

	var theMobs := ListMobilesNearLocation( who.x, who.y, who.z, ENDANGER_RANGE );
	var theEvent array;
	theEvent.+type;
	theEvent.+source;
	theEvent.type := EVID_DAMAGED;
	theEvent.source := who;

	foreach Mob in theMobs
		if( !Mob.acctname and !GetObjProperty (Mob, "master"))
			SendEvent (Mob, theEvent);
		endif
		sleepms(2);
	endforeach

	
	
	return;

endfunction

/////////////////
//lavaFall( who )
///////////////////////////////////////////
//Lava Fall doesnt apply damage on its own.
///////////////////////////////////////////
function lavaFall( who )

	var parms := {};
	parms[1] := who;
	start_script(":sabilities:lavafall", parms);

endfunction

/////////////////////////////////////
//doPoison( who, strength, duration )
/////////////////////////////////////
function doPoison( who, strength, duration )

	who.SetPoisoned(1);
	var parms := {};
	parms[1] := who;
	parms[2] := strength;
	parms[3] := duration;
	start_script(":poison:dopoison", parms);

endfunction

////////////////////////////
//grpFball( caster, victim )
////////////////////////////
function grpFball( caster, victim )

	var Vics := ListMobilesNearLocation( victim.x, victim.y, victim.z, ( GetAttribute( caster, ATTRIBUTEID_MAGERY ) / 10 ) );
	var rawDmg := 40;
	
	foreach vic in Vics
	    if( vic != victim )
		PlayMovingEffect( victim, vic, FX_FIREBALL, 5, 1 );
		PlaySoundEffect( victim, SFX_SPELL_FIREBALL );
		//Should do some dmg here? hmm?
		ApplyRawDamage( victim, calcDamage( caster, vic, rawDmg ));
	    endif
	  sleepms(2);
	endforeach

endfunction

//////////////////////////////
//grpFstrike( caster, victim )
//////////////////////////////
function grpFstrike( caster, victim )

	var Vics := ListMobilesNearLocation( victim.x, victim.y, victim.z, ( GetAttribute( caster, ATTRIBUTEID_MAGERY ) / 10 ) );
	var rawDmg := 60;
	foreach vic in Vics
		PlayStationaryEffect(vic.x, vic.y, vic.z, 0x3709, 0x0a, 0 );
		PlaySoundEffect( vic, SFX_SPELL_FLAME_STRIKE );
		//Should do some dmg here? hmm?
		ApplyRawDamage( victim, calcDamage( caster, vic, rawDmg ));
	    sleepms(2);
	endforeach

endfunction

////////////////////////
//zDestruction( victim )
////////////////////////
function zDestruction( victim )

	PlaySoundEffect( victim , SFX_SPELL_EXPLOSION );
	PlayStationaryEffect( victim.x+1,victim.y,victim.z , FX_EXPLODE_3 , 7 , 0x10 );
	PlayStationaryEffect( victim.x,victim.y,victim.z , FX_EXPLODE_3 , 7 , 0x10 );
	PlayStationaryEffect( victim.x-1,victim.y,victim.z , FX_EXPLODE_3 , 7 , 0x10 );
	PlayStationaryEffect( victim.x+1,victim.y+1,victim.z , FX_EXPLODE_3 , 7 , 0x10 );
	PlayStationaryEffect( victim.x,victim.y+1,victim.z , FX_EXPLODE_3 , 7 , 0x10 );
	PlayStationaryEffect( victim.x-1,victim.y+1,victim.z , FX_EXPLODE_3 , 7 , 0x10 );
	PlayStationaryEffect( victim.x+1,victim.y-1,victim.z , FX_EXPLODE_3 , 7 , 0x10 );
	PlayStationaryEffect( victim.x,victim.y-1,victim.z , FX_EXPLODE_3 , 7 , 0x10 );
	PlayStationaryEffect( victim.x-1,victim.y-1,victim.z , FX_EXPLODE_3 , 7 , 0x10 );

endfunction

function summonStuff( victim, monA, monB, monC, monD )
	var realtemplateA := FindPackage (monA);
	if (!realtemplateA)
		Syslog ("Error finding NPC template - " );
		return "error";
	endif

	var realtemplateB := FindPackage (monB);
	if (!realtemplateB)
		Syslog ("Error finding NPC template - " );
		return "error";
	endif

	var realtemplateC := FindPackage (monC);
	if (!realtemplateC)
		Syslog ("Error finding NPC template - " );
		return "error";
	endif
	var realtemplateD := FindPackage (monD);
	if (!realtemplateD)
		Syslog ("Error finding NPC template - " );
		return "error";
	endif

	CreateNpcFromTemplate( realtemplateA, victim.x+5, victim.y, victim.z );
	CreateNpcFromTemplate( realtemplateB, victim.x-5, victim.y, victim.z );
	CreateNpcFromTemplate( realtemplateC, victim.x, victim.y+5, victim.z );
	CreateNpcFromTemplate( realtemplateD, victim.x, victim.y-5, victim.z );

endfunction