const ALLY_HENCHMAN := 1;
const ALLY_PET := 2;

var glx,gly;	// last positon of what i guarded
var gwait;	// current guard scan delay

var targets;

function sweepminwait()
	var sload := cint(polcore().sysload);
	
	if (sload < 1)
		return 1;
	elseif (sload < 5)
		return 2;
	elseif (sload < 10)
		return 3;
	elseif (sload < 25)
		return 4;
	else
		return 5;
	endif
endfunction

function guardsweep(atype,stype := 0)
	var clocktime := ReadGameClock();
	var o;
	
	if (!gwait)
		gwait := sweepminwait();
	endif
	
	if (me.frozen)
		sleep (1);
		return 0;
	// Don't try to guard the mymaster if the henchman is already fighting.
	elseif (fighting)
		nextwatch := clocktime + sweepminwait();
		return 0;
	endif

	if (nextwatch <= clocktime) 
		nextwatch := clocktime + gwait;

//		PrintTextAbove(me,"*" + sweepminwait() + "*");		
//		PrintTextAbove(me,"*" + gwait + "*");
//		PrintTextAbove(me,"" + guarding.x + "," + guarding.y + "," + glx + "," + gly );
			
		if (gwait < (sweepminwait()*5) )
			gwait := gwait + 1;
		endif

		if ( (guarding.x != glx) || (guarding.y != gly) )
//			PrintTextAbove(me,"*reset*");
			glx := guarding.x;
			gly := guarding.y;
			gwait := sweepminwait();
		endif
		
		if (atype == ALLY_HENCHMAN)
			if (Random (100) == 99)
				HenchieSay ("I've got your back, " + guarding.name);
				if (Random (20) == 19)
					HenchieSay ("WAY back");
				endif
			endif
		endif

		var chosen_target := 0;
		var old_distance := 1000;
		var maxattackrange := HALT_THRESHOLD;
		
		if (atype == ALLY_PET)
			if(!caster && (HALT_THRESHOLD < maxrundistance))
				maxattackrange := maxrundistance;
			endif
		endif


		foreach mob in ListHostiles (guarding, maxattackrange, LH_FLAG_LOS) // HALT_THRESHOLD, LH_FLAG_LOS
			if (Distance (me, mob) < old_distance && AttackableTarget(mob, 1) && !(mob == guarding || mob == mymaster || mob == following))
				if (Abs(mob.z - me.z) < 25)
					chosen_target := mob;
					old_distance := Distance (me, mob);
				endif
			endif
		endforeach
			
		foreach serial in getallies(me.master)
			if (serial != me.serial)
				o := SystemFindObjectBySerial(serial);
				foreach mob in ListHostiles (o, maxattackrange, LH_FLAG_LOS) // HALT_THRESHOLD, LH_FLAG_LOS
					if (Distance (me, mob) < old_distance && AttackableTarget(mob, 1) && !(mob == guarding || mob == mymaster || mob == following))
						if (Abs(mob.z - me.z) < 25)
							chosen_target := mob;
							old_distance := Distance (me, mob);
						endif
					endif
				endforeach			
			endif
		endforeach
			
			
		if (chosen_target && !fighting)
			if (atype == ALLY_PET)
				if (Random (20) == 19)
					if (dragonspeak)
						dragontalk("guardingattacked", chosen_target.name); 
					endif
				endif
			endif
			
//			PrintTextAbove(me,"*reset*");			
			Fight (chosen_target);
		endif
	endif

	if (!LifeCheck(guarding))
		guarding := 0;
		return 0;
	endif
	return 1;
endfunction

// used to determine if a target that has just entered is a valid
// target for smiting.
function ValidBeatdownTarget(me,mob)

//	never attack a player's follower just because of EVID_ENTEREDAREA
	var x := mob;
	while (x.master)
		x:=x.master;
	endwhile
	if (x.acctname)
		return 0;
	endif
	
//	standard baddie detection code
	If ( (attackabletarget(mob, 0)) && (Abs(mob.z - me.z) < 25) )			
		var MyTemplateElem := GetNpcTemplateElem (mob.npctemplate);
		var IsItHostile := 0;
		If (MyTemplateElem)
			ISItHostile := GetConfigString (MyTemplateElem, "hostile");
		endif
		If (IsItHostile)
			gwait := sweepminwait();
			return 1;
		endif
	endif
	
	return 0;
endfunction

function CachedTarget(master,txt)
	var s;
	var targ;
	var tim;
	var now;

	s := GetObjProperty(master,"#ts-" + txt);
	targ := SystemFindObjectBySerial(s);
	if (!targ)
		targ := 0;
	endif
	tim := GetObjProperty(master,"#tt-" + txt);
	if (!tim)
		tim := 0;
	endif
	
	now := ReadGameClock();

//	SendSysMessage(master,"" + targ + "," + tim + "," + now);
	
	if ( ( (now - tim) < 10 ) && ( targ ) )
		return targ;
	endif
	
	return 0;
endfunction

function SharedTarget(master,txt,topt,skillattr,debug := 0)
	var targ;
	var loops := 0;
	
	targ := Target(master,topt);
	
	if (targ.errortext)
		while (loops < 10)
			targ := CachedTarget(master,txt);
			if (targ)
//				PrintTextAbove(me,"*using cache*");
				return targ;
			endif
			
			loops := loops + 1;
			sleepms(1000);
		endwhile
	else
		SetObjProperty(master,"#ts-" + txt,targ.serial);
		SetObjProperty(master,"#tt-" + txt,ReadGameClock());
		
//		PrintTextAbove(me,"*using target*");
		return targ;	
	endif	
	
//	PrintTextAbove(me,"*failed to get target*");
	return 0;
endfunction

/*
// This function is designed to speed up speech processing of subordinates.
// It changes the command from "all heal" to "name heal", so you only have
// to process the "name heal" case.  all is set to 1 if it was an all command
// so you can process it.

// call it like:

// if (!apspeechproc(evtext, mename))
//	return;
// endif

function apspeechproc(byref line, name)
	// change "all" to me
	if (line["all"])
		line["all"] := name;
	endif
	
	// if I see me (or all changed to me), I process the command.
	if (line[name])
		return 1;
	endif
	
	return 0;
endfunction
*/

function becomeally(me,master)
	set_critical(1);
	
	var allies := getobjproperty(master,"#followers");
	if (!allies)
		allies := {};
	endif

//	sendsysmessage(master,"ally:" + allies);
	
	if (!(me.serial in allies))
		allies.append(me.serial);
	endif

//	sendsysmessage(master,"ally:" + allies);
	
	setobjproperty(master,"#followers",allies);
	
	set_critical(0);	
endfunction

function getallies(master)
	var allies := getobjproperty(master,"#followers");
	if (!allies)
		allies := {};
	endif
	
	var i;
	for (i:=1;i<len(allies)+1;i:=i+1)
		if ( (!SystemFindObjectBySerial(allies[i])) )
			allies.erase(i);
		endif
	endfor
	
	setobjproperty(master,"#followers",allies);
	
	return allies;
endfunction

function ceaseally(me,master)
	set_critical(1);

	var allies := getobjproperty(master,"#followers");
	if (!allies)
		allies := {};
	endif

//	sendsysmessage(master,"ally:" + allies);
	
	var i;
	for (i:=1;i<len(allies)+1;i:=i+1)
		if (allies[i] == (me.serial))
			allies.erase(i);
		endif
	endfor
	setobjproperty(master,"#followers",allies);	

//	sendsysmessage(master,"ally:" + allies);
	
	set_critical(0);
endfunction





/*
		if (stype == 1)
			foreach mob in ListMobilesNearLocationEX ( me.x, me.y, me.z, maxattackrange, LISTEX_FLAG_NORMAL )
				if( AttackableTarget(mob, 1) && Distance (me, mob) < old_distance && !(mob == guarding || mob == mymaster || mob == following))
					if (Abs(mob.z - me.z) < 25)
						var MyTemplateElem := GetNpcTemplateElem (mob.npctemplate);
						var IsItHostile := 0;
						If (MyTemplateElem)
							ISItHostile := GetConfigString (MyTemplateElem, "hostile");
						endif
						If (IsItHostile)
							chosen_target := mob;
							old_distance := Distance (me, mob);
						endif
					endif
				endif
			endforeach
		else
*/