include "include/client";
include "include/objtype";
include "include/effects";
include "include/eventid";
include "include/sysevent";
include "include/string";
include "include/myutil";
include "include/dotempmods";
include "include/attributes";
include "../pkg/npcs/npc_util";
include "../pkg/npcs/npcinfo";
include "../pkg/npcs/main_ai/combat/spellcasting";

var me := Self();
var next_look_around;

Const CLOSEDISTANCE_MOVED			:= 0;
Const CLOSEDISTANCE_DIDNT_MOVE		:= 1;
Const CLOSEDISTANCE_PEACEMADE			:= 2;
Const CLOSEDISTANCE_FLEEING			:= 3;


///////////////////
//  Called whenever the NPC is started or restarted
///////////////////

function DoStartupSetup ()
	var MyTemplateElem := GetNpcTemplateElem (me.npctemplate);
	if (!MyTemplateElem)
		AlertGM("we are missing the npctemplate");
		KillMe ();
	endif

	if (MyTemplateElem.rank)
		var rank := CINT (MyTemplateElem.rank);
		SetObjProperty (me, "rank", rank);
	endif
endfunction




///////////////////
//  called when the NPC is first created
///////////////////

function DoOnCreationSetup ()
	run_script_to_completion (":npcs:npc_setup", me);
	var myx := me.x;
	var myy := me.y;

	if (!me.frozen)
		var old_dex_mod := GetAttributeTemporaryMod (me, "Dexterity");
		SetAttributeTemporaryMod (me, "Dexterity", 5000);
		Move ("N");
		Move ("N");
		if (me.x == myx and me.y == myy)
			Move ("S");
			Move ("S");
			if (me.x == myx and me.y == myy)
				Move ("E");
				Move ("E");
				if (me.x == myx and me.y == myy)
					Move ("W");
					Move ("W");
					if (me.x == myx and me.y == myy)
						if (!me.frozen)
							AlertGM("oh no its killing me");
							KillMe ();
							return;
						endif
					endif
				endif
			endif
		endif
		SetAttributeTemporaryMod (me, "Dexterity", old_dex_mod);
	endif
endfunction