//include "include/starteqp";
include "include/string";
include "../pkg/npcs/npc_util";

set_critical(0);
//global me := self();
drop_anchor();
var questtype := 1;

var speechelem := GetNpcTemplateElem( me.npctemplate);
//var speech := getconfigstring(speechelem, "speech") ;
var equipname := speechelem.equip;
var saywords := speechelem.saywords;
var flee_point := speechelem.flee_point;
if (!flee_point)
        flee_point := 10;
endif

if (!me.backpack)
	me.hidden := 1;
	var newbackpack := CreateItemAtLocation(me.x, me.y, me.z, 0xe75,1);
	EquipItem(me, newbackpack);

if( me.name["<random>"] )
	me.gender := RandomInt(2);
	me.graphic := 400 + me.gender;
	var title := randomint(20);
	var ttitle := "";
	case (title) 
          	0: ttitle := "";
          	1: ttitle := " the townsperson";
          	2: ttitle := " the farmer";
          	3: ttitle := " the sailor";
          	4: ttitle := " the drunkard";
          	5: ttitle := " the wanderer";
          	6: ttitle := " the villager";
          	7: ttitle := " the gypsie";
          	8: ttitle := " the vagabond";
          	9: ttitle := " the laborer";
	       	  default: ttitle := "";
	endcase

	me.name := randomname(me);
	me.title_suffix := ttitle;
	var style := "poor";
	case (RandomInt(4))
	0:style := "rich";
	1:style := "warrior";
	2:style := "mage";
	endcase
	var parms := {};
	parms[1]:= me;
	parms[2]:= style;
	start_script("::/misc/dressme", parms);
endif
	me.hidden := 0;
endif

var master;
var slave;

sleep(2);
QuestieSetup();

function QuestieSetup()

	me.graphic := 400+me.gender;

	master := 0;
	slave := 0;

	if (getobjproperty(me,"master"))
		master := systemfindobjectbyserial(getobjproperty(me,"master"));
		if (!master)
			setobjproperty(me,"guardkill",1);
			MoveObjectToLocation(me,4550, 3687  , 0, realm := _DEFAULT_REALM, flags := MOVEOBJECT_FORCELOCATION );
			KillMe ();
		endif
	else
		master := me;
	endif

	if (master.serial == me.serial)
		if (getobjproperty(me,"slave"))
			slave := systemfindobjectbyserial(getobjproperty(me,"slave"));
		endif
		if ( getobjproperty(me,"questtype") )
			questtype := getobjproperty(me,"questtype");
			if ( (questtype == 2) and (!Slave) )
				setobjproperty(me,"guardkill",1);
				MoveObjectToLocation(me,4550, 3687  , 0,realm := _DEFAULT_REALM, flags := MOVEOBJECT_FORCELOCATION );
				KillMe ();
			endif
		else
			questtype := randomint(2)+1;
			setobjproperty(me,"questtype",questtype);
		endif
		case (questtype)
			1: 
				if (!slave)	slave := MakeSlave(); endif
				SetupMailboy();
			2:
				if (!SlavesExist()) MakeMonsterSlaves(); endif
		endcase
	endif

	setobjproperty(me,"master",master.serial);

endfunction

function SetupMailboy()

	foreach item in enumerateitemsincontainer(me.backpack)
		if ( (getobjproperty(item,"slave")) and (getobjproperty(item,"slave") != slave.serial) )
			DestroyItem(item);
		endif
	endforeach

	foreach item in enumerateitemsincontainer(me.backpack)
		if ( getobjproperty(item,"slave") == slave.serial )
			return;
		endif
	endforeach

	CreateQuestItem(me.backpack,slave.serial);

endfunction

function CreateQuestItem(mypack,slaveserial)

	var itemcfg := ReadConfigFile( ":townfolk:questitems" );
     	var itemfile := FindConfigElem( itemcfg, 1 );
	var itemlist := GetConfigStringArray( itemfile, "Item" );
	var item := 0;
	if (!len(itemlist))
		return;
	endif

	repeat
		var itemobjtype := itemlist[RandomInt(len(itemlist))+1];
		item := CreateItemInContainer(mypack,cint(itemobjtype));
	until (item);
	SetObjProperty(item,"slave",slaveserial);
	item.movable := 1;
	return item;

endfunction

function MakeSlave()

	var newslave;

	var slavetown;
	var x1, y1, x2, y2, x, y, z;

	repeat
	case ( RandomInt(30) )
	0:
	1:
	2:
		slavetown := "Moonglow";
		x1 := 4379;
		y1 := 1045;
		x2 := 4487;
		y2 := 1178;
	3:
	4:
	5:
	6:
		slavetown := "Britain";
		x1 := 1244;
		y1 := 1530;
		x2 := 1704;
		y2 := 1758;
	7:
	8:
	9:
		slavetown := "Jhelom";
		x1 := 1294;
		y1 := 3664;
		x2 := 1506;
		y2 := 3886;
	10:
	11:
	12:
		slavetown := "Yew";
		x1 := 494;
		y1 := 926;
		x2 := 600;
		y2 := 1034;
	13:
	14:
	15:
		slavetown := "Minoc";
		x1 := 2394;
		y1 := 370;
		x2 := 2624;
		y2 := 632;
	16:
	17:
	18:
		slavetown := "Trinsic";
		x1 := 1794;
		y1 := 2638;
		x2 := 2136;
		y2 := 2902;
	19:
	20:
	21:
		slavetown := "Skara Brae";
		x1 := 538;
		y1 := 2106;
		x2 := 686;
		y2 := 2274;
	22:
	23:
	24:
		slavetown := "Magincia";
		x1 := 3646;
		y1 := 2040;
		x2 := 3814;
		y2 := 2280;
	25:
		slavetown := "Occlo";
		x1 := 3588;
		y1 := 2446;
		x2 := 3762;
		y2 := 2690;
	26:
		slavetown := "Nujelm";
		x1 := 3496;
		y1 := 1062;
		x2 := 3808;
		y2 := 1400;
	27:
	28:
	29:
		slavetown := "Vesper";
		x1 := 2794;
		y1 := 634;
		x2 := 3062;
		y2 := 1000;
	30:
		slavetown := "Cove";
		x1 := 2206;
		y1 := 1116;
		x2 := 2290;
		y2 := 1236;
	endcase
	x := RandomInt(x2-x1)+x1;
	y := RandomInt(y2-y1)+y1;
	z := GetMapInfo(x,y).z;
	set_critical(1);
	newslave := CreateNPCfromtemplate(":townfolk:questie",x,y,z,0);
//	newslave := CreateNPCfromtemplate(":townfolk:questie",me.x,me.y,me.z,0);

	setobjproperty(newslave,"master",me.serial);
	set_critical(0);
	until (newslave);

	setobjproperty(me,"slave",newslave.serial);
	setobjproperty(me,"slavetown",slavetown);

	return newslave;

endfunction

function WhatTown(who)

	if (!who)
		return;
	endif

	var x := who.x;
	var y := who.y;
	var town;
	var x1, y1, x2, y2;

	town := "Moonglow";
	x1 := 4379;
	y1 := 1045;
	x1 := 4487;
	y2 := 1178;
	if (x >= x1 and x <= x2 and y >= y1 and y <= y2)
		return town;
	endif

	town := "Britain";
	x1 := 1244;
	y1 := 1530;
	x2 := 1704;
	y2 := 1758;
	if (x >= x1 and x <= x2 and y >= y1 and y <= y2)
		return town;
	endif

	town := "Jhelom";
	x1 := 1294;
	y1 := 3664;
	x2 := 1506;
	y2 := 3886;
	if (x >= x1 and x <= x2 and y >= y1 and y <= y2)
		return town;
	endif

	town := "Yew";
	x1 := 494;
	y1 := 926;
	x2 := 600;
	y2 := 1034;
	if (x >= x1 and x <= x2 and y >= y1 and y <= y2)
		return town;
	endif

	town := "Minoc";
	x1 := 2394;
	y1 := 370;
	x2 := 2624;
	y2 := 632;
	if (x >= x1 and x <= x2 and y >= y1 and y <= y2)
		return town;
	endif

	town := "Trinsic";
	x1 := 1794;
	y1 := 2638;
	x2 := 2136;
	y2 := 2902;
	if (x >= x1 and x <= x2 and y >= y1 and y <= y2)
		return town;
	endif

	town := "Skara Brae";
	x1 := 538;
	y1 := 2106;
	x2 := 686;
	y2 := 2274;
	if (x >= x1 and x <= x2 and y >= y1 and y <= y2)
		return town;
	endif

	town := "Magincia";
	x1 := 3646;
	y1 := 2040;
	x2 := 3814;
	y2 := 2280;
	if (x >= x1 and x <= x2 and y >= y1 and y <= y2)
		return town;
	endif

	town := "Occlo";
	x1 := 3588;
	y1 := 2446;
	x2 := 3762;
	y2 := 2690;
	if (x >= x1 and x <= x2 and y >= y1 and y <= y2)
		return town;
	endif

	town := "Nujelm";
	x1 := 3496;
	y1 := 1062;
	x2 := 3808;
	y2 := 1400;
	if (x >= x1 and x <= x2 and y >= y1 and y <= y2)
		return town;
	endif

	town := "Vesper";
	x1 := 2794;
	y1 := 634;
	x2 := 3062;
	y2 := 1000;
	if (x >= x1 and x <= x2 and y >= y1 and y <= y2)
		return town;
	endif

	town := "Cove";
	x1 := 2206;
	y1 := 1116;
	x2 := 2290;
	y2 := 1236;
	if (x >= x1 and x <= x2 and y >= y1 and y <= y2)
		return town;
	endif

	return;

endfunction

function SlavesExist()

	if (!slave) return 0; endif

	foreach item in EnumerateItemsInContainer(slave.backpack)
		if ( getobjproperty(item,"master") == me.serial )
			var otherslave := systemfindobjectbyserial( GetObjProperty(item,"otherslave") );
			if (!otherslave) return 0; endif
			foreach it in EnumerateItemsInContainer(otherslave.backpack)
				if ( getobjproperty(it,"master") == me.serial )
					return 1;
				endif
			endforeach
			return 0;
		endif
	endforeach

	return 0;

endfunction

function MakeMonsterSlaves()

	var slave_one := randommonsterslave();
	var slave_two := randommonsterslave();
	var questitem_one := CreateQuestItem(me.backpack,me.serial);
	var questitem_two := CreateQuestItem(me.backpack,me.serial);
	setobjproperty( questitem_one,"master",me.serial);
	setobjproperty( questitem_one,"otherslave",slave_two.serial);
	setobjproperty( me, "slave", slave_one.serial);
	setobjproperty( questitem_two,"master",me.serial);

	questitem_one.name := me.name + "'s " + TruncateArticle( questitem_one.desc );
	questitem_two.name := me.name + "'s " + TruncateArticle( questitem_two.desc );

	if (!slave_one.backpack) sleep(2); endif

	MoveItemToContainer( questitem_one, slave_one.backpack );
	MoveItemToContainer( questitem_two, slave_two.backpack );

	slave := slave_one;
	setobjproperty(me,"slave",slave.serial);

endfunction

function randommonsterslave()

	var dungeonname, regionnum;
	case (randomint(9))
		0:
			dungeonname := "cavern of Despise";
			regionnum := 44;
		1:
			dungeonname := "deep Destard";
			regionnum := 57;
		2:
			dungeonname := "lowest Covetous";
			regionnum := 47;
		3:
			dungeonname := "the bottom of Hythloth";
			regionnum := 62;
		4:
			dungeonname := "the catecombs of Fire Dungeon";
			regionnum := 67;
		5:
			dungeonname := "darkest Deceit";
			regionnum := 63;
		6:
			dungeonname := "the bottom of Shame";
			regionnum := 52;
		7:
			dungeonname := "the park in Wind";
			regionnum := 106;
		8:
			dungeonname := "Buccaneer's Den";
			regionnum := 36;
	endcase

	var cfg := ReadConfigFile(":regionalspawner:regionspawn");
     	var spawnregion := FindConfigElem( cfg, regionnum );
//	var spawngroups := GetConfigStringArray( spawnregion, "group" );
//	var spawngroup := "questtargets";
//	var groupstring := splitwords(spawngroup);
	var groupname := "questtargets";

	var coords := splitwords(spawnregion.rect);
	var x1 := cint(coords[1]);
	var y1 := cint(coords[2]);
	var x2 := cint(coords[3]);
	var y2 := cint(coords[4]);

	var groupelem := FindConfigElem( cfg, groupname );
	var critterlist := GetConfigStringArray( groupelem, "npc" );

	var critnum;
	var thecritter;
	var x;
	var y;
	var z;	
	var i;
	var tries;
	var info;

	critnum := RandomInt(len(critterlist))+1;
	thecritter := 0;
	tries := 0;
	repeat
		x := RandomInt (x2-x1)+x1;
		y := RandomInt (y2-y1)+y1;
		z := GetMapInfo(x,y).z;
		tries := tries +1;

		info := hex(GetMapInfo( x , y ).landtile);
		if ((info < 0x406) or (info > 0x455))
			thecritter := createnpcfromtemplate(CSTR(critterlist[critnum]),x,y,z);
			if (thecritter)
				if (!MoveObjectToLocation(thecritter, thecritter.x,
					 thecritter.y, z,0) )
					KillIt(thecritter);
				endif
			endif
		endif
	until (thecritter) or (tries > 50);

	if (thecritter)
		setobjproperty(thecritter,"dungeon",dungeonname);
		return thecritter; 
	else
		return 0;
	endif

endfunction

function KillIt(critter)

	MoveObjectToLocation(critter,4550, 3687  , 0,realm := _DEFAULT_REALM, flags := MOVEOBJECT_FORCELOCATION );
	SetObjProperty(critter,"guardkill",1);
	applyrawdamage( critter, getvital(critter,"Life") + 100 );

endfunction

function MakeMagic( objname, item )

	var parms := { };
	parms[1] := objname;
	parms[2] := item;

	start_script(":magicitems:createmagicitem", parms);

endfunction
