include "include/magic";

var nextbuffcheck := ReadGameClock();
var nextdraincheck := 0;
var mymagery := 100;


/////////////////////////////////////////
// CastTheSpell is called with the spellid and spell parms after which it will check skill,
// consume mana, consume reagents and adds casting delay and lets the henchman preform 
// casting animations
/////////////////////////////////////////

function CastTheSpell (byref spellid, byref parms)
	mymagery := GetAttribute(me, ATTRIBUTEID_MAGERY);
	var circle := spellcfg[spellid].circle;
	var current_spell := FindConfigelem (spellcfg, spellid);

	SpeakPowerWords (me, spellid); //starting to cast

	//can they cast the spell?
	if (!CastSpellskillcheck (circle))
		Fizzle(me);
		return 0;
	endif
	if (!FreeHands (me))
		return 0;
	endif

	if(!TakeTheReagents (current_spell))
		HenchieSay ("I'm out of reagents!");
		castwatch := ReadGameClock() + 10; //no point in casting spells now
		if(allowedtoswitch)
			ChangeWeapons(); //equip anything as long as it's a weapon
		endif
		return 0;
	endif

	if (!ConsumeSpellManaCost (me, circle))
		HenchieSay ("I'm out of mana!");
		castwatch := ReadGameClock() + 10; //lets give the script some time to regain mana
		if(allowedtoswitch)
			ChangeWeapons(); //equip anything as long as it's a weapon
		endif
		return 0;
	endif

	//lets get some animations and at the same time create the cast delay and the keep the henchman to busy to move	
	var i;
	var spelldelay := CINT((1500 + (500 * (circle - 1)))/1000);
	for (i := 1; i <= spelldelay; i := i + 1)
		PerformAction (me, ANIM_CAST_DIR);
		spelldelay := spelldelay - 1;
		sleep(1);
	endfor	
	castwatch := ReadGameClock() + 2;
	return run_script_to_completion (spellcfg[spellid].script, parms);
endfunction

/////////////////////////////////////////////////
// Takereagents will call consume all the reagents that are needed for a spell
// if not all reagents are found then it returns 0
////////////////////////////////////////////////

function TakeTheReagents (byref current_spell)
	var reagents := GetConfigStringArray (current_spell, "reagent");
	foreach reagent in reagents
		if (!ConsumeSubstanceIsBroken(GetObjtypeByName( reagent )))
			return 0;
		endif
	endforeach
	return 1;
endfunction

///////////////////////////////////////////////////////
// ConsumeSubstanceIsBroken removes a specific reagent from anywhere in the character's
// backpack, this function is primarly only called by 'TakeTheReagents'
///////////////////////////////////////////////////////

function ConsumeSubstanceIsBroken (byref what)
	var mystuff := 0;
	foreach item in EnumerateItemsInContainer (me.backpack)
		if ( item.objtype == what)
			mystuff := item;
			break;
		endif
	endforeach
	if (!mystuff)
		return 0;
	else
		SubtractAmount(mystuff,1);
		return 1;
	endif
endfunction

////////////////////////////////////////////////
// this function does a magery check to see if you have enough skill to cast a spell, though
// it isn't 100% correct it comes really close to it which makes it just as good
////////////////////////////////////////////////

function CastSpellskillcheck (byref circle)
	var neededskill := CINT(20 + ((circle - 1) * 11));//this is correct, give or take a few points ;)
	if(!CheckSkill (me, SKILLID_MAGERY, neededskill, 0))
		return 0;
	endif
	return 1;
endfunction

/////////////////////////////////////////////////
// Prepareforcombat makes sure that the user always has magic reflect and reactive armor on
// if it has enough mana and reagents that is
/////////////////////////////////////////////////

function PrepareforCombat()
	if(HasMageWeapon() && GetVital(me, "Mana") > 150)
	if(!GetObjProperty(me, "mr"))
		return CastTheSpell (36, {"#MOB", me, me});
	elseif(!GetObjProperty(me, "#reactive_armor"))
		return CastTheSpell (7, {"#MOB", me, me});
	endif
	endif
	return 0;
endfunction

////////////////////////////////////////////////
// henchman meditation, basicly the same as normal meditation but placed in 1 function to avoid
// the script from calling more then 1 meditations at a time (which was almost instant recharge)
////////////////////////////////////////////////

function DoMeditate()
//	if(meditate)
		HenchieSay("*meditates*");
		var circle := 6;
		foreach item in ListEquippedItems(me)
		if ((armorcfgfile[item.objtype].blockcircle) && (armorcfgfile[item.objtype].blockcircle < circle)) 
			if(GetObjProperty (me, "#medspam") > ReadGameClock())
				HenchieSay("Aargh, how am I supposed to meditate with all this metal!");
				SetObjProperty (me, "#medspam", ReadGameClock()+3);
				return 0;
			endif
		endif
		endforeach

		if (GetVital (me, "mana") >= GetVitalMaximumValue (me, "mana"))
			return 1;
		endif
	
		var hp := GetVital (me, "Life");
		var mana := GetVital (me, "mana");
		var diff := CINT ((GetVitalMaximumValue (me, "mana") - GetVital (me, "mana"))/100);

		var scaled_diff := 110 - CINT ((GetVital (me, "Mana") * 100)/GetVitalMaximumValue (me, "Mana"));
		if (scaled_diff < diff)
			diff := scaled_diff;
		endif
	
		if ( diff > 100 )
			diff := 100;
		elseif (diff < 1)
			diff := 0;
		endif

		PlaySoundEffect (me, 0xf8);
		sleep (3);

		if (GetVital (me, "Life") < hp || (GetVital (me, "mana") < mana) )
			HenchieSay("Aargh, I failed!");
			SetVital (me, "Mana", CINT(GetVital (me, "Mana") + 500)); //each attempt does give them 5 mana so they won't get stuck in a can't ever med loop.
			PlaySoundEffect (me, 0xf6);
			return 0;
		elseif(GetVital (me, "mana") >= GetVitalMaximumValue (me, "mana"))
			PlaySoundEffect (me, 0xf6);
			return 1;
		endif

		//take their max skill of evalint, necromancy, and druidic magic
		var evalint_skill := GetAttribute (me, ATTRIBUTEID_INVOCATION);
		var avgskill := CINT((GetAttribute (me, ATTRIBUTEID_MEDITATION) + GetAttribute (me, ATTRIBUTEID_MAGERY) + evalint_skill)/3);

		var rate := 2;
		If ( avgskill > 95)
			rate := 6;
		elseif ( avgskill > 80)
			rate := 4;
		endif

		if (CheckSkill (me, SKILLID_MEDITATION, diff, 0) )
			SetVital (me, "Mana", GetVital (me, "Mana") + 300*rate);
			if (GetVital (me, "Mana") > GetVitalMaximumValue (me, "Mana"))
				SetVital (me, "Mana", GetVitalMaximumValue (me, "Mana"));
				PlaySoundEffect (me, 0xf6);
				return 1;
			endif
			PlaySoundEffect (me, 0xfa);
		
			repeat
				SetVital (me, "Mana", GetVital (me, "Mana") + 100*rate);
				if (GetVital (me, "Mana") >= GetVitalMaximumValue (me, "Mana"))
					SetVital (me, "Mana", GetVitalMaximumValue (me, "Mana"));
					DisplayMed(100);
					PlaySoundEffect (me, 0xf6);
					return 1;
				else
					DisplayMed(CINT((GetVital (me, "Mana")*100) / GetVitalMaximumValue (me, "Mana")));
				endif
				sleep (1);
			until (GetVital (me, "Life") < hp);

			if (GetVital (me, "Mana") > GetVitalMaximumValue (me, "Mana"))
				SetVital (me, "Mana", GetVitalMaximumValue (me, "Mana"));
			endif	
			PlaySoundEffect (me, 0xf6);
		else
			HenchieSay("Aargh, I failed!");
			SetVital (me, "Mana", CINT(GetVital (me, "Mana") + 500)); //each attempt does give them 5 mana so they won't get stuck in a can't ever med loop.
		endif
//	endif
	return 0;
endfunction

//////////////////////////////////////////////////////
// CheckMageBuff will check to see if a buff spell is missing, if so it will cast that spell
// if reagent and mana allow it that is, this is best to be called when not fighting!
//////////////////////////////////////////////////////

function CheckMageBuff( forcebuff := 0)
	mymagery := GetAttribute(me, ATTRIBUTEID_MAGERY);
	if(nextbuffcheck > readgameclock() && !forcebuff)
		return 0;
	endif
	if(!CheckIfSpecialized (mymaster, SKILLID_MAGERY))
		return 0;
	endif 

	Set_Critical(1);
	var currentmods := GetObjProperty (me, "#mods");
	if (!currentmods)
		currentmods := { };
	endif

	var bufftypes := {};
	var medamount := 900;
	if(GetAttribute(me, ATTRIBUTEID_MAGERY) >= 31 && GetVitalMaximumValue(me, "Mana") >= 900)
		bufftypes.append("ar");
		bufftypes.append("str");
		bufftypes.append("int");
		bufftypes.append("dex");
	endif
	if(GetAttribute(me, ATTRIBUTEID_MAGERY) >= 42 && GetVitalMaximumValue(me, "Mana") >= 1000)
		bufftypes.append("all");
		medamount := 1000;
	endif
	if(GetAttribute(me, ATTRIBUTEID_MAGERY) >= 86 && GetVitalMaximumValue(me, "Mana") >= 4100)
		bufftypes.append("poly");
		medamount := 4100;
	endif

	var oldweapon_one;
	var oldweapon_two;
	var rearmBuffer := 0;

	if(!Freehands(me) && (buffoption == 2 || forcebuff))
		oldweapon_one := GetEquipmentByLayer (me, LAYER_HAND1);
		oldweapon_two := GetEquipmentByLayer (me, LAYER_HAND2);
		if (oldweapon_one)
			MoveItemToContainer (oldweapon_one, me.backpack);//makes the unequip script run!
		endif
		if (oldweapon_two)
			MoveItemToContainer (oldweapon_two, me.backpack);//makes the unequip script run!
		endif
		rearmBuffer := 1;
	endif
	

	var found := 0;
	var gotspam := 1;
	if(medamount <= GetVitalMaximumValue(me, "Mana")/2)
		medamount := GetVitalMaximumValue(me, "Mana")/2; //lets med before we reach the minimum needed amount, easier to start a med that way
	endif

	foreach buff in bufftypes
		found := 0;
		foreach mmod in currentmods //buffs from spells
			if(mmod[1] == buff)
				found := 1;
				break;
			endif
		endforeach

			

		if(GetVital(me, "Mana") <= medamount && meditate >= 1)
			DoMeditate();
		endif

		if(!found)
			if(gotspam)
				if(buffoption == 1 && !forcebuff)
					if (mymaster.gender)
						HenchieSay ("Ma'am, I am not buffed!");
					else
						HenchieSay ("Sir, I am not buffed!");
					endif
					nextbuffcheck := ReadGameClock() + 60;
					return 1;
				elseif(!forcebuff)
					HenchieSay ("Hold on, I need to buff");
				endif
				gotspam := 0;
			endif

			if(buff == "ar")
				if(GetVital(me, "Mana") >= 700)
					found := CastTheSpell (15, {"#MOB", me, me});
					sleep(2);
				else
					found := 2;
				endif
			elseif(buff == "str")
				if(GetVital(me, "Mana") >= 700)
					found := CastTheSpell (16, {"#MOB", me, me});
					sleep(2);
				else
					found := 2;
				endif
			elseif(buff == "int")
				if(GetVital(me, "Mana") >= 700)
					found := CastTheSpell (10, {"#MOB", me, me});
					sleep(2);
				else
					found := 2;
				endif
			elseif(buff == "dex")
				if(GetVital(me, "Mana") >= 700)
					found := CastTheSpell (9, {"#MOB", me, me});
					sleep(2);
				else
					found := 2;
				endif
			elseif(buff == "poly")
				if(GetVital(me, "Mana") >= 4100)
					SpeakPowerWords (me, 56); //starting to cast
					if (CastSpellskillcheck (7))
						if(TakeTheReagents ( FindConfigelem (spellcfg, 56)))
							var i;
							var spelldelay := CINT((4500)/1000);
							for (i := 1; i <= spelldelay; i := i + 1)
								PerformAction (me, ANIM_CAST_DIR);
								spelldelay := spelldelay - 1;
								sleep(1);
							endfor	
							caster_magery := GetAttribute (me, ATTRIBUTEID_MAGERY);
							caster_evalint := GetAttribute (me, ATTRIBUTEID_INVOCATION);
							var Critgroup;
							if (caster_magery < 70)
								Critgroup := Random(1);
							elseif (caster_magery < 80)
								Critgroup := Random(1)+1;
							elseif (caster_magery < 90)
								Critgroup := Random(1)+2;
							else
								Critgroup := 3;
							endif
	
							var critter := Random(8);
							var newcolor := 1401+(critgroup*10)+critter;
	
							var caster_med := GetAttribute (me, ATTRIBUTEID_MEDITATION);
	
							var mod_amount := (critgroup*3)+critter;
							if ( (caster_magery + caster_med + caster_evalint) > (80 * 3) ) 
								mod_amount := mod_amount * 2;
							endif

							var duration := GetModDuration (caster_magery )*4;
							DoTempMod (me, "poly", mod_amount, duration);
							DoPersistedMod (me, "color", newcolor, me.color, duration);
							found := 1;
							sleep(2);
						else
							found := 0;
							HenchieSay ("I'm out of reagents!");
						endif
					else
						found := 2;
						Fizzle(me);
					endif
				else
					found := 2;
				endif
			elseif(buff == "all")
				if(GetVital(me, "Mana") >= 1000)
					found := CastTheSpell (17, {"#MOB", me, me});
					sleep(2);
				else
					found := 2;
				endif
			endif
			if(!found)
				Set_Critical(0);
				nextbuffcheck := ReadGameClock() + 60; //give the players time to recover from the spam
				if(rearmBuffer)
					if(oldweapon_one)
						ItemEquip ( oldweapon_one );
					endif
					if(oldweapon_two)
						ItemEquip ( oldweapon_two );
					endif
				endif
				return 0;
			elseif(found == 2)
				HenchieSay ("Doh, not enough mana to buff!");
				if(meditate >= 1)
					nextbuffcheck := ReadGameClock() + 5;
				else
					nextbuffcheck := ReadGameClock() + 60;
				endif
				if(rearmBuffer)
					if(oldweapon_one)
						ItemEquip ( oldweapon_one );
					endif
					if(oldweapon_two)
						ItemEquip ( oldweapon_two );
					endif
				endif
				return 0; //couldn't cast the spell because there was too little mana
			endif
		endif
	endforeach
	PrepareforCombat();
	Set_Critical(0);
	nextbuffcheck := ReadGameClock() + 45; //It saves serverload and I doubt those 30 seconds of none buffness will cause much death.
	if(rearmBuffer)
		if(oldweapon_one)
			ItemEquip ( oldweapon_one );
		endif
		if(oldweapon_two)
			ItemEquip ( oldweapon_two );
		endif
	endif
	return 1;
endfunction

/////////////////////////////////////////////
// DoCombatCasting selects which spell should be used during combat, this has been made as 
// random as possible but it has a few preferences at times
// no spells are casted unless there is a 50% chance of 'not fialing' the cast
/////////////////////////////////////////////

function DoCombatCasting(byref opponent)
	if(castwatch > ReadGameClock() || !HasMageWeapon())
		return 0;
	endif

	mymagery := GetAttribute(me, ATTRIBUTEID_MAGERY);
	var selected_spells := getObjProperty(me, "virtueskillssetup");
	if(!selected_spells)
		selected_spells := dictionary;
		selected_spells[5] := 1;
	endif

	//lets check for magic reflect, not too often though ;)
	if(!random(2) && GetObjProperty(opponent,"mr"))
		return CastTheSpell (5, {"#MOB", me, opponent}); //magic arrow
	elseif(!random(15) && !GetObjProperty(me,"mr")) //it's good to reflect spells, it saves you mana compared with a direct spell AND it saves health
		return CastTheSpell (36, {"#MOB", me, me});
	elseif (!GetObjProperty(me, "#reactive_armor") && !random(25))
		return CastTheSpell (7, {"#MOB", me, me}); //not really what most players want to focus on so it doesn't happen often
	endif

	if(!nextdraincheck) //We need to cast spells between drains or we'll never do any damage if we are unlucky
		//now we check for mana supplies and drain the opponent if it needs to (though it doesn't happen always so the henchman aren't uber mages)
		if((GetVital(opponent, "Mana") > (GetVitalMaximumValue(opponent, "Mana")/3)) && !random(5) && (GetAttribute(opponent, ATTRIBUTEID_MAGERY) > 53) && (GetVital(me, "Mana") >= 1600) && selected_spells[31] == 1) //if the opponent has mana drain it!
			//lets check if we can even try
			var diff := (GetAttribute (me, "Intelligence") - GetAttribute (opponent, "Intelligence"));
			if (diff > 40)
				diff := 40;
			elseif (diff < (0-40))
				diff := (0-40);
			endif

			if (opponent.npctemplate)
				diff := diff + CINT (GetAttribute (me, ATTRIBUTEID_MEDITATION)/3);
			endif

			diff := Resisted (me, opponent, diff);
			if( diff > CINT (GetVital (opponent, "Mana")/100))
				diff := CINT (GetVital (opponent, "Mana")/100);
			endif

			if ( diff > 0 )
				if(mymagery >= 86 && (GetVital (me, "Mana") >= 4000) && (GetVital (opponent, "Mana") > 4000) && selected_spells[53] == 1) //chance of casting mana vamp, lets do it even if there is a small risk of failing
					nextdraincheck := 2;
					return CastTheSpell (53, {"#MOB", me, opponent}); //manavamp
				elseif(mymagery >= 53) //ok, we can cast manadrain, lets do it!
					nextdraincheck := 2;
					return CastTheSpell (31, {"#MOB", me, opponent}); //manadrain
				endif
			endif
		elseif((mymagery >= 86) && ((GetVital (me, "Mana") < GetVitalMaximumValue(me, "Mana")) && GetVital (opponent, "Mana") > 4500) && (GetVital (me, "Mana") >= 4000) && !random(3) && selected_spells[53] == 1) //we need to drain if possible
			//lets check if we can even try
			var diff := (GetAttribute (me, "Intelligence") - GetAttribute (opponent, "Intelligence"));
			if (diff > 40)
				diff := 40;
			elseif (diff < (0-40))
				diff := (0-40);
			endif

			if (opponent.npctemplate)
				diff := diff + CINT (GetAttribute (me, ATTRIBUTEID_MEDITATION)/3);
			endif

			diff := Resisted (me, opponent, diff);
			if( diff > CINT (GetVital (opponent, "Mana")/100))
				diff := CINT (GetVital (opponent, "Mana")/100);
			endif

			if ( diff > 0 )
				nextdraincheck := 1;
				return CastTheSpell (53, {"#MOB", me, opponent}); //manavamp
			endif
		endif
	else
		nextdraincheck := nextdraincheck - 1;
	endif

	//if it's summoned dispel it if skill and random are true
	if(GetObjProperty(opponent, "summoned") && (mymagery >= 75) && !random(6) && (GetVital (me, "Mana") >= 250))
		return CastTheSpell (41, {"#MOB", me, opponent}); //dispel
	endif

	var spellknowledge := 8;
	if(mymagery >= 97 && (GetVital(me, "Mana") >= 5500))
		spellknowledge := 64;	
	elseif(mymagery >= 86 && (GetVital(me, "Mana") >= 4500))
		spellknowledge := 55;		
	elseif(mymagery >= 75 && (GetVital(me, "Mana") >= 2500))
		spellknowledge := 47;
	elseif(mymagery >= 64 && (GetVital(me, "Mana") >= 1900))
		spellknowledge := 40;
	elseif(mymagery >= 53 && (GetVital(me, "Mana") >= 1600))
		spellknowledge := 31;
	elseif(mymagery >= 42 && (GetVital(me, "Mana") >= 1300))
		spellknowledge := 24;
	elseif(mymagery >= 31 && (GetVital(me, "Mana") >= 900))
		spellknowledge := 13;
	elseif(GetVital(me, "Mana") < 400)
		return 0; //not enough mana to cast anything
	endif

	var castable_direct_spells := array;
	var castable_spells := array;
	for i := 1 to spellknowledge
		if(selected_spells[i] == 1)
			case(i)
				1: //clumsy
				3: //Feeblemind
				8: //Weaken
				27: //Curse
				28: //fire field
				37: //mind blast
				38: //Paralyze
				39: //poison field
				31: //manadrain
				33: //blade spirit
				40: //creature
				43: //explosion
				46: //mass curse
				47: //paralize field
				49: //chain lightning
				50: //energy field
				53: //mana vampire
				55: //meteor swarm
				57: //earthquake
				58: //vortex
				60: //air
				61: //deamon
				62: //earth
				63: //fire 
				64: //water
					castable_spells.append(i);					
				default:
					castable_spells.append(i);
					castable_direct_spells.append(i);
			endcase
		endif
	endfor

	selected_spells := 0;

	if(len(castable_spells)) //We have some spells that we can cast
		selected_spells := castable_spells[random(len(castable_spells))+1]; //lets select one
		if(CastingCheck(selected_spells, opponent)) //check if friendlies could be hurt
			return CastTheSpell (selected_spells, {"#MOB", me, opponent});//nope, then fire away
		elseif(len(castable_direct_spells))
			return CastTheSpell (castable_direct_spells[random(len(castable_direct_spells))+1], {"#MOB", me, opponent}); //can we cast a no brainer?
		else
			return CastTheSpell (selected_spells, {"#MOB", me, opponent});//nope, then fire away
		endif
	else
		return CastTheSpell (5, {"#MOB", me, opponent});//no spells selected, default to magic arrow
	endif
	return 0; //the script shouldn't reach this spot
endfunction


function CastingCheck (spellid, mytarget)
	var range := 0;
	var friendlies := 0;
	var enemies := 0;	

	case (spellid)
		1: //clumsy
			if(CanMod (mytarget, "cdex"))
				return 1;
			endif
			return 0;
		3: //Feeblemind
			if(CanMod (mytarget, "cint"))
				return 1;
			endif
			return 0;
		8: //Weaken
			if(CanMod (mytarget, "cstr"))
				return 1;
			endif
			return 0;
		27: //Curse
			if(CanMod (mytarget, "call"))
				return 1;
			endif
			return 0;
		37:
			var my_int := GetAttribute (me, "Intelligence");
			var his_int := GetAttribute (mytarget, "Intelligence");
			if (his_int >= my_int)
				return 0;
			endif
			return 1;
		38: //Paralyze
			if(CanMod (mytarget, "p"))
				return 1;
			endif
			return 0;
		57: //earthquake
			range := CINT (mymagery/15);
			if(Distance(mytarget, me) <= range) //mytarget must be in hit range
				foreach mobile in ListMobilesNearLocationEx (me.x, me.y, me.z, range, 0x03)
					if( CheckLosAt (mobile, mytarget.x, mytarget.y, mytarget.z) )
						if((mobile.acctname || GetObjProperty(mobile, "master")) && (mytarget != mobile))
							friendlies := 1;
							break;
						endif
					endif
				endforeach
	
				if(friendlies) //we have friendlies in the area of effect range, lets cast a different spell instead of the same level
					return 0;
				else //let it rip
					return 1;
				endif
				return 0;	
			endif
		28: //fire field
		39: //poison field
		47: //paralize field
		50: //energy field
			var direction := GetFieldDirection (me, mytarget.x, mytarget.y);
			var i;
			for ( i := -2; i <= 2; i := i + 1 )
				if (direction == "ew")
					foreach mobile in ListMobilesNearLocationEx (mytarget.x + i, mytarget.y, mytarget.z, 0, LISTEX_FLAG_NORMAL + LISTEX_FLAG_HIDDEN)
						if((mobile.acctname || GetObjProperty(mobile, "master")) && (mytarget != mobile))
							return 0;
						endif
					endforeach
				else
					foreach mobile in ListMobilesNearLocationEx (mytarget.x, mytarget.y + i, mytarget.z, 0, LISTEX_FLAG_NORMAL + LISTEX_FLAG_HIDDEN)
						if((mobile.acctname || GetObjProperty(mobile, "master")) && (mytarget != mobile))
							return 0;
						endif
					endforeach
				endif
			endfor
			return 1;
		33: //blade spirit
		40: //creature
		58: //vortex
		60: //air
		61: //deamon
		62: //earth
		63: //fire 
		64: //water
			foreach mobile in ListMobilesNearLocation (me.x, me.y, me.z, 20)
				if(GetObjProperty(mobile, "master") == me.serial)
					friendlies := friendlies + GetSummonsCountOfNPC (mobile);
					if(mobile.npctemplate["daemon"])
						return 0;
					endif
				endif
			endforeach
	
			case(spellid)
				62:
					friendlies := friendlies + 12;
				58:
				60:
				63:
				64:
					friendlies := friendlies + 16;
				61:
					friendlies := friendlies + 26;
				default:
					friendlies := friendlies + 10;
			endcase

			var mymaxsummons := 24;
			if (mymagery >= 98)
				mymaxsummons := 32;
			endif
		
			if(friendlies > mymaxsummons)
				return 0;
			endif
			return 1;
		31:
		53: 
			return 0;
		43: //explosion
			range := 3;
			break;
		46: //mass curse
			range := 4;
			break;
		55: //meteor swarm
			range := 3;
			if (mymagery > 95)
				range := range + 1;
				if (GetAttribute (me, ATTRIBUTEID_INVOCATION) > 95)
					range := range + 1;
				endif
			endif
			break;
		49: //chain lightning
			range := CINT (mymagery/15);
			break;
	endcase

	if(range > 0)
		foreach mobile in ListMobilesNearLocationEx (mytarget.x, mytarget.y, mytarget.z, range, 0x03)
			if( CheckLosAt (mobile, mytarget.x, mytarget.y, mytarget.z) )
				if((mobile.acctname || GetObjProperty(mobile, "master")) && (mytarget != mobile))
					friendlies := 1;
					break;
				elseif(IsHostile (mobile))
					enemies := enemies + 1;
				endif
			endif
		endforeach
	
		if(friendlies) //we have friendlies in the area of effect range, lets cast a different spell instead of the same level
			return 0;
		elseif (enemies < 2) //no need to waste mana
			return 0;
		else //let it rip
			return 1;
		endif	
	endif
	return 1;
endfunction

///////////////////
//  determines if the warrior has a mageweapon equipped
///////////////////

function HasMageWeapon()
	if(usesmagery)
		if(GetAttribute(me, ATTRIBUTEID_MAGERY) < 20)
			HenchieSay("How am I supposed to cast anything with less then 20 magery???");
			HenchieSay("I think I'll stick with physical attacks until I learned something!");
			usesmagery := 0;
		endif
		if(Freehands(me))
			return 1;
		endif
	endif
	return 0;
endfunction

function DisplayMed(procent) 
	PrintTextAbovePrivate (me, CSTR(procent)+"%", mymaster, 0x03, 0x0063);
////////AOS version, might work later after I patched, currently it causes crashes....
//	// Done for an issue with NPC's dying before packet sent 
//	set_critical(1); 
//	if(procent <= 255) 
//		var pkt := "BF000B002201SSSSSSSSDD"; 
//		pkt["SSSSSSSS"] := FixSize((Hex(me.serial)-"0x"), (8-len(me.serial))); 
//		pkt["DD"] := Hex(procent)-"0x"; 
//		//print(pkt); 
//		SendPacket(mymaster, pkt); 
//	endif 
//	set_critical(0); 
//endfunction 
//
//function FixSize(byref value, fixamt) 
//	var i; 
//	for(i := 1; i <= CInt(fixamt); i := i+1) 
//		value := "0" + value; 
//	endfor 
endfunction 


function MageSetup ()
var layout := {
	"page 0",
	"resizepic 50 20 2620 290 370",
	"resizepic 325 20 2620 460 370",
	"text 70 34 40 0",
	"text 210 34 40 1",
	"text 70 54 40 2",
	"text 210 54 40 3",
	"text 70 74 40 4",
	"text 210 74 40 5",
	"text 70 94 40 6",
	"text 210 94 40 7",
	"text 70 114 40 8",
	"text 210 114 40 9",
	"text 70 134 40 10",
	"text 210 134 40 11",
	"gumppic 55 165 2621",
	"button 490 350 249 247 1 0 1"   //ok	
};

var data := {};
var bonuslvl := 0;
var nextlvl := 0;
var new_skill_list := dictionary;
var usable_skills := dictionary;
	
	var virtue := CINT(GetObjProperty(me, "mage_exp")); // how well are you as a warrior?	
	if(virtue && virtue >= 0)
		if ( virtue < 800 )
			bonuslvl := 0;
			nextlvl := 800;
		elseif ( virtue < 3200 )
			bonuslvl := 1;
			nextlvl := 3200;
		elseif ( virtue < 6400 )
			bonuslvl := 2;
			nextlvl := 6400;
		elseif ( virtue < 12800 )
			bonuslvl := 3;
			nextlvl := 12800;
		elseif ( virtue < 25600 )
			bonuslvl := 4;
			nextlvl := 25600;
		elseif ( virtue < 50000 )
			bonuslvl := 5;
			nextlvl := 50000;
		elseif ( virtue == 50000 )
			bonuslvl := "MAX"; // this is a thing of pure beauty, though very hard to reach if not impossible
			nextlvl := 50000;
		endif
	else
		bonuslvl := 0;
		nextlvl := 800;
	endif

//	var chance := 0;
//	if (chance <= 0)
//		chance := 1; // there is always a chance
//	endif
//	var chancestring := CSTR(chance) + "%";	

	var manabonus := GetAttributeTemporaryMod( me, "Intelligence" )/10;
	if(!manabonus)
		manabonus := 0;
	endif

	var strbonus := GetAttributeTemporaryMod( me, "Strength" )/10;
	if(!strbonus)
		strbonus := 0;
	endif
	var dexbonus := GetAttributeTemporaryMod( me, "Dexterity" )/10;
	if(!dexbonus)
		dexbonus := 0;
	endif

	var armor := SetARMod();
	var arbonus := (me.ar_mod + 50) - armor;
	if(!arbonus)
		arbonus := 0;
	endif

	data := { // time to give the warrior some info about himself and his abilities
		"Mage Level :",  CSTR(bonuslvl), 
		"Next Level :", CSTR(virtue) + "/" + CSTR(nextlvl),
		"Intelligence (Bonus) :", CSTR(GetAttributeBaseValue (me, "Intelligence")/10) +" ("+CSTR(manabonus)+")",
		"Strength (Bonus) :", CSTR(GetAttributeBaseValue (me, "Strength")/10) +" ("+CSTR(strbonus)+")",
		"Agility (Bonus) :", CSTR(GetAttributeBaseValue (me, "Dexterity")/10) +" ("+CSTR(dexbonus)+")",
		"Armor (Bonus) :", CSTR(armor) +" ("+CSTR(arbonus)+")"
	};

	//now we free up some space for future use
	data.append (""); //12
	data.append (""); //13
	data.append (""); //14
	data.append (""); //15
	data.append (""); //16
	data.append (""); //17
	data.append (""); //18
	data.append (""); //19
	data.append (""); //20

	if (CINT (GetObjProperty (me, "#spellchoice")) > ReadGameClock())
		SendSysmessage (mymaster, "That gump is already open!");
		return;
	endif

	FillInSpells ( mymaster, data, layout, usable_skills);

	var gump_return := SendDialogGump (mymaster, layout, data);
	if (!gump_return && gump_return[0] != 0)
		SendSysMessage (mymaster, "You must close other gumps before you can do this.");
	endif

	if ( gump_return[1] != 1)
		HenchieSay("Ow well, Nevermind then");			
		EraseObjProperty (me, "#spellchoice");
		return 0;
	elseif ( gump_return[1] == 1)
		if (mymaster.gender)
			HenchieSay("I'll do as you ordered, Ma'am!");
		else
			HenchieSay("I'll do as you ordered, Sir!");
		endif

		//if ( gump_return[13] == 1)
		//	SetObjProperty(me, "buff_setting", "enable");
		//elseif ( gump_return[14] == 1)
		//	SetObjProperty(me, "buff_setting", "disable");
		//endif

		if( len(usable_skills.keys()))
			for counter := 21 to 84
				if ( gump_return[counter] == 1)
					new_skill_list[counter-20] := 1;
				else
					new_skill_list[counter-20] := 0;
				endif
			endfor
			setobjproperty (me, "virtueskillssetup",new_skill_list);
		endif
		EraseObjProperty (me, "#spellchoice");
		return 1;
	endif
	EraseObjProperty (me, "#spellschoice");
endfunction

function FillInSpells ( byref mymaster, byref data, byref layout, byref usable_skills)

	if ( !CheckIfSpecialized (mymaster, SKILLID_MAGERY) )
		PrintTextAbove (me, "*looks puzzled*");
		PrintTextAbove (me, "But you don't use magics?");
		return 0;
	endif
	var counter := 20;
	var foundbook := 0;

	foreach item in EnumerateItemsInContainer (me.backpack)
		if ( item.objtype == 0x0efa)
			foundbook := item;
			break;
		endif
	endforeach

	if(!foundbook)
		foreach item in ListEquippedItems( me );
			if ( item.objtype == 0x0efa)
				foundbook := item;
				break;
			endif
		endforeach
	endif

	if(!foundbook)
		layout.append ("text 350 34 40 21");
		data.append ("No spellbook!");
		return 1;
	endif

	foreach scroll in EnumerateItemsInContainer (foundbook)
		scroll := FindConfigElem (scrollcfgfile, scroll.objtype);		
		case(scroll.Spellid)
			1:
			3:	
			5:
			8:
			12:
			18:
			20:
			27:
			30:
			31:
			33: //blade spirit
			37:
			38:
			40: //creature
			42:
			43:
			46:
			49:
			51:
			53:
			55:
			57:
			58: //vortex
			60: //air
			61: //deamon
			62: //earth
			63: //fire 
			64: //water
				usable_skills[counter+CINT(scroll.Spellid)] := (CSTR(scroll.Desc) - "scroll");
		endcase
	endforeach

	if(!len(usable_skills.keys()))
		layout.append ("text 350 34 40 21");
		data.append ("No spells in the spellbook!");
		return 1;
	endif

	var skill_list := GetObjProperty( me , "virtueskillssetup" );
	var selected := 0;
	var ypos := 34;
	var xpos := 350;

	foreach spellnr in (usable_skills.keys())
		counter := counter + 1;
		layout.append ("text "+CSTR(xpos+20)+" " + ypos + " 40 " + counter);
		if (skill_list[spellnr-20] == 1)
			selected := 1;
		elseif (skill_list[spellnr-20] == 0)
			selected := 0;
		else
			selected := 0;
		endif

		layout.append ("checkbox "+CSTR(xpos)+" " + CSTR(ypos) + " " + CSTR(0x9ce) +" "+ CSTR(0x9cf) + " "+ CSTR(selected) +" " + spellnr);
		data.append (usable_skills[spellnr]);
		ypos:= ypos + 25;
		if(counter == 32 || counter == 44)
			xpos := xpos + 130;
			ypos := 34;
		endif
	endforeach
endfunction

function GetSummonsCountOfNPC (mob)
	var mobelem := GetNpcTemplateElem (mob.npctemplate);
	var mobstr := GetAttribute (mob, "Strength");
        var mobint := GetAttribute (mob, "Intelligence");
 
	//Summoned pets count for less
	if (GetObjProperty (mob, "summoned"))
		if (mobelem.script ["spell"] || mobelem.script["fire"] || mobelem.script["vampire"])
			if (mobstr >= 280 && mobint >= 280) // bloodlich, etc (added to limit uber undead)
				return 50;
			elseif (mobstr > 220 && mobint > 220) // lich lord, etc (added to limit uber undead)
				return 45;
			elseif (mobstr > 120 && mobint >= 120) // lich and sylvanguardian
				return 35;
                        elseif (mobstr > 180) // Daemon
                               return 26;
			elseif (mobstr > 120 && mobint < 120) // fire, water, air elementals
				return 16;
                        else
                                   return 12; // weak bone mage types
			endif
		elseif (mobstr > 180) // Golems
                       return 16;
                 elseif (mobstr > 120) // earth elementals
			return 12;
		else
			return 10;  // all the little stuff
		endif
	endif
endfunction