Const MAX_HENCHMEN_PER_ACCOUNT	:= 4;
Const MAX_HENCHMEN_AT_A_TIME	:= 2;
use uo;

include "include/client";
include "include/objtype";
include "include/dotempmods";
include "include/attributes";
include "include/myutil";
include "include/yesno";
include "include/myutil";
include "include/eventid";
include "include/sysevent";
include "../pkg/npcs/npc_util";
include "../pkg/npcs/npcinfo";
include "../pkg/npcs/speech";
include "../pkg/skills/warriorskills/healing/bandaid";


///////////////////
//  counts how many henchmen a particular account has
///////////////////

function AddToAccountHenchmen (mymasterserial)
	set_critical (1);
	var mymymaster := SystemFindObjectBySerial (mymasterserial, SYSFIND_SEARCH_OFFLINE_MOBILES );
	if (!mymymaster)
		set_critical(0);
		KillMe ();
		return;
	endif
	me.setmaster (mymymaster);
	me.title_race := mymymaster.name;

	var acctname := mymymaster.acctname;
	if (!acctname)
		set_critical (0);
		return 0;
	endif

	var henchmen := GetGlobalProperty ("#henchmen_of_"+acctname);
	if (!henchmen)
		henchmen := {};
	endif

	if (me.serial in henchmen)
		set_critical (0);
		return 1;
	endif
	henchmen.append (me.serial);
	SetGlobalProperty ("#henchmen_of_"+acctname, henchmen);
	set_critical(0);
	return 1;
endfunction




///////////////////
//  counts how many henchmen a particular account has
///////////////////

function CountAccountHenchmen (mymasterserial)
	var mymymaster := SystemFindObjectBySerial (mymasterserial, SYSFIND_SEARCH_OFFLINE_MOBILES );
	if (!mymymaster)
		return 0;
	endif

	var acctname := mymymaster.acctname;
	if (!acctname)
		return 0;
	endif

	var henchmen := GetGlobalProperty ("#henchmen_of_"+acctname);
	if (!henchmen)
		return 0;
	endif

	var newhenchmen := {};
	foreach henchserial in henchmen
		var thehenchman := SystemFindObjectBySerial (henchserial);
		if (thehenchman)
			newhenchmen.append (henchserial);
		endif
	endforeach
	SetGlobalProperty ("#henchmen_of_"+acctname, newhenchmen);
	return  (len (newhenchmen));
endfunction




///////////////////
//  counts the number of henchmen in the area that the player controls, and quits if there's too many
///////////////////

function AboveHenchCount (countme := 1)
	set_critical(1);
	var men := 0;
	foreach mobile in ListMobilesNearLocation (me.x, me.y, me.z, 8)
		if (mobile.script["henchman"])
			if (GetObjProperty (mobile, "master") == mymasterserial)
				if (GetObjProperty (mobile, "#following") )
					if (countme)
						men := men + 1;
					elseif (me != mobile)
						men := men + 1;
					endif
				endif
			endif
		endif
	endforeach
	set_critical(0);

	if (men > MAX_HENCHMEN_AT_A_TIME)
		return 1;
	else
		return 0;
	endif
endfunction




///////////////////
//  counts the number of henchmen in the area that the player controls, and quits if there's too many
///////////////////

function BelowHenchCount (countme := 1)
	set_critical(1);
	var men := 0;
	foreach mobile in ListMobilesNearLocation (me.x, me.y, me.z, 8)
		if (mobile.script == ":guards:henchman")
			if (GetObjProperty (mobile, "master") == mymasterserial)
				if (GetObjProperty (mobile, "#following") )
					if (countme)
						men := men + 1;
					elseif (me != mobile)
						men := men + 1;
					endif
				endif
			endif
		endif
	endforeach
	set_critical(0);

	if (men < MAX_HENCHMEN_AT_A_TIME)
		return 1;
	else
		return 0;
	endif
endfunction




///////////////////
//A bunch of different ways to say ok
///////////////////

function SayOkay()
	if ( random(5)!=1 )
		HenchieSay("Okay");
		return;
	endif

	var samegender := ( mymaster.gender == me.gender );
	var msg := "Okay";
	case ( random(24) )
	0: msg := "Yes, Oh great one";
	1: msg := "Your wish is my command";
	2: msg := "Whatever you say";
	3: msg := "Of course";
	4: msg := "As you wish";
	5: msg := "My pleasure";
	6: msg := "You bet";
	7: msg := "k";
	8: msg := "Sure thing";
	9: msg := "np";
	10: msg := "You da boss";
	11: msg := "Okay, but you can rez', right?";
	12: msg := "Surely";
	13: msg := "Alrighty";
	14: msg := "If you promise to keep me alive";
	15: 
		if ( mymaster.gender )
			msg := "Ma'am! Yes, Ma'am!";
		else
			msg := "Sir! Yes, Sir!";
		endif
	16: 
		if (!samegender )
			msg := "You are such a hottie";
		elseif (me.gender)
			msg := "Let's go find some cute guys";
		else
			msg := "Where do the chicks hang out?";
		endif
	17: msg := "I joined the army for THIS?";
	18: msg := "*mumble* bossy *mumble*";
	19: msg := "Uh... well, ok";
	20: msg := "If you think I should";
	21: msg := "Will do";
	22: msg := "Huh?  Oh.  Okay";
	23: 
		if ( mymaster.gender and !samegender )
			msg := "Yes, dear";
		elseif (!samegender)
			msg := "Sure, sweety";
		else
			msg := "Okay";
		endif
	default: msg := "Okay";
	endcase
	HenchieSay (msg);
endfunction




///////////////////
//  Attempts to resurrect the warrior
///////////////////

function ResurrectHenchman (byref corpse)
	set_critical (1);
	var mymaster_serial := GetObjProperty (corpse, "master");
	if (!mymaster_serial)
		set_critical (0);
		return 0;
	endif

	var mymymaster := SystemFindObjectBySerial (mymaster_serial, SYSFIND_SEARCH_OFFLINE_MOBILES );
	if (!mymymaster)
		set_critical(0);
		return 0;
	endif

	var soul_serial := GetObjProperty (corpse, "soul");
	var soulstone := SystemFindObjectBySerial (soul_serial);
	if(!soulstone)
		soulstone := SystemFindObjectBySerial (soul_serial, SYSFIND_SEARCH_OFFLINE_MOBILES );
	endif

	if(soulstone)
		var hinfo := GetObjProperty(soulstone, "info");
		var old_henchman_serial := hinfo[1];
		if(old_henchman_serial != GetObjProperty(corpse, "serial"))
			PrintTextAbove(corpse, "This henchman moved on");
			return 0;
		endif
	endif

	var parms := {};
	parms.+script := ":guards:henchman";
	if (GetObjProperty (corpse, "myscript") )
		parms.script := GetObjProperty (corpse, "myscript");
	endif

	var new_npc := CreateNPCFromTemplate (":guards:warrior", corpse.x, corpse.y, corpse.z, parms);
	if (!new_npc)
		set_critical(0);
		return 0;
	endif

	var newbackpack := CreateItemAtLocation (5288 , 1176 , 0, UOBJ_BACKPACK, 1);
	if (!EquipItem (new_npc, newbackpack))
		DestroyItem (newbackpack);
	endif

	SetObjProperty (new_npc, "master", mymymaster.serial);
	if(GetObjProperty (corpse, "combatvirtue"))
		if(GetObjProperty (corpse, "combatvirtue") <= GetObjProperty (mymymaster, "combatvirtue"))
			SetObjProperty (new_npc, "combatvirtue", GetObjProperty (corpse, "combatvirtue"));
		else
			SetObjProperty (new_npc, "combatvirtue", GetObjProperty (mymymaster, "combatvirtue"));
		endif
	else
		SetObjProperty (new_npc, "combatvirtue", 0);
	endif

	if(GetObjProperty (corpse, "mage_exp"))
		if(GetObjProperty (corpse, "mage_exp") <= GetObjProperty (mymymaster, "mage_exp"))
			SetObjProperty (new_npc, "mage_exp", GetObjProperty (corpse, "mage_exp"));
		else
			SetObjProperty (new_npc, "mage_exp", GetObjProperty (mymymaster, "mage_exp"));
		endif
	else
		SetObjProperty (new_npc, "mage_exp", 0);
	endif

	SetObjProperty (new_npc, "virtue", GetObjProperty (corpse, "virtue"));

	if(!GetObjProperty (corpse, "#lastdeath") || (GetObjProperty (corpse, "#lastdeath") <= ReadGameClock()))
		SetObjProperty(new_npc, "#lastdeath", ReadGameClock() + 3600);
		SetObjProperty(new_npc, "#takepoints", 1);		
	else
		SetObjProperty(new_npc, "#lastdeath", GetObjProperty (corpse, "#lastdeath"));
	endif

	SetObjProperty (new_npc, "soul", GetObjProperty (corpse, "soul"));
	SetVital (new_npc, "Life", 100);

	var temp_string := corpse.desc;
	temp_string["A corpse of "] := "";
	new_npc.name := temp_string;

	foreach item in ListRootItemsInContainer (corpse)
		if (!EquipItem (new_npc, item))
			MoveItemToContainer (item, new_npc.backpack);
		endif
	endforeach

//	RestartScript(new_npc);
	DestroyItem (corpse);
	set_critical (0);
	return 1;
endfunction

///////////////////
//  warrior tries to use a bandage or potion
///////////////////

function ApplyHenchmanHealing (byref who)
	if (GetObjProperty (me, "#heal") and GetObjProperty (me, "#heal") > readgameclock())
        	return 0;
	endif

	if (distance (me, who) > 2)
		HenchieSay (who.name + " is too far away!");
		return 0;
	endif

	if (who.poisoned or GetObjProperty(who, "iampoisoned"))

		var difficulty := 40 + GetPoisonLevel (who)*10;
		if (checkskill (me, SKILLID_HEALING, difficulty, 0))
			CurePoison (who, 0, who.name + " has CURED you!");
			if (who == me)
				HenchieSay ("*Whew!*  I'm cured!");
			endif
			SetObjProperty (me, "#heal", ReadGameClock() + 10);
			return 1;
		elseif (who == me)
			DrinkCure ();
		endif
	else
		EraseObjProperty (me, "#spammed");
	endif

	 var parms := { };
	 parms[1] := me;
	 parms[2] := who;

	foreach item in EnumerateItemsInContainer (me.backpack)
		if ( item.objtype == UOBJ_BANDAGE)
			 parms[3] := item;
			 start_script (":healing:dohealing",parms);

		//	start_script (":healing:bandageheal", parms);
			return 1;
		endif
	endforeach

	//this isn't needed for the healing script.  Instead it just makes the warrior shut up if
	//he's out of bandages and hurt
	SetObjProperty (me, "#heal", ReadGameClock() + 5);
	If (Random (10) == 9 )
		HenchieSay ("I don't have any bandages!");
	endif
	return 0;
endfunction

function ShrineHenchmans (byref shrine, byref newmymaster)
	set_critical (1);
	foreach item in ListRootItemsInContainer (newmymaster.backpack)
		if (item.objtype == 0xFFFA)
			var hinfo := GetObjProperty(item, "info");
			if(!SystemFindObjectBySerial (hinfo[1]) && hinfo[1]) //is it dead?
				if(!GetObjProperty(item, "barracks"))
				var shrineflag := getobjproperty(item,"shrinerez");
				if (!shrineflag) 
						shrineflag := 0; 
				endif
				if (!FlagCheck(shrineflag, shrine))
					shrineflag := FlagSet(shrineflag, shrine);
					SetObjProperty(item,"shrinerez",shrineflag);
					var shrinecount := GetObjproperty(item, "shrinecount");
					if(!shrinecount)
						shrinecount := 0;
					endif
					SetObjProperty(item, "shrinecount", shrinecount +  1);
					var parms := {};
					parms.+script := ":guards:henchman";

					var new_npc := CreateNPCFromTemplate (":guards:warrior", newmymaster.x, newmymaster.y, newmymaster.z, parms);
					if (new_npc)
						var newbackpack := CreateItemAtLocation (5288 , 1176 , 0, UOBJ_BACKPACK, 1);
						if (!EquipItem (new_npc, newbackpack))
							DestroyItem (newbackpack);
						endif
						SetObjProperty (new_npc, "master", newmymaster.serial);
	
						SetObjProperty (new_npc, "soul", item.serial);
						SetVital (new_npc, "Life", 100);
						PlaySoundEffect( new_npc, SOUND_EFFECT_RES );
						PlayObjectCenteredEffect( new_npc, EFFECT_SPARKLE, 10,10);
						hinfo[1] := new_npc.serial;
						new_npc.name := hinfo[2];
						hinfo[3] := newmymaster.serial;
						SetObjProperty(item, "info", hinfo);
					endif	
				else
					SendSysMessage(newmymaster, hinfo[2] +" already shrined here");
				endif
				else
					SendSysMessage(newmymaster, hinfo[2] +" isn't dead, try the barracks");
				endif
			endif
		endif
	endforeach
	set_critical (0);
	return 1;
endfunction


///////////////////
//  If we're really low on HP, try to drink a heal potion
///////////////////

function DrinkHeal ()
	if (CINT (GetObjProperty (me, "#potion")) > ReadGameClock()  )
        	return 0;
	endif

	foreach item in EnumerateItemsInContainer (me.backpack)
		if (item.objtype == UOBJ_HEAL_POTION or item.objtype == UOBJ_GREATER_HEAL_POTION)
			PlaySoundEffect (me, SFX_DRINK);
			PerformAction (me, ANIM_EAT);
			CreateItemInBackpack (me, UOBJ_EMPTY_BOTTLE, 1);
			var heal_amount;
			if (item.objtype == 0xDC02)
				heal_amount := RandomDiceRoll ("3d12+3");
			else
				heal_amount := RandomDiceRoll ("5d12+3");
			endif			
			HealDamage (me, heal_amount);
			SubtractAmount (item, 1);
			PlaySoundEffect (me,  SFX_HEAL);
			SetObjProperty (me, "#potion", (ReadGameClock() + 20));
			return 1;
		endif
	endforeach

	return 0;
endfunction




///////////////////
//  If we're really low on HP, try to drink a heal potion
///////////////////

function DrinkCure ()
	if (Cint (GetObjProperty (me, "#potion")) > ReadGameClock()  )
        	return 0;
	endif

	foreach item in EnumerateItemsInContainer (me.backpack)
		if (item.objtype == UOBJ_CURE_POTION or item.objtype == UOBJ_GREATER_CURE_POTION)
			PlaySoundEffect (me, SFX_DRINK);
			PerformAction (me, ANIM_EAT);
			CreateItemInBackpack (me, UOBJ_EMPTY_BOTTLE, 1);
			if (item.objtype == UOBJ_CURE_POTION)
				if (GetPoisonLevel (me) <= 7 or random (2) )
					CurePoison (me, SFX_CURE, 0);
				endif
			else
				CurePoison (me, SFX_CURE, 0);
			endif			
			SubtractAmount (item, 1);
			SetObjProperty (me, "#potion", (ReadGameClock() + 20));
			return 1;
		endif
	endforeach

	return 0;
endfunction

function ItemEquip (item)
	var canequip := EquipItem (me, item);
	if (!canequip)
		return 0;
	endif

	//add the owner's mark:
	if (!GetObjProperty (item, "ownerserial"))
		var TheName := item.desc;
		SetObjProperty (item, "oldname", thename);
		var longname := splitwords(TheName);
		if (longname[1]=="a" or longname[1]=="an")
			TheName:="";
			foreach word in longname;
				if (word != longname[1])
					TheName := TheName + " "+ word;
				endif
			endforeach
			item.name := mymaster.name+"'s" + TheName;
		else
			item.name := mymaster.name+"'s " + TheName;
		endif
		item.buyprice := -1;
		SetObjProperty (item, "ownerserial", mymaster.serial);
		SetObjProperty (item, "ownername", mymaster.name);
	endif
	return canequip;

endfunction


// Make the henchman say something to indicate that
// he/she is healing the one who is being guarded.

function SayHenchmanHealing ()
	case (Random (8))
	0:
		HenchieSay ("You look injured!");
	1:
		HenchieSay ("The things I do for you...");
	2:
		HenchieSay ("Hold still");
	3:
		HenchieSay ("Ick! you're bleeding");
	4:
		HenchieSay ("This may sting!");
	5:
		HenchieSay ("Soon you'll be good as new!");
	6:
		HenchieSay ("Is that blood?!");
	7:
		HenchieSay (me.name + " to the rescue!");
	endcase
endfunction

// Put yellow text over henchman's head
function HenchieSay(saywhat)
	PrintTextAbove (me, saywhat, _DEFAULT_TEXT_FONT, FONTCOLOR_YELLOW);
endfunction

// Put Custom Colored Text over henchman's head
function HenchieSayColor(saywhat, color := FONTCOLOR_GREEN)
	PrintTextAbove (me, saywhat, _DEFAULT_TEXT_FONT, color);
endfunction

/////////////////////////////////////////////////////
// DoStartupSetup looks for or creates a soulstone, if a soulstone is found the skills and
// other features will be set accordingly, if not then basic henchman stats are given to a
// new soulstone which is given to the mymaster
/////////////////////////////////////////////////////

function DoHenchStartupSetup ()
	if(!soulstone)
		soulstone := FindSoulStone();
	endif

	set_critical(1);
	if(soulstone)
		soulstone.name := me.name +"'s Soulstone";
		soulstone.newbie := 1;
		var info := GetObjProperty(soulstone, "info");
		info[1] := me.serial; //set new serial
		info[2] := me.name;
		info[3] := mymaster.serial;
		SetObjProperty(soulstone, "info", info);

		var hconfig := GetObjProperty(soulstone, "config");
		if(len(hconfig)  && hconfig[1] >= 0)
			HALT_THRESHOLD := hconfig[1];
			SWITCH_THRESHOLD := hconfig[2];
			MAX_FOLLOW_RANGE := hconfig[3];
			usesmagery := hconfig[4];
			meditate := hconfig[5];
			casthealduringcombat := hconfig[6];
			healtype := hconfig[7];
			healallowed := hconfig[8];
			healpriority := hconfig[9];
			allowedtoswitch := hconfig[10];
			ignoreothers := hconfig[11];
			buffoption := hconfig[12];
		endif

		//get skills
		var skills := GetObjProperty(soulstone, "skills");
		if(len(skills) && skills[1] >= 0)
			for i := 1 to 49
				var skill := skills[i];
				if(!skill)
					skill := 0;
				endif
				var spec := CheckIfSpecialized (mymaster, i-1);
	
				//lets check for specs
				case (spec)
					1:
					2:
					3:
						if (skill > 1000)
							skill := 1000;
						endif
					4:
					5:
					6:
						if (skill > 800)
							skill := 800;
						endif
					default:
						if (skill > 400)
							skill := 400;
						endif
				endcase
				if(GetObjProperty (me, "#takepoints") && skill >= 100)
					if(random(2))
						skill := CINT(skill * 0.99); //deathtax
					endif
				endif
				SetAttributeBaseValue (me, GetAttributeIDBySkillID(i-1), skill);
				skills[i] := skill;
			endfor	
			EraseObjProperty (me, "#takepoints");
			SetObjProperty(soulstone, "skills", skills);
		endif
		
		var stats := GetObjProperty(soulstone, "stats");
		if(len(stats) && stats[1] >= 0)
			SetAttributeBaseValue (me, "Strength", stats[1]);
			SetAttributeBaseValue (me, "Intelligence", stats[2]);
			SetAttributeBaseValue (me, "Dexterity", stats[3]);
		endif

		var expinfo := GetObjProperty(soulstone, "exp");
		if(len(expinfo) && expinfo[1] >= 0)
			setObjproperty( me , "combatvirtue", expinfo[1]);
			setObjproperty( me , "mage_exp", expinfo[2]);
			setObjproperty( me , "virtue", expinfo[3]);
			SetObjProperty( me , "virtueskillssetup" , expinfo[4]);
		endif


		var visual := GetObjProperty(soulstone, "visual");
		if(len(visual) && visual[1] >= 0)
			me.gender := visual[1];
			me.graphic := me.gender + 400;
			me.color := 33784;
			var hairstyle := visual[3];
			if(!len(hairstyle))
				hairstyle := {0,0,0,0};
			else
				if (hairstyle[1])
					var hair := CreateItemAtLocation (5288 , 1176 , 0, CINT (hairstyle[1]), 1);
					hair.color := hairstyle[2];
					if (!EquipItem (me, hair))
						DestroyItem (hair);
					endif

					if (hairstyle[3])
						var beard := CreateItemAtLocation (5288 , 1176 , 0, CINT (hairstyle[3]), 1);
						beard.color := hairstyle[4];
						if (!EquipItem (me, beard))
							DestroyItem (beard);
						endif
					endif
				endif
			endif
		endif
		recalcvitals(me);
	else
		SendSysMessage(mymaster, "unable to locate soulstone or create one!");
		Set_critical(0);
		return 0;
	endif
	foreach item in ListRootItemsInContainer (me.backpack)
		EquipItem (me, item);
	endforeach

	if(GetObjProperty (soulstone, "practicing") && !GetObjProperty(soulstone, "#running_practice"))
		Start_script (":guards:henchman_practice", soulstone);
		SetObjProperty(soulstone, "#running_practice", 1);
	endif

	var totem := GotTotem();
	if(totem)
		mount_totem(totem);
	endif

	recalcVitals(me);
	set_critical(0);
endfunction

function DoSkillBuy (byref cash)
	if(!soulstone)
		soulstone := findsoulstone();
	endif

	var gold_amount := cash.amount;
	destroyItem(cash);
	if(!soulstone)
		CreateItemInContainer (me.backpack, UOBJ_GOLD_COIN, gold_amount);
		SendSysMessage(mymaster, "unable to locate or create soulstone for "+CSTR(me.name)+"!");
		return 0;
	endif

	var gump_layout := {
		"page 0",
		"nodispose",
		"resizepic 0 50 2620 320 460",
		"text 15 62 1 0"
	};

	var gump_data := {};
	gump_data[1]:="SKILLS: (Practicing for " + CSTR(CINT(gold_amount/60)) + " minutes)";

	var current_base_skill, current_raw_skill, after_raw_skill, after_base_skill, projected_skill_gain_string, raw_skill_cap, base_skill_cap;
	var current_y_pos := 90;
	var string_counter := 1;

	var skill_list := {1, 17, 5, 27, 31, 40, 41, 42, 43, 26, 25, 16, 46};
	var spec;

	foreach skillid in skill_list
		current_base_skill := GetAttributeBaseValue (me, GetAttributeIDBySkillID (skillid));
		current_raw_skill := BaseSkillToRawSkill (current_base_skill);

		//lets check for specs
		spec := CheckIfSpecialized (mymaster, skillid);
		case (spec)
			1:
			2:
			3:
				base_skill_cap := 1000;
			4:
			5:
			6:
				base_skill_cap := 800;
			default:
				base_skill_cap := 400;
		endcase
		raw_skill_cap := BaseSkillToRawSkill (base_skill_cap);

		after_raw_skill := current_raw_skill + (gold_amount*10) + (CurrentlyPracticing (skillid, soulstone)*10);
		after_base_skill := RawSkillToBaseSkill (after_raw_skill);

		if (after_raw_skill <= raw_skill_cap)
			projected_skill_gain_string := CSTR (" (" + SkillNumDisplay (after_base_skill - current_base_skill) + ")" );
			var limit := CINT(GetAttribute(mymaster, ATTRIBUTEID_LEADERSHIP)*10);
			if(limit > GetAttributeBaseValue(mymaster, GetAttributeIDBySkillID (skillid)))
				limit := GetAttributeBaseValue(mymaster, GetAttributeIDBySkillID (skillid));
			endif
			if (after_base_skill > limit )
				projected_skill_gain_string := " (mymaster Max)";
			endif
		else
			projected_skill_gain_string := " (Skill Cap)";
		endif

		if (CurrentlyPracticing (skillid, soulstone))
			projected_skill_gain_string := projected_skill_gain_string + " (P)";
		endif

		if (current_raw_skill < raw_skill_cap)
			var limit := CINT(GetAttribute(mymaster, ATTRIBUTEID_LEADERSHIP)*10);
			if(limit > GetAttributeBaseValue(mymaster, GetAttributeIDBySkillID (skillid)))
				limit := GetAttributeBaseValue(mymaster, GetAttributeIDBySkillID (skillid));
			endif
			var temp_raw_skill := current_raw_skill + (CurrentlyPracticing (skillid, soulstone)*10);
			var mymaster_max_raw_skill := BaseSkillToRawSkill (limit);
			if (temp_raw_skill < raw_skill_cap and mymaster_max_raw_skill > temp_raw_skill)
				gump_layout.append ("button 20 " + current_y_pos + " 2104 2103 1 0 " + (skillid+1));
			endif
		endif

		gump_layout.append ("text 40 " + (current_y_pos - 5) + " 1102 " + string_counter);
		gump_data.append (GetSkillName(skillid) + " " + projected_skill_gain_string);
		string_counter := string_counter + 1;
		current_y_pos := current_y_pos + 20;
	endforeach

	gump_layout.append ("button 240 465 2119 2120 1 0 0");
	gump_layout.append ("text 20 465 1104 " + string_counter);
	gump_data.append ("Select a skill");

	var gump_return := SendDialogGump( mymaster, gump_layout, gump_data );

	if (!gump_return or !gump_return[0])
		HenchieSay ("Ok, never mind then.");
		CreateItemInContainer (me.backpack, UOBJ_GOLD_COIN, gold_amount);
		return 0;
	endif

	var chosen_skill := gump_return [0] - 1;

	//lets check for specs
	spec := CheckIfSpecialized (mymaster, chosen_skill);
	case (spec)
		1:
		2:
		3:
			base_skill_cap := 1000;
		4:
		5:
		6:
			base_skill_cap := 800;
		default:
			base_skill_cap := 400;
	endcase
	raw_skill_cap := BaseSkillToRawSkill (base_skill_cap);

	var limit := CINT(GetAttribute(mymaster, ATTRIBUTEID_LEADERSHIP)*10);
	if(limit > GetAttributeBaseValue(mymaster, GetAttributeIDBySkillID (chosen_skill)))
		limit := GetAttributeBaseValue(mymaster, GetAttributeIDBySkillID (chosen_skill));
	endif

	var mymaster_raw_skill_cap := BaseSkillToRawSkill (limit);
	if (mymaster_raw_skill_cap < raw_skill_cap)
		raw_skill_cap := mymaster_raw_skill_cap;
	endif
	current_base_skill := GetAttributeBaseValue (me, GetAttributeIDBySkillID (chosen_skill));
	current_raw_skill := BaseToRawSkill (current_base_skill);
	var max_training := raw_skill_cap - current_raw_skill;

	if (max_training <= 0)
		HenchieSay("Here's your gold back.");
		CreateItemInContainer (mymaster.backpack, UOBJ_GOLD_COIN, gold_amount);
		return 1;
	endif


	var paid_for_training := (gold_amount*10) + (CurrentlyPracticing (chosen_skill, soulstone)*10);

	if (max_training < paid_for_training)
		var refund := CINT ((paid_for_training - max_training)/10);
		if (refund)
			sleep (1);
			HenchieSay("Hmm Boss, I think you gave me a bit too much.");
			sleep (1);
			HenchieSay("Here's your " + refund + " gold back.");
			CreateItemInContainer (mymaster.backpack, UOBJ_GOLD_COIN, refund);
			paid_for_training := CINT(max_training/10)+1;
		else
			paid_for_training := CINT(max_training/10)+1;
		endif
	else
		paid_for_training := gold_amount + CurrentlyPracticing (chosen_skill, soulstone);
	endif

	HenchieSay("Ok, so what should I do?");
	sleep(1);
	HenchieSay("I'll now practice "+GetSkillName (chosen_skill)+" in my spare time");

	set_critical (1);
	var prac := GetObjProperty (soulstone, "practicing");
	if (!prac)
		prac := {};
	endif

	//check to see if we're already practicing this skill
	var theskill := {};
	for i := 1 to len (prac)
		theskill := prac[i];
		if (theskill[1] == chosen_skill)
			theskill[2] := paid_for_training;
			prac[i] := theskill;
			SetObjProperty (soulstone, "practicing", prac);

			if (!GetObjProperty (soulstone, "lastpractice") )
				SetObjProperty (soulstone, "lastpractice", ReadGameClock() );
			endif
			set_critical (0);
			return;
		endif
	endfor

	//guess we're not already practicing that skill, so start anew
	theskill[1] := chosen_skill;
	theskill[2] := paid_for_training;

	prac.append (theskill);
	SetObjProperty (soulstone, "practicing", prac);

	if (!GetObjProperty (soulstone, "lastpractice"))
		SetObjProperty (soulstone, "lastpractice", ReadGameClock() );
	endif

	if(!GetObjProperty(soulstone, "#running_practice"))
		Start_script (":guards:henchman_practice", soulstone);
		SetObjProperty(soulstone, "#running_practice", 1);
	endif

	set_critical (0);

	return 1;
endfunction

///////////////////
//  Does some parsing to display the number correctly
///////////////////

function SkillNumDisplay (byref skillval)
	var str := cstr (skillval);
	if (!len(str))
		return "0.0";
	endif
	str[ len(str),1 ] := "."+ str[ len(str),1 ];
	return str;
endfunction


///////////////////
//  calculates what skills the player is already practicing
///////////////////

function CurrentlyPracticing (byref skillid, byref soulstone)
	if (!GetObjProperty (soulstone, "practicing") )
		return 0;
	endif

	var prac := GetObjProperty (soulstone, "practicing");
	var theskill := { };
	for i := 1 to len (prac)
		theskill := prac [i];
		if (theskill[1] == skillid)
			return theskill[2];
		endif
	endfor

	return 0;
endfunction

function IncreaseByRaw (skill, rawpoints, spec)
	rawpoints := CINT (rawpoints);
	if (!rawpoints)
		return skill;
	endif

	var initial := skill;
	var current := initial;

	if (rawpoints > 0)
		var to_increase := GetNeededRawPointsToIncrease (current);
		while (rawpoints >= to_increase)
			rawpoints := rawpoints - to_increase;
			current	:= current + 1;
			to_increase := GetNeededRawPointsToIncrease (current);
		endwhile
		
		if (Random(to_increase) < rawpoints)
			current := current + 1;
		endif

	elseif (rawpoints < 0)
		var to_decrease	:= GetNeededRawPointsToIncrease (current-1);
		while (rawpoints >= to_decrease and current > 0 )
			rawpoints := rawpoints - to_decrease;
			current := current - 1;
			to_decrease := GetNeededRawPointsToIncrease (current-1);
		endwhile

		if (Random (to_decrease) < rawpoints )
			current := current - 1;
		endif
		
		if (current < 0)
			current := 0;
		endif
	endif
	
	if (current != initial)
		//lets check for specs
		var skillcap := 400;
		case (spec)
			1:
			2:
			3:
				skillcap := 1000;
			4:
			5:
			6:
				skillcap := 800;
			default:
				skillcap := 400;
		endcase

		if (skillcap)
			if (current > skillcap)
				current := skillcap;
			endif
		endif

		return current;
	endif
	return current;
endfunction

function HenchmanBuffMax (byref who, byref skillid)
	var mymaster_serial := GetObjProperty(who, "master");
	var mymaster := SystemFindObjectBySerial (mymaster_serial, SYSFIND_SEARCH_OFFLINE_MOBILES);
	if (!mymaster) //no leader found....lets equip it at max then even though it shouldn't happen!
		return 0;
	endif

	Var total_leaderskill := CINT(GetAttribute(mymaster, ATTRIBUTEID_LEADERSHIP)*10);
	var myskill := CINT(GetAttributeBaseValue(who, GetAttributeIDBySkillID (skillid)));
//	PrintTextAbove(who, "My "+ CSTR(GetAttributeIDBySkillID (skillid)) +" = "+ CSTR(GetAttributeBaseValue(who, GetAttributeIDBySkillID (skillid)))
	if(myskill < total_leaderskill)
		var maxamount := CINT((total_leaderskill - myskill)/10);
		if(maxamount < 0)
			return 0;
		elseif(maxamount > 30)
			return 30;
		else
			return maxamount;
		endif
	else
		return 0; //buffs don't work at all!
	endif
	return 0;
endfunction

function HenchmanBuffEquip (byref character, byref item)
	if (!character or !item)
		return 0;
	endif

	var skillid := GetObjProperty (item, "skilladv");
	if (!skillid and skillid != 0)
		return 0;
	endif
	
	var skill_bonus := GetObjProperty (item, CStr("skill"+skillid));
	if (!skill_bonus)
		return 0;
	endif

	set_critical (1);
	var allskillmods := GetObjProperty (character, "#allskillmods");
	if (!allskillmods)
		allskillmods := array;
	endif

	var previous_skill_bonus := 0;	//skill bonus for items already equipped
	var maximum_skill_bonus := HenchmanBuffMax (character, skillid);//So we can have a single special item that takes us above
								//the normally allowed bonus
	foreach skillmod in allskillmods
		//we've already got the skill bonus for this item, so just return
		if (skillmod[1] == item.serial)
			set_critical (0);
			return 0;
		endif

		//if we already have an item equiped that gives us this skill...
		if (skillmod[2] == skillid)
			previous_skill_bonus := previous_skill_bonus + skillmod[3];
			if (skillmod[3] > maximum_skill_bonus)
				maximum_skill_bonus := skillmod[3];
			endif
		endif
	endforeach

	var new_skill_mod := array;
	new_skill_mod [1] := item.serial;
	new_skill_mod [2] := skillid;
	new_skill_mod [3] := skill_bonus;

	allskillmods.append (new_skill_mod);
	SetObjProperty (character, "#allskillmods", allskillmods);
	set_critical (0);

	if (skill_bonus > maximum_skill_bonus)
		maximum_skill_bonus := skill_bonus;
	endif

	//Set the maximum amount of skill bonus that you can get
	if (previous_skill_bonus)
		if (previous_skill_bonus + skill_bonus > maximum_skill_bonus)
			skill_bonus := maximum_skill_bonus - previous_skill_bonus;
			if (skill_bonus <= 0)
				return;
			endif
		endif
	endif

	SetObjProperty( character, "#leadermax"+CSTR(skillid), maximum_skill_bonus);
	AddSkillBonus (character, skillid, skill_bonus);
	return 1;
endfunction

function HenchmanBuffUnequip (byref character, byref item)
	if (!character or !item)
		return 0;
	endif

	var skillid := GetObjProperty (item, "skilladv");
	if (!skillid and skillid != 0)
		return 0;
	endif

	var skill_bonus := GetObjProperty (item, "skill"+CStr(skillid));
	if (!skill_bonus)
		return 0;
	endif

	set_critical (1);
	var allskillmods := GetObjProperty (character, "#allskillmods");
	if (!allskillmods)
		//we don't have any skillmods.  Why are we trying to remove one?
		set_critical (0);
		return 0;
	endif

	//we need to make a new allskillmods list, without the one we're trying to remove, and
	//also figure out what other skill bonuses we have
	var new_allskillmods := array;
	var other_skill_bonus := 0;
	var maximum_skill_bonus := HenchmanBuffMax (character, skillid);	//So we can have a single special item that takes us above
	var oldmax := GetObjProperty(character, "#leadermax"+CSTR(skillid));
										//the normally allowed bonus
	foreach skillmod in allskillmods
		if (skillmod [1] != item.serial)
			new_allskillmods.append (skillmod);
			if (skillmod[2] == skillid)
				other_skill_bonus := other_skill_bonus + skillmod[3];
			endif
		endif
		if (skillmod[3] > maximum_skill_bonus)
			maximum_skill_bonus := skillmod[3];
		endif
		if (skillmod[3] > oldmax)
			oldmax := skillmod[3];
		endif
	endforeach

	//well, we went through them all and didn't remove anything, so I guess
	//we didn't really have that item equiped in the first place...
	if (len (allskillmods) == len (new_allskillmods))
		set_critical (0);
		return 0;
	endif

	if (len (new_allskillmods) )
		SetObjProperty (character, "#allskillmods", new_allskillmods);
	else
		EraseObjProperty (character, "#allskillmods");
	endif
	set_critical (0);

	var old_skill_bonus := skill_bonus;
	if (other_skill_bonus + old_skill_bonus > oldmax)
		old_skill_bonus := oldmax - other_skill_bonus;
		if (old_skill_bonus <= 0)
			old_skill_bonus := skill_bonus;
		endif
	endif

	if (other_skill_bonus + skill_bonus > maximum_skill_bonus)
		skill_bonus := maximum_skill_bonus - other_skill_bonus;
		if (skill_bonus <= 0)
			return;
		endif
	endif

	if(oldmax > maximum_skill_bonus)
		skill_bonus := skill_bonus + (old_skill_bonus - skill_bonus);
	elseif(oldmax < maximum_skill_bonus)
		skill_bonus := old_skill_bonus;
	endif

	if(other_skill_bonus == 0)
		EraseObjProperty( character, "#leadermax"+CSTR(skillid));
	else
		SetObjProperty( character, "#leadermax"+CSTR(skillid), maximum_skill_bonus);
	endif

	AddSkillBonus (character, skillid, 0-skill_bonus);
endfunction

function FindSoulStone ()
	if(!soulstone)
		var soul_serial := GetObjProperty (me, "soul");
		if (!soul_serial)
			var waitcounter := 0;
			repeat
				sleep (1);
				waitcounter := waitcounter + 1;
				soul_serial := GetObjProperty (me, "soul");
			until (soul_serial || waitcounter > 10);
			if(!soul_serial)
				soulstone := CreateItemInBackpack( mymaster, 0xFFFA);
				if(!soulstone)
					HenchieSay("I'm unable to make a soulstone!!!!!, don't let me die!!!!!!");
					return 0;
				else
					HenchieSay("Here is my soulstone, take good care of it!");
				endif
				soul_serial := soulstone.serial;
				soulstone.name := me.name +"'s Soulstone";
				soulstone.newbie := 1;
				setObjProperty (me, "soul", soulstone.serial);
				return soulstone;
			endif
			return 0;
		endif

		soulstone := SystemFindObjectBySerial (soul_serial);
		if(!soulstone)
			soulstone := SystemFindObjectBySerial (soul_serial, SYSFIND_SEARCH_OFFLINE_MOBILES );
		endif
		if(!soulstone)
			HenchieSay("Could you please take better care of my soulstone!!!");
			soulstone := CreateItemInBackpack( mymaster, 0xFFFA);
			if(!soulstone)
				HenchieSay("I'm unable to make a soulstone!!!!!, don't let me die!!!!!!");
				return 0;
			else
				HenchieSay("I've made a new one in your backpack.");
			endif
			soul_serial := soulstone.serial;
			soulstone.name := me.name +"'s Soulstone";
			soulstone.newbie := 1;
			setObjProperty (me, "soul", soulstone.serial);
			return soulstone;
		endif
	endif
	return soulstone;
endfunction

function RecordFeatures()
	if(!soulstone)
		soulstone := FindSoulStone();
	endif

	Set_Critical(1);
	if(soulstone)
		var info := array;
		info[1] := me.serial; //set new serial
		info[2] := me.name;
		info[3] := mymaster.serial;
		SetObjProperty(soulstone, "info", info);

		soulstone.name := me.name +"'s Soulstone";
		soulstone.newbie := 1;

		//set the configuration
		var hconfig := array;
		hconfig[1] := HALT_THRESHOLD;
		hconfig[2] := SWITCH_THRESHOLD;
		hconfig[3] := MAX_FOLLOW_RANGE;
		hconfig[4] := usesmagery;
		hconfig[5] := meditate;
		hconfig[6] := casthealduringcombat;
		hconfig[7] := healtype;
		hconfig[8] := healallowed;
		hconfig[9] := healpriority;
		hconfig[10] := allowedtoswitch;
		hconfig[11] := ignoreothers;
		hconfig[12] := buffoption;
		SetObjProperty(soulstone, "config", hconfig);
	
		//get skills, also lower them if they are too high
		var skills := array;
		for i := 1 to 49
			var skill := GetAttributeBaseValue (me, GetAttributeIDBySkillID(i-1));
			if(!skill)
				skill := 0;
			endif
			var spec := CheckIfSpecialized (mymaster, i-1);
	
			//lets check for specs
			case (spec)
				1:
				2:
				3:
					if (skill > 1000)
						skill := 1000;
					endif
				4:
				5:
				6:
					if (skill > 800)
						skill := 800;
					endif
				default:
					if (skill > 400)
						skill := 400;
					endif
			endcase

			if(!GetObjProperty(me, "#FreeSkill") || (GetObjProperty(me, "#FreeSkill") <= ReadGameClock()))
				if(CINT(i -1) != 15)
					case(spec)
						1:
						2:
						3:
							skill := IncreaseByRaw (skill, 100, spec);
						4:
						5:
						6:
							skill := IncreaseByRaw (skill, 50, spec);
					endcase
				endif
			endif
				SetAttributeBaseValue (me, GetAttributeIDBySkillID(i-1), skill);
			skills[i] := skill;
		endfor	
		if(!GetObjProperty(me, "#FreeSkill") || (GetObjProperty(me, "#FreeSkill") <= ReadGameClock()))
			SetObjProperty(me, "#FreeSkill", ReadGameClock() + 300); //next free skill in 5 min
		endif

		SetObjProperty(soulstone, "skills", skills);

		//stat information
		var stats := array;
		stats[1] := GetAttributeBaseValue (me, "Strength");
		stats[2] := GetAttributeBaseValue (me, "Intelligence");
		stats[3] := GetAttributeBaseValue (me, "Dexterity");
		SetObjProperty(soulstone, "stats", stats);

		//experience based values
		var expinfo := array;
		if(GetObjProperty (me, "combatvirtue"))
			expinfo[1] := GetObjProperty (me, "combatvirtue");
		else
			expinfo[1] := 0;
		endif

		if(GetObjProperty (me, "mage_exp"))
			expinfo[2] := GetObjProperty (me, "mage_exp");
		else
			expinfo[2] := 0;
		endif

		if(GetObjProperty (me, "virtue"))
			expinfo[3] := GetObjProperty (me, "virtue");
		else
			expinfo[3] := 0;
		endif

		if(GetObjProperty( me , "virtueskillssetup" ))
			expinfo[4] := GetObjProperty( me , "virtueskillssetup");
		else
			expinfo[4] := 0;
		endif
		SetObjProperty(soulstone, "exp", expinfo);

		//info about the appearal of the henchman
		var visual := array;
		visual[1] := me.gender;
		visual[2] := me.color;
		var hairstyle := array;
		var myhair := GetEquipmentByLayer (me, LAYER_HAIR);
		if (myhair)
			hairstyle[1] := myhair.objtype;
			hairstyle[2] := myhair.color;
		else
			hairstyle[1] := 0;
			hairstyle[2] := 0;
		endif

		var mybeard := GetEquipmentByLayer (me, LAYER_BEARD);
		if (mybeard)
			hairstyle[3] := mybeard.objtype;
			hairstyle[4] := mybeard.color;
		else	
			hairstyle[3] := 0;
			hairstyle[4] := 0;
		endif
		visual[3] := hairstyle;
		SetObjProperty(soulstone, "visual", visual);
	else
		SendSysMessage(mymaster, "unable to locate or create a soulstone for " + me.name);
		Set_Critical(0);
		return 0;
	endif
	SetObjProperty(me, "soul", soulstone.serial);
	Set_Critical(0);

	if(GetObjProperty (soulstone, "practicing") && !GetObjProperty(soulstone, "#running_practice"))
		Start_script (":guards:henchman_practice", soulstone);
		SetObjProperty(soulstone, "#running_practice", 1);
	endif
endfunction


///////////////////
//  Gives the warrior an AR mod for what they have equipped
// this has to be done in order to give them me like armor!
///////////////////

function SetARMod ()
	set_Critical(1);
	var myar := CalcArmorFromItems(me)+getArmorMod(me);
	me.ar_mod := CINT(myar-50);
	set_Critical(0);
	return myar;
endfunction

function GotTotem()
	foreach item in EnumerateItemsInContainer (me.backpack)
		if(IsTotem (item))
			return item;
		endif
	endforeach
	return 0;
endfunction

function Mount_totem( byref totem )

	var mount := CreateItemAtLocation(5288 , 1176 , 0, 0xF021,1);
	mount.color := totem.color;
	setobjproperty(mount,"totem",totem.objtype);

	var ownerserial := GetObjProperty(totem, "ownerserial");
	if ( ownerserial )
		var oldname := GetObjProperty(totem, "oldname");
		var ownername := GetObjProperty(totem, "ownername");
		SetObjProperty( mount, "ownerserial", ownerserial );
		SetObjProperty( mount, "oldname", oldname );
		SetObjProperty( mount, "ownername", ownername );
	endif

	case ( totem.objtype )
		0x2124:
			mount.graphic := 0x3ea0;
		0x20f6:	
			mount.graphic := 0x3ea6;
		0x25ce:	
			mount.graphic := 0x3eb4;
		0x2619:	
			mount.graphic := 0x3ebd;	
		0x2136:
			mount.graphic := 0x3ea5;
		default:
        		return 0;
	endcase
	mount.name := totem.name;
	if (!EquipItem(me,mount))
		return 0;
	endif
	PlaySoundEffect( me, SFX_SPELL_DISPEL );
	PlayStationaryEffect( me.x, me.y, me.z, FX_SMOKE, 0xA, 0xA );
	DestroyItem(totem);
	return 1;
endfunction

function IsTotem (byref item)
	case ( item.objtype )
		0x2124:
		0x20f6:	
		0x25ce:
		0x2619:
		0x2136:
			return 1;
		default:
        		return 0;
	endcase
	return 0;
endfunction

function callforhelp(byref opponent)
	var ev := array;
	ev.+type := EVID_ALL_ATTACK_CMD;
	ev.+source := opponent;

	foreach mob in ListMobilesNearLocationEX ( me.x, me.y, me.z, range, LISTEX_FLAG_NORMAL )
       		If (GetObjProperty (mob, "master") == mymasterserial)
			if (!mobile.warmode)
				SendEvent (mobile, ev);
			endif
		endif
	endforeach
endfunction