include "include/client";
include "include/objtype";
include "include/dotempmods";
include "include/myutil";
include "include/yesno";
include "include/myutil";
include "include/sysevent";
include "include/eventid";
include "../pkg/npcs/npc_util";
include "../pkg/npcs/npcinfo";
include "../pkg/npcs/speech";
include "../pkg/npcs/spellcasting";
include "../pkg/world/townstones/townstone";

Const MAX_TOWNGUARDS_PER_PERSON	:= 4;
Const BONUS_GUARDS_PER_TOWN		:= 10;
Const HALT_THRESHOLD			:= 10;

/////////////////////////////////////////////////////////////////////////////////////////////////
//// resurrects a henchman, althought it should be in the henchman.inc I need it here so I can ress 
////both townguards and henchman (a lot of functions are named the same and it won't compile
////////////////////////////////////////////////////////////////////////////////////////////////

function ResurrectHenchman (byref corpse)
	set_critical (1);
	var master_serial := GetObjProperty (corpse, "master");
	if (!master_serial)
		set_critical (0);
		return 0;
	endif

	var mymaster := SystemFindObjectBySerial (master_serial, SYSFIND_SEARCH_OFFLINE_MOBILES );
	if (!mymaster)
		set_critical(0);
		return 0;
	endif

	var parms := {};
	parms.+script := ":guards:henchman";
	if (GetObjProperty (corpse, "myscript") )
		parms.script := GetObjProperty (corpse, "myscript");
	endif

	var new_npc := CreateNPCFromTemplate (":guards:warrior", corpse.x, corpse.y, corpse.z, parms);
	if (!new_npc)
		set_critical(0);
		return 0;
	endif

	var newbackpack := CreateItemAtLocation (4550, 3687  , 0, UOBJ_BACKPACK, 1);
	if (!EquipItem (new_npc, newbackpack))
		DestroyItem (newbackpack);
	endif

	SetObjProperty (new_npc, "master", mymaster.serial);
	if(GetObjProperty (corpse, "combatvirtue"))
		if(GetObjProperty (corpse, "combatvirtue") <= GetObjProperty (mymaster, "combatvirtue"))
			SetObjProperty (new_npc, "combatvirtue", GetObjProperty (corpse, "combatvirtue"));
		else
			SetObjProperty (new_npc, "combatvirtue", GetObjProperty (mymaster, "combatvirtue"));
		endif
	else
		SetObjProperty (new_npc, "combatvirtue", 0);
	endif

	if(GetObjProperty (corpse, "mage_exp"))
		if(GetObjProperty (corpse, "mage_exp") <= GetObjProperty (mymaster, "mage_exp"))
			SetObjProperty (new_npc, "mage_exp", GetObjProperty (corpse, "mage_exp"));
		else
			SetObjProperty (new_npc, "mage_exp", GetObjProperty (mymaster, "mage_exp"));
		endif
	else
		SetObjProperty (new_npc, "mage_exp", 0);
	endif

	SetObjProperty (new_npc, "virtue", GetObjProperty (corpse, "virtue"));

	if(!GetObjProperty (corpse, "#lastdeath") || (GetObjProperty (corpse, "#lastdeath") <= ReadGameClock()))
		SetObjProperty(new_npc, "#lastdeath", ReadGameClock() + 3600);
		SetObjProperty(new_npc, "#takepoints", 1);		
	else
		SetObjProperty(new_npc, "#lastdeath", GetObjProperty (corpse, "#lastdeath"));
	endif

	SetObjProperty (new_npc, "soul", GetObjProperty (corpse, "soul"));
	SetVital (new_npc, "Life", 100);

	var temp_string := corpse.desc;
	temp_string["A corpse of "] := "";
	new_npc.name := temp_string;

	foreach item in ListRootItemsInContainer (corpse)
		if (!EquipItem (new_npc, item))
			MoveItemToContainer (item, new_npc.backpack);
		endif
	endforeach

//	RestartScript(new_npc);
	DestroyItem (corpse);
	set_critical (0);
	return 1;
endfunction

///////////////////
//  counts how many townguards a particular account has
///////////////////


function AddToAccountTownguards ()
  	set_critical (1);
	var mymaster := SystemFindObjectBySerial (masterserial, SYSFIND_SEARCH_OFFLINE_MOBILES );
	if (!mymaster)
		set_critical (0);
		KillMe ();
		return;
	endif
	me.setmaster (mymaster);
	me.title_race := mymaster.name;
	if (me.graphic != 400 and me.graphic != 401)
		me.title_guild := mymaster.name;
	endif
	SetObjProperty (me, "townnum", GetObjProperty (mymaster, "townnum"));

	var acctname := mymaster.acctname;
	if (!acctname)
		set_critical (0);
		return 0;
	endif

	var townguards := GetGlobalProperty ("#townguards_of_"+acctname);
	if (!townguards)
		townguards := {};
	endif

	if (me.serial in townguards)
		set_critical (0);
		return 1;
	endif
	townguards.append (me.serial);
	SetGlobalProperty ("#townguards_of_"+acctname, townguards);
	set_critical(0);
	return 1;
endfunction




///////////////////
//  counts how many townguards a particular account has
///////////////////

function CountAccountTownguards (masterserial)
	var mymaster := SystemFindObjectBySerial (masterserial, SYSFIND_SEARCH_OFFLINE_MOBILES );
	if (!mymaster)
		return 0;
	endif

	var acctname := mymaster.acctname;
	if (!acctname)
		return 0;
	endif

	var townguards := GetGlobalProperty ("#townguards_of_"+acctname);
	if (!townguards)
		return 0;
	endif

	var newtownguards := {};
	foreach henchserial in townguards
		var thehenchman := SystemFindObjectBySerial (henchserial);
		if (thehenchman)
			newtownguards.append (henchserial);
		endif
	endforeach
	SetGlobalProperty ("#townguards_of_"+acctname, newtownguards);
	return  (len (newtownguards));
endfunction




///////////////////
//  Figures out how many henchmen that particular person is allowed to have
///////////////////

function CalculateMaxGuards (player)

var currenttown := getobjproperty (player, "townnum");
 var currentmayor := FindMayorofTown(currenttown);
 if ( player == currentmayor)
     Return 10;
 else
     Return 4;
 endif
 
endfunction



///////////////////
//A bunch of different ways to say ok
///////////////////

function SayOkay()
	if ( randomint(5)!=1 )
		say("Okay");
		return;
	endif

	var samegender := ( master.gender == me.gender );
	var msg := "Okay";
	case ( RandomInt(24) )
	0: msg := "Yes, Oh great one";
	1: msg := "Your wish is my command";
	2: msg := "Whatever you say";
	3: msg := "Of course";
	4: msg := "As you wish";
	5: msg := "My pleasure";
	6: msg := "You bet";
	7: msg := "k";
	8: msg := "Sure thing";
	9: msg := "np";
	10: msg := "You da boss";
	11: msg := "Okay, but you can rez', right?";
	12: msg := "Surely";
	13: msg := "Alrighty";
	14: msg := "If you promise to keep me alive";
	15: 
		msg := "Sir! Yes, Sir!";
		if ( master.gender ) msg := "Yes, Ma'am!"; endif
	16: 
		if (!samegender )
			msg := "You are such a hottie";
		elseif ( me.gender )
			msg := "Let's go find some cute guys";
		else
			msg := "Where do the chicks hang out?";
		endif
	17: msg := "I joined the army for THIS?";
	18: msg := "*mumble* bossy *mumble*";
	19: msg := "Uh... well, ok";
	20: msg := "If you think I should";
	21: msg := "Will do";
	22: msg := "Huh?  Oh.  Okay";
	23: 
		if ( master.gender and !samegender )
			msg := "Yes, dear";
		elseif (!samegender)
			msg := "Okay, sweety";
		else
			msg := "Okay";
		endif
	default: msg := "Okay";
	endcase
	say (msg);
endfunction




///////////////////
//  Say OK for monsters
///////////////////

function BeastSayOkay()
	case (RandomInt (4))
		0: 		PlaySoundEffect (me, 0x60);
		1: 		PlaySoundEffect (me, 0x61);
		2:		PlaySoundEffect (me, 0xa4);
		default:
			case (RandomInt (10))
				0:		PrintTextAbove  (me, "*sneezes*");
				1:		PrintTextAbove  (me, "*pants*");
				2:		PrintTextAbove  (me, "*whimpers*");
				3:		PrintTextAbove  (me, "*looks playful*");
				4:		PrintTextAbove  (me, "*looks hopeful*");
				5:		PrintTextAbove  (me, "*sniffs air*");
				6:		PrintTextAbove  (me, "*groans*");
				7:		PrintTextAbove  (me, "*shakes himself off*");
				8:		PrintTextAbove  (me, "*stretches*");
				9:		PrintTextAbove  (me, "*looks curious*");
				default:	PrintTextAbove  (me, "*rolls over*");
			endcase
	endcase
endfunction




///////////////////
//  Attempts to resurrect the warrior
///////////////////

function ResurrectTownguard (byref corpse)
	set_critical (1);
	var master_serial := GetObjProperty (corpse, "master");
	if (!master_serial)
		set_critical (0);
		return 0;
	endif

	var mymaster := SystemFindObjectBySerial (master_serial, SYSFIND_SEARCH_OFFLINE_MOBILES );
	if (!mymaster)
		set_critical(0);
		return 0;
	endif

	var mynpctemplate := GetObjProperty (corpse, "npctemplate");
	if (!mynpctemplate)
		set_critical(0);
		SendSysMessage (mymaster, "unknown template " + CSTR(mynpctemplate) + ", can't res");
		return 0;
	endif
	var new_npc := CreateNpcFromTemplate (mynpctemplate, corpse.x, corpse.y, corpse.z);
	if (!new_npc)
		set_critical(0);
		return 0;
	endif

	SetObjProperty (new_npc, "master", master_serial);
	SetVital (new_npc, "Life", 1);
	if (GetObjProperty (corpse, "gender") )
		new_npc.gender := GetObjProperty (corpse, "gender");
		new_npc.graphic := 400 + new_npc.gender;
	endif
	
	if (GetObjProperty (corpse, "g") )
		SetObjProperty (new_npc, "g", GetObjProperty (corpse, "g"));
	endif
		
	new_npc.color := GetObjProperty (corpse, "color");
	SetObjProperty (new_npc, "gender", new_npc.gender);
	SetObjProperty (new_npc, "color", new_npc.color);
	var temp_string := corpse.desc;
	temp_string["A corpse of "] := "";
	new_npc.name := temp_string;

	var newbackpack := CreateItemAtLocation (4550, 3687  , 0, UOBJ_BACKPACK, 1);
	if (!EquipItem (new_npc, newbackpack))
		DestroyItem (newbackpack);
	endif

	foreach item in ListRootItemsInContainer (corpse)
		if (!EquipItem (new_npc, item))
			MoveItemToContainer (item, new_npc.backpack);
		endif
	endforeach

	if (GetObjProperty (corpse, "hairstyle"))
		var hairstyle := GetObjProperty (corpse, "hairstyle");
		if (hairstyle[1])
			var hair := CreateItemAtLocation (4550, 3687  , 0, CINT (hairstyle[1]), 1);
			hair.color := hairstyle[2];
			if (!EquipItem (new_npc, hair))
				DestroyItem (hair);
			endif
		endif
		if (hairstyle[3])
			var beard := CreateItemAtLocation (4550, 3687  , 0, CINT (hairstyle[3]), 1);
			beard.color := hairstyle[4];
			if (!EquipItem (new_npc, beard))
				DestroyItem (beard);
			endif
		endif
	endif

	DestroyItem (corpse);
	set_critical (0);
	return 1;
endfunction




///////////////////
//  Set this location as our homepoint that we'll return to if we wander away.
///////////////////

function MarkHomePoint()
	var homepoint := { };
	homepoint[1] := me.x;
	homepoint[2] := me.y;
	homepoint[3] := me.z;
	SetObjProperty( me, "#homepoint", homepoint );
endfunction




///////////////////
//  Once we've set out homepoint, this function later on recalls it and takes us there.
///////////////////

function WalkToMyHome()
	foreach mob in ListMobilesNearLocation (me.x, me.y, me.z, 5)
		if (CheckForCriminals (mob))
			GetHelp (mob);
			fight (mob);
			break;
		endif
	endforeach

	foreach mob in ListHostiles (me, 9);
		if (mob)
			GetHelp (mob);
			Fight (mob);
			break;
		endif
	endforeach

	var myhome := GetObjProperty (me, "#homepoint");
	if (!myhome)
		MarkHomePoint();
		return;
	endif

	if (me.x == myhome[1] and me.y == myhome[2])
		return;
	endif

	var ev;
	for i := 1 to 15
		WalkTowardLocation (myhome[1], myhome[2]);
		ev := wait_for_event (0);
		if (me.x == myhome[1] and me.y == myhome[2])
			return;
		endif
	endfor

	if (me.x != myhome[1] or me.y != myhome[2] )
		MoveObjectToLocation (me, myhome[1], myhome[2], myhome[3], 0);
	endif
endfunction




///////////////////
//  The NPC's normal state, where they use less CPU and wait for events.
///////////////////

function GuardSleepMode ()
	var ev;
	while (me)
		if (me.poisoned or GetVital (me, "Life") < CINT (GetVitalMaximumValue (me, "Life")))
			if (me.graphic == 400 or me.graphic == 401)
				ApplyHenchmanHealing (me);
			endif
		endif
		ev := os::wait_for_event (120);
		if (ev)
			case (ev.type)
				EVID_ENGAGED:
				EVID_DAMAGED:
					return ev;
				EVID_ALL_ATTACK_CMD:
					return ev;
				EVID_ENTEREDAREA:
					return ev;
				EVID_SPEECH:
					if (!ev.source.npctemplate)
						if (ev.source.serial == masterserial or ev.source.cmdlevel)
							return ev;
						endif
					endif
				EVID_DOUBLECLICKED:
					if (!ev.source.npctemplate)
						return ev;
					endif
				EVID_ITEM_GIVEN:
					if (!ev.source.npctemplate)
						return ev;
					endif
			endcase
		endif
	endwhile      
endfunction




///////////////////
//  Called when something enters our area to find out if its something that we should be attacking
///////////////////

function CheckForCriminals (byref jerk)
	if (jerk.dead)
		return 0;
	endif

	if (IsHostile (jerk))
		if (me.graphic == 400 or me.graphic == 401)
			say ("Ah ha! " + jerk.name);
		else
			PlaySoundEffect (me, 0x63);
		endif
		GetHelp (jerk);
		fight (jerk);
		WalkToMyHome ();
		return 1;
	elseif (jerk.npctemplate)
		return 0;
	endif

	if (jerk.criminal)
		if (jerk.serial == master)
			Say ("What sort of trouble have you gotten yourself into NOW?");
			return 0;
		endif
		if (me.graphic == 400 or me.graphic == 401)
			say ("Stop Criminal!");
		else
			PlaySoundEffect (me, 0x63);
		endif
		GetHelp (jerk);
		fight (jerk);
		WalkToMyHome ();
		return 1;
	endif
	return 0;
endfunction




///////////////////
//  warrior tries to use a bandage or potion
///////////////////

function ApplyHenchmanHealing (byref who)
	//if poisoned, the automatically cure themselves.  Probably shouldn't...
	if (me.poisoned)
		say ("I'm poisoned!");
	endif

	if (who.poisoned)
		if (checkskill (me, SKILLID_HEALING, 50, 0))
			CurePoison (who, 0, who.name + " has CURED you!");
			if (who == me)
				say ("*Whew!*  I'm cured!");
			endif
			return 1;
		endif
	endif

	if (GetVital (me, "Life") < 40)
		DrinkHeal ();
	endif

	if (distance (me, who) > 3)
		say (who.name + " is too far away!");
		return 1;
	endif

	if (GetObjProperty (me, "#heal") and GetObjProperty (me, "#heal") > readgameclock())
        	return 0;
	endif

	var parms := { };
	parms[1] := me;
	parms[2] := who;

	foreach item in EnumerateItemsInContainer (me.backpack)
		if ( item.objtype == UOBJ_BANDAGE)
			parms[3] := item;
			start_script (":healing:dohealing",parms);
			return 1;
		endif
	endforeach

	//this isn't needed for the healing script.  Instead it just makes the warrior shut up if
	//he's out of bandages and hurt
	SetObjProperty (me, "#heal", ReadGameClock() + 15);
	Say ("I don't have any bandages!");
	return 1;
endfunction




///////////////////
//  If we're really low on HP, try to drink a heal potion
///////////////////

function DrinkHeal ()
	if (CINT (GetObjProperty (me, "#potion")) > ReadGameClock()  )
        	return 0;
	endif

	foreach item in EnumerateItemsInContainer (me.backpack)
		if (item.objtype == UOBJ_HEAL_POTION or item.objtype == UOBJ_GREATER_HEAL_POTION)
			PlaySoundEffect (me, 0x32);
			PerformAction (me, ANIM_EAT);
			CreateItemInBackpack (me, UOBJ_EMPTY_BOTTLE, 1);
			var heal_amount;
			if (item.objtype == 0xDC02)
				heal_amount := RandomDiceRoll ("2d12+3");
			else
				heal_amount := RandomDiceRoll ("5d12+3");
			endif			
			HealDamage (me, heal_amount);
			SubtractAmount (item, 1);
			PlaySoundEffect (me,  0x1f3);
			SetObjProperty (me, "#potion", (ReadGameClock() + 20));
			return 1;
		endif
	endforeach

	SetObjProperty (me, "#potion", ReadGameClock() + 15);
	Say ("Ack, I don't have any healing potions!");
	return 0;
endfunction




///////////////////
//  called when the warrior's master double clicks on him
///////////////////

function OpenMyPack (byref theclicker)
	if (Distance (me, theclicker) > 1)
		return;
	endif

	if (!me.backpack)
		var newpack := CreateItemAtLocation (5288, 1176, 0, UOBJ_BACKPACK, 1);
		if (!EquipItem (me, newpack))
			DestroyItem (newpack);
		endif
	endif

	SendOpenSpecialContainer (theclicker, me.backpack);
endfunction




///////////////////
//  Tries to equip the given item
///////////////////

function WearItem (it, you := 0)
	foreach thing in ListEquippedItems (you)
		if (thing == it)
			Say ("But you're wearing that!");
			return;
		endif
	endforeach

	var mygear := ListWornItems (me);
	set_critical (1);
	foreach thing in mygear
		RemoveItem (thing, you.backpack);
	endforeach
	if (!ItemEquip (it))
		if (you)
			Say ("I can't wear that.  Maybe I'm not strong enough.");
			MoveItemToContainer (it, you.backpack);
		else
			MoveItemToContainer (it, me.backpack);
		endif
	endif
	foreach thing in mygear
		ItemEquip (thing);
	endforeach
	set_critical (0);
endfunction




///////////////////
//  tries to equip the given item, and put the owner's mark on it
///////////////////

function ItemEquip (item)
	var canequip := EquipItem (me, item);
	if (!canequip )
		return 0;
	endif

	//add the owner's mark:
	if (!GetObjProperty (item, "ownerserial"))
		var TheName := item.desc;
		SetObjProperty (item, "oldname", thename);
		var longname := splitwords(TheName);
		if (longname[1]=="a" or longname[1]=="an")
			TheName:="";
			foreach word in longname;
				if (word != longname[1])
					TheName := TheName + " "+ word;
				endif
			endforeach
			item.name := master.name+"'s" + TheName;
		else
			item.name := master.name+"'s " + TheName;
		endif
		item.buyprice := -1;
		SetObjProperty (item, "ownerserial", master.serial);
		SetObjProperty (item, "ownername", master.name);
	endif
	return canequip;
endfunction




///////////////////
//  Undresses, moving all equipped items to my backpack
///////////////////

function Undress ()
	SayOkay ();
	sleep (1);

	set_critical (1);
	foreach thing in ListWornItems (me)
		RemoveItem (thing, me.backpack);
	endforeach
	set_critical (0);
endfunction




///////////////////
//  Unequips the given item, moving it to the container, or if there's not a container, to the warrior's feet
///////////////////

function RemoveItem (item, container := 0)
	if (container)
		MoveItemToContainer (item, container);
	else
		MoveObjectToLocation (item, me.x, me.y, me.z, realm := _DEFAULT_REALM, flags := MOVEOBJECT_FORCELOCATION );
	endif
endfunction




///////////////////
//  March forward, if we've been told to
///////////////////

function DoMarching()
	var nextmove;
	if (!getobjproperty (me, "#nextmove"))
		nextmove := 0;
	else
		nextmove := getobjproperty (me, "#nextmove");
	endif

	if (nextmove > ReadGameClock())
		return;
	endif
	SetObjProperty (me, "#nextmove", ReadGameClock() + 1);

	if (!MarchForward())
		movestate := 0;
	endif

	if (!master.ip or distance (me, master ) > 15)
		movestate := 0;
	endif

	MarkHomePoint();
	sleep (1);

	if (!movestate)
		CheckTownLocation ();
	endif
endfunction




///////////////////
//  See if there's any other NPCs standing directly on top of the guards.  If so, they'll take a step.
///////////////////

function OtherGuardHere()
	foreach mob in ListMobilesNearLocation (me.x, me.y, me.z, 0);
		if (mob != me)
			return 1;
		endif
	endforeach
	return 0;
endfunction




///////////////////
//  NPC takes a step forward
///////////////////

function MarchForward ()
	var mex := me.x;
	var mey := me.y;
	case ( me.facing )
		0: Move ("N");
		1: Move ("NE");
		2: Move ("E");
		3: Move ("SE");
		4: Move ("S");
		5: Move ("SW");
		6: Move ("W");
		7: Move ("NW");
	endcase
	if ( me.x == mex and me.y == mey )
		return 0;
	else
		return 1;
	endif
endfunction




///////////////////
//  Equip everything we've got
///////////////////

function GetDressed ()
	foreach item in ListRootItemsInContainer (me.backpack)
		ItemEquip (item);
	endforeach
endfunction




///////////////////
//  Look for other guards in the area to help us out
///////////////////

function GetHelp (byref opponent)
	if (!opponent or opponent == master)
		return;
	endif
	
	if (opponent.guildid and !opponent.criminal)
		return;
	endif

	var eve := array;
	eve.+type := EVID_ALL_ATTACK_CMD;
	eve.+source := opponent;
	eve.+target := opponent;

	foreach mob in ListMobilesNearLocation (me.x, me.y, me.z, 10);
		if (mob.npctemplate and mob.npctemplate["guard"] and !mob.warmode and mob != me)
			SendEvent (mob, eve);
		endif
	endforeach
endfunction




///////////////////
//  Try a different pathfinding method to get to our opponent
///////////////////

function runrandom (byref opponent, numruns := 2)
	var stepstotake := (numruns)+4;
	var tox := me.x;
	var toy := me.y;
	var highx := tox - opponent.x;
	if ( highx < 0 ) highx := 0 - highx; endif
	var highy := tox - opponent.y;
	if ( highy < 0 ) highy := 0 - highy; endif

	case ( highy > highx )
	0:	//run along the x access
		case ( RandomInt(2) )
		0:	//to the right
			toy := (me.y - stepstotake);
			if (randomint(2)) tox := opponent.x; endif //to his x
		1:	//to the left
			toy := (me.y + stepstotake);
			if (randomint(2)) tox := opponent.x; endif //to his x
		endcase
	1:
		//run along the y access
		case( randomint(2) )
		0:	//to the right
			tox := (me.x - stepstotake);
			if (randomint(2)) toy := opponent.y; endif //to his y
		1:	//to the left
			tox := (me.x + stepstotake);
			if (randomint(2)) toy := opponent.y; endif //to his y
		endcase
	endcase

	var runs := 0;
	var ev;
	while ( (distance(me, opponent) > 0) and (runs <= stepstotake) )
		RunTowardLocation( tox, toy );
		OpenDoors(opponent);
		runs := runs +1;
		ev := wait_for_event(0);
		if (ev)
			case (ev.type)
			EVID_PEACEMADE: return 1;
			EVID_DAMAGED:
				AddToHitList(ev);
				if (ev.source.serial == opponent.serial)
					flee(opponent);
				endif
			endcase
		endif
		if ( (me.x == tox) and (me.y == toy) )
			return 0;
		endif
	endwhile

	return 0;
endfunction



///////////////////
//  Determines if we have a bow equipped, and, if so, if we have ammo for it
///////////////////

function HasBow ()
	var weapon := me.weapon;
	if (!weapon.objtype)
		ChangeWeapons();
		return 0;
	endif

	var ammotype := 0;
	case (weapon.objtype)
		0x13B2:
		0x26cc:
			ammotype := 0xf3f;//bow and arrows
		0x0f4f:
		0x13fd:
			ammotype := 0x1bfb;//xbow and bolts
		0x6050:
			ammotype := 0x6051;//firebow and firearrows
		default: return 0;
	endcase

	var myammo := EnumerateItemsInContainerOfObjtype (me.backpack, ammotype);
	if (!len(myammo))
		say ("No ammo!");
		ChangeWeapons ();
		return 0;
	endif
	return 1;
endfunction




///////////////////
//  Try to find a different weapon in my backpack to use
///////////////////

function ChangeWeapons ()
	var weapon := GetEquipmentByLayer(me,LAYER_HAND1);
	var shield := GetEquipmentByLayer(me,LAYER_HAND2);

	if (weapon)
		MoveObjectToLocation (weapon, me.x, me.y, me.z, realm := _DEFAULT_REALM, flags := MOVEOBJECT_FORCELOCATION );
	endif
	if (shield)
		MoveObjectToLocation (shield, me.x, me.y, me.z, realm := _DEFAULT_REALM, flags := MOVEOBJECT_FORCELOCATION );
	endif

	foreach item in ListRootItemsInContainer (me.backpack)
		EquipItem (me,item);
	endforeach

	if (weapon)
		MoveItemToContainer (weapon, me.backpack);
	endif
	if (shield)
		MoveItemToContainer (shield, me.backpack);
	endif
endfunction




///////////////////
//  Run away from our opponent
///////////////////

function flee (byref opponent)
	if (me.frozen or me.paralyzed)
		sleep (1);
		return;
	endif
	var runs := 0;
	var ev;
	if (me.graphic == 400 or me.graphic == 401)
		say("Aaaaiiiiiii!!!");
	else
		say("*whimper*");
	endif

	while (Distance (me, opponent) < 20 and runs < 50)
		RunAwayFrom (opponent);
		runs := runs + 1;
		ev := wait_for_event(0);
//		if (ev)
//			AddToHitList (ev);
//		endif
	endwhile

	RestartScript (me);
endfunction




///////////////////
//  Change back to our old weapons
///////////////////

function Rearm (byref oldweapon_one, byref oldweapon_two)
	var weapon := GetEquipmentByLayer (me, LAYER_HAND1);
	var shield := GetEquipmentByLayer (me, LAYER_HAND2);

	if (weapon == oldweapon_one and shield == oldweapon_two)
		return;
	endif

	if (weapon)
		MoveObjectToLocation(weapon, me.x, me.y, me.z, realm := _DEFAULT_REALM, flags := MOVEOBJECT_FORCELOCATION );
	endif

	if (shield)
		MoveObjectToLocation(shield, me.x, me.y, me.z, realm := _DEFAULT_REALM, flags := MOVEOBJECT_FORCELOCATION );
	endif

	EquipItem (me, oldweapon_one);
	EquipItem (me, oldweapon_two);

	if (weapon)
		MoveItemToContainer (weapon, me.backpack);
	endif
	if (shield)
		MoveItemToContainer (shield, me.backpack);
	endif
endfunction




///////////////////
//  Figures out if the NPC should guard the area that they're currently in (They'll still respond if attacked,
//  but they won't initiate combat with hostiles if they're not in their own town.)
///////////////////

function CheckTownLocation ()
	if (me.x > 5120 and me.y < 2300)
		guardtown := 0;
		if (me.graphic == 400 or me.graphic == 401)
			say ("This is not my home town, so I won't defend it.");
		else
			say("*Sits down*");
		endif
		if (me.strength_mod > 100)
			me.strength_mod := me.strength_mod - 100;
		endif
		return;
	endif
	
	var currenttown := FindCurrentTown();
	if (!currenttown)
		guardtown := 0;
		if (me.graphic == 400 or me.graphic == 401)
			say ("This is not my home town, so I won't defend it.");
		else
			say("*Sits down*");
		endif
		if (me.strength_mod > 100)
			me.strength_mod := me.strength_mod - 100;
		endif
		return;
	endif	
	
	var mytownnum := FindEmpireNum (GetObjProperty (me, "townnum"));
	var currenttownnum := FindEmpireNum (currenttown);
	guardtown := 0;
	if (mytownnum == currenttownnum)
		guardtown := 1;
		if (me.graphic == 400 or me.graphic == 401)
			say ("This is my home town, so I'll guard it");
		else
			say("*looks around aggressively*");
		endif
		if (me.strength_mod < 100)
			var diff := 100 - me.strength_mod;
			me.strength_mod := me.strength_mod + diff;
			SetVital (me, "Life", CINT(GetVital (me, "Life") + diff));
		endif
	else
		if (me.graphic == 400 or me.graphic == 401)
			say ("This is not my home town, so I won't defend it.");
		else
			say("*Sits down*");
		endif
		if (me.strength_mod > 100)
			me.strength_mod := me.strength_mod - 100;
		endif
	endif
endfunction




///////////////////
//  Finds the nearest townstone and returns the townnumber of that stone
///////////////////

function FindCurrentTown()
	if (me.x > 5120 and me.y < 2300)
		return 0;
	endif
	var stone := FindMyStone (me);
	if (!stone or Distance (me, stone) > 400)
		return 0;
	endif

	return GetObjProperty (stone, "townnum");
endfunction





///////////////////
//  Finds the townstone that the warrior is sworn to and figures out the empire number
///////////////////

function FindEmpireNum (townnum)
	var stoneserial := GetGlobalProperty ("Townstone"+townnum);
	var stone := SystemFindObjectBySerial (stoneserial);
	var fealty := CINT (GetObjProperty (stone, "fealty"));
	if (fealty)
		return fealty;
	else
		return townnum;
	endif
endfunction




///////////////////
//  Occasionally checks to see if its time to collect my pay
///////////////////

function CollectPay ()
	var lastpay := GetObjProperty (me, "lastpay");
	if (!lastpay)
		SetObjProperty (me, "lastpay", ReadGameClock());
		return;
	endif
	
	if ((lastpay + 86400) > ReadGameClock() )
		return;
	endif

	//Time to collect my pay
	var mygold := GetObjProperty (me, "g");
	if (!mygold)
		mygold := 0;
	endif
	
	mygold := mygold - 1000;
	if (mygold < (0-3000))
		KillMe ();
		return;
	endif
	
	SetObjProperty (me, "g", mygold);
	SetObjProperty (me, "lastpay", ReadGameClock());
endfunction




///////////////////
//  Ride a horse
///////////////////

function MountHorse(horse)

	if (!horse.script ["tamed"])
		Say ("I don't know... looks kind of wild, to me.");
		return;
	elseif (GetObjProperty (horse, "master") != masterserial )
		Say ("Howzabout you lemme ride YOUR horse?");
		return;
	endif

	var mounttype := 0;
	case (horse.graphic)
	0xcc: //dark brown/horse
			mounttype := 0x3ea2;
	0xc8: //lightbrown/horse2
			mounttype := 0x3e9f;
	0xe2: //light grey/horse3
			mounttype := 0x3ea0;
	0xe4: //greybrown/horse4
			mounttype := 0x3ea1;
	0xdc: //Llama:
			mounttype := 0x3ea6;
	0xd2: //desert
			mounttype := 0x3ea3;
	0xda: //frenzied
			mounttype := 0x3ea4;
	0xdb: //forest
			mounttype := 0x3ea5;
	endcase

	if (!mounttype)
		Say ("Well how am I supposed to ride THAT?");
		return;
	endif

	if (mounttype)
		if ( MoveObjectToLocation(me,horse.x,horse.y,horse.z,0) )
			set_critical(1);
			me.facing := horse.facing;
			var mount := CreateItemAtLocation(4550, 3687  , 0, 0xF021,1);
			mount.color := horse.color;
			setobjproperty(mount,"petname",horse.name);
			setobjproperty(mount,"pethp",horse.hp);
			setobjproperty(mount,"petmana",horse.mana);
			setobjproperty(mount,"freetime",ReadGameClock()+1200);
			mount.graphic := mounttype;
			MoveObjectToLocation(horse, 4550, 3687  , 0, realm := _DEFAULT_REALM, flags := MOVEOBJECT_FORCELOCATION );
			setobjproperty(horse,"guardkill",1);
			applyrawdamage(horse,horse.maxhp);
			EquipItem(me,mount);

			if (horse)
				MoveObjectToLocation(horse, 4550, 3687  , 0,
				 realm := _DEFAULT_REALM, flags := MOVEOBJECT_FORCELOCATION );
				setobjproperty(horse,"guardkill",1);
				applyrawdamage(horse,horse.maxhp);
			endif
			set_critical(0);
		endif
	endif
endfunction




///////////////////
//records the henchperson's stats so that, if they die, they can be resurrected intact.
///////////////////

function RecordStats ()
	var hairstyle := array;
	var myhair := GetEquipmentByLayer (me, LAYER_HAIR);
	if (myhair)
		hairstyle[1] := myhair.objtype;
		hairstyle[2] := myhair.color;
	else
		hairstyle[1] := 0;
		hairstyle[2] := 0;
	endif

	var mybeard := GetEquipmentByLayer (me, LAYER_BEARD);
	if (mybeard)
		hairstyle[3] := mybeard.objtype;
		hairstyle[4] := mybeard.color;
	else
		hairstyle[3] := 0;
		hairstyle[4] := 0;
	endif

	SetObjProperty (me, "hairstyle", hairstyle);
endfunction




///////////////////
//  This really isn't called when the guard is created, since they spawn with the warrior script, but might be used when
//  they get resurrected
///////////////////

function DoOnCreationSetup ()
	var newbackpack := CreateItemAtLocation (4550, 3687  , 0, UOBJ_BACKPACK, 1);
	if (!EquipItem (me, newbackpack))
		DestroyItem (newbackpack);
	endif

	me.gender := RandomInt (2);
	if (me.graphic == 400 or me.graphic == 401)
		me.graphic := 400 + me.gender;

		var robe := CreateItemAtLocation (4550, 3687  , 0, 0x1f03, 1);
		if (!EquipItem (me, robe))
			DestroyItem (robe);
		endif
	else
		me.color := RandomInt (16) + 1134;
		me.gender := RandomInt (2);
		SetObjProperty (me, "color", me.color);
	endif

	me.name := RandomName (me);
endfunction


