var GEO_CITRINE      := 0xf15;
var GEO_TOURMALINE   := 0xf18;
var GEO_AMBER        := 0xf25;
var GEO_RUBY         := 0xf13;
var GEO_AMETHYST     := 0xf16;
var GEO_EMERALD      := 0xf10;
var GEO_STARSAPPHIRE := 0xf0f;
var GEO_SAPPHIRE     := 0xf11;
var GEO_DIAMOND      := 0xf30;

var GEO_BOOST_DAMAGE := 1.2;
var GEO_BOOST_INVOCATION := 1.33;
var GEO_BOOST_HEALING := 1.33;
var GEO_BOOST_SUMMONDURATION := 2;
var GEO_BOOST_BUFFS := 1.2;
var GEO_REDUCE_MANACOST := 0.8;

// me - the caster
// gem - objtype of the gem to burn
// bonus - the numerical bonus to multiply by if geomancy goes off

function perk_geomancy(me,gem,bonus,debug := 0)
	debug := me;

	var power := PerkPower(PERKID_GEOMANCY,me);
	if ( power )
		if ( power > random(100) ) // geomancy activation
			if (debug)
//				sendsysmessage(debug,"Geomancy trigger");
			endif
			if ( burngem(me,gem,1,(100-(power*4/5)),debug) ) // gem burn or pass check
				if (debug)
//					sendsysmessage(debug,"Geomancy success");
				endif
				
				return bonus; // we get the bonus
			endif
		endif
	endif
	
	if (debug)
//		sendsysmessage(debug,"Geomancy failure");
	endif	
	
	return 1;
endfunction

function gemlen(queue,debug := 0)
	var sweep := GetGlobalProperty(queue + "_queue");
	
	return len(sweep);
endfunction

// gem "decoration" commands
// used for geomancy and geostone seer commands

function burngem(me,gem,quantity,chance,debug := 0)
	var r:= random(100);
	
//	sendsysmessage(debug,"Burngem Start");
	if (HasRegs(me, gem,1))
//		sendsysmessage(debug,"Burngem Objtype Found");
		if (r < chance)
			if (ConsumeSubstance(me.backpack,gem,quantity))
				razzledazzle(me,gem); // special effect
				
//				sendsysmessage(debug,"Burngem Consume");
				return 1;
			else
//				sendsysmessage(debug,"Burngem Consume Failure");
				return 0;
			endif
		endif
	else
		if (debug)
//			sendsysmessage(debug,"None of that substance");
		endif
	
//		sendsysmessage(debug,"Burngem Failure");
		return 0;
	endif
	
//	sendsysmessage(debug,"Burngem Success");
	return 1;
endfunction

function razzledazzle(me,gemot)
	var x,y,z;	
	var j:=0;
	var gem:=0;

	x := me.x+6-random(11);
	y := me.y+6-random(11);
	z := GetMapInfo(x,y).z;

	
	while ( ( !CheckLosAt( me, x, y, z ) ) && (j<10) )
		x := me.x+6-random(11);
		y := me.y+6-random(11);
		z := GetMapInfo(x,y).z;
			
		j:=j+1;
	endwhile

	gem := placegem("gq_geomancy",gemot,x,y,z);

	if (gem)
		PlayStationaryEffect (x,y-1,z, FX_SPARK_EFFECT, 7, 0x10,0);
	endif
endfunction

function placegem(queue,ot,x,y,z)
	var gem := CreateItemAtLocation (x, y, z, ot, 1);
		
	if (gem)
		gem.movable := 0;
		set_critical (1);
		pushgem(queue,gem);
		set_critical (0);
		
		return gem;
	endif
	
	return 0;
endfunction

function pushgem(queue,gem,debug := 0)
	var sweep;
	
	sweep := GetGlobalProperty(queue + "_queue");
	
	if (!sweep)
		sweep := {gem.serial};
	else
		sweep.append(gem.serial);
	endif
	
	SetGlobalProperty(queue + "_queue",sweep);
	
	if (debug)
		SendSysMessage(debug,"in : (" + sweep + ")");
	endif
endfunction

function popgem(queue,debug := 0)
	var sweep,gem;
		
	sweep := GetGlobalProperty(queue + "_queue");
	if (!len(sweep))
		return 0;
	endif
	
	gem := sweep[1];
	sweep.erase(1);
	
	SetGlobalProperty(queue + "_queue",sweep);
	
	if (debug)
		SendSysMessage(debug,"out obj : (" + gem + ")");
	endif	
	
	return gem;
endfunction

function HasRegs(caster, what, amt)
	foreach item in EnumerateItemsInContainer (caster.backpack)
		if ( (item.objtype == what)  and (item.amount >= amt) )
			return item;
		endif
	endforeach

	return 0;
endfunction
