use attributes;

const PERKID_FINESSE := 1;
const PERKID_OVERBEAR := 2;
const PERKID_BREACH := 3;
const PERKID_MAGICBLOW := 4;
const PERKID_NINJA := 5;
const PERKID_GEOMANCY := 6;
const PERKID_FIREWALKER := 7;
const PERKID_MIKAYLASMETHOD := 8;
const PERKID_SKULK := 9;
const PERKID_FLANK := 10;
const PERKID_VILENESS := 11;
const PERKID_VIRTUOSITY := 12;
const PERKID_PYROMANIA := 13;
const PERKID_OVERSEER := 14;
const PERKID_CRITICALHIT := 15;
const PERKID_RESONANCE := 16;
const PERKID_ADRENALINE := 17;
const PERKID_BATTLEHONED := 19;

function DamageReroll(rawdamage,debug := 0)
	var olddamage := rawdamage;
			
	CalculateAttackDamage (rawdamage);
			
	if (debug)
		SendSysMessage(debug,"damage : " + olddamage + "," + rawdamage);
	endif

	if (olddamage > rawdamage)
		rawdamage := olddamage;
	endif
			
	if (debug)
		SendSysMessage(debug,"newdamage : " + rawdamage);
	endif
	
	return rawdamage;
endfunction

function TimeCap(me,name, time)
	var vname := "#TC_" + name;
	var tc := GetObjProperty (me,vname);
//	PrintTextAbove(me,tc);
	if (tc and tc > ReadGameClock())
		return 1;
	else
		SetObjProperty (me, vname, ReadGameClock()+time);
		return 0;
	endif
	
	return 0;
endfunction

// I am not going to spend my first big pol project tearing my hair out over
// PoL's graceless way of handling uninitialized variables.  I decree everything
// will be initalized, and I will use these functions to do so.  Huzzah!
function VarInit(x,ini)
	if (!x)
		x:=ini;
	endif
	
	return x;
endfunction

function GetOPI(me, name, ini)
	var x;
	x := GetObjProperty (me,name);
	
	x := VarInit(x,ini);

	return x;
endfunction

// it's a scripting language, dammit, "25" should be equal to CInt("25")
function IntifyArray(a)
	var i;
	
	if (len(a))
		for (i:=1;i<len(a)+1;i:=i+1)
			a[i] := CInt(a[i]);
		endfor
	endif
	
	return a;
endfunction

function InArray(item,a,me := 0)	
	foreach x in a
		if (me)
			SendSysMessage(me,x + " ? " + item);
		endif
		
		if (item == x)
			if (me)
				SendSysMessage(me,"yes");
			endif
			
			return 1;
		endif
	endforeach
	
	if (me)
		SendSysMessage(me,"no");
	endif
	
	return 0;
endfunction

/*

perk related objprops:

p_xpbuffer : xp that will be added next time we go through the xp process
p_xp : perk xp list

p_on : list of on perks
#p_onable : list of activatable perks
#p_onablecheck : a "note to self" if we've checked if any perks are onable.

#p_overbuff : the perk which controls our supreme buff, one and only one should be on
p_overbufflist

#p_perkpower : cached perk power

*/

function PerkGetUsableList(me)
	var onablecheck := GetOPI (me,"#p_onablecheck",0);
	if (!(onablecheck))
		PerkNoteUsables(me);
	endif
	
	return GetOPI (me,"#p_onable",{});
endfunction

function UseThisPerk(me, perk)
	return GetOPI (me,"p-on",{});
endfunction

function PerkGetOnList(me)
	return GetOPI (me,"p_on",{});
endfunction

function PerkOff(perk,me)
	var on := PerkGetOnList(me);
	var act := 0;
	var i;

	for (i:=1;i<len(on)+1;i:=i+1)
		if (on[i] == perk)
			on.erase(i);
			act := 1;
		endif
	endfor

	if (act)
		var config := ReadConfigFile(":perks:perk");
		SendSysMessage(me,"The perk " + config[perk].name + " is now off.");

		// force the perk power to be recalculated
		SetObjProperty(me,"#p_perkpower" + perk,-1);
		
		SetObjProperty (me,"p_on",on);	
		
		return 1;
	endif

	return 0;
endfunction

function PerkOn(perk,me)
	var on := PerkGetOnList(me);
	var onable := PerkGetUsableList(me);
	var act := 0;

	var config;
	
	if (InArray(perk,onable))
		config := ReadConfigFile(":perks:perk");
		
		if (config[perk].active == 0)
			SendSysMessage(me,"Perk " + perk + " has been disabled.");
		else
			on.append(perk);
			act := 1;
		endif
	else
		SendSysMessage(me,"Perk " + perk + " activation failed!");
	endif

	if (act)
		config := ReadConfigFile(":perks:perk");
		SendSysMessage(me,"The perk " + config[perk].name + " is now on.");

		// force the perk power to be recalculated
		SetObjProperty(me,"#p_perkpower" + perk,-1);
		
		SetObjProperty (me,"p_on",on);	
		
		return 1;
	endif

	return 0;
endfunction

function PerkToggle(perk,me)
//	var onable := PerkGetUsableList(me);	
	var on := PerkGetOnList(me);
//	var i;
		
	if (InArray(perk,on)) // turn off
		PerkOff(perk,me);
	else // turn on
		PerkOn(perk,me);
	endif
endfunction

/*
  This is the big function.  Normally it would be (me,perk), but I reversed the
order so you could do a string search on "Perkpower(5" to find all of the places
perk 5 is used.
  The function returns 0 to 100.  You should:
  
  0 - do nothing
  1-100 - do the perk, using the value of power to determine how effective the perk is.
   
*/

function PerkPower(perk,me,force := 0,frac := 0)

	var debug := 0;
	if (debug)
		debug:=me;
	endif

	if (force == 0)
		var pp := GetOPI(me,"#p_perkpower" + perk,-1);
		
//		sendsysmessage(me,"cached value for perk " + perk + " : " + pp);
		
		if (TimeCap(me,"p_perkpowercheck" + perk,60))
			if (pp != -1)
//				sendsysmessage(me,"returning cached value");
				return pp;
			endif
		endif
	endif


	var on := GetOPI (me,"p_on",{});
	if (!(InArray(perk,on)))
		SetObjProperty(me,"#p_perkpower" + perk,0);
		return 0; // It's not on.  Power is zero.
	endif
	
	var onablecheck := GetOPI (me,"#p_onablecheck",0);
	if (!(onablecheck))
		PerkNoteUsables(me);
	endif
	var onable := GetOPI (me,"#p_onable",{});
	
//	SendSysMessage(me,"perk : onable check");
	if (!(InArray(perk,onable)))
		SendSysMessage(me,"perk : On but not onable!");
		
		// it's on... but it shouldn't be?  Thor is confused.
		// we will fix this condition with radical surgery
		
		perktoggle(perk,me);	
		
		return 0;
	endif	

	var config := ReadConfigFile(":perks:perk");	
	
//	SendSysMessage(me,"perk : configuration check");
	// sanity check
	if (cint(config[perk].perkid) != cint(perk))
	
		SendSysMessage(me,"perk : Misconfiguration!");
		SendSysMessage(me,"perk : " . config[perk].perkid);
		SendSysMessage(me,"perk : " . perk);
		
		// we wouldn't know what to do with you anyway
		
		perktoggle(perk,me);
	
		return 0;
	endif
	
//	SendSysMessage(me,"perk : disabled check");
	// has this perk been deliberately disabled?
	if (config[perk].active == 0)
		SendSysMessage(me,"perk : Disabled!");
		// die!
		
		perktoggle(perk,me);
	
		return 0;
	endif
	
	// we've established that it exists, is on, is onable, and hasn't been disabled
	var power := cdbl(0);
	
	// who am i?
	var mynature := 0;
	if (me.acctname)
		mynature := 1;	// pc
	elseif (me.master)
		mynature := 2;	// friendly npc
	else
		mynature := 16;	// some kind of monster
	endif

	
	// step 1 : power from skills
	
	// skills that you need
	var good := IntifyArray(SplitWords( VarInit(config[perk].must,"") + " " + VarInit(config[perk].should,"")));
	// skills that actively hinder the perk
	var bad := IntifyArray(SplitWords(VarInit(config[perk].shouldnt,"")));	
	var count := 0;
	var skill,temp;
	
	// good skills, if above the threshhold, add to power.
	foreach item in good
		count := count + 1;
		skill := GetAttribute (me, GetAttributeIDBySkillID (item));
		
		if ((mynature < 8) && (skill > 130))
			// only so much power mortals are meant to bear
			skill := 130;
		endif
		
		temp := cdbl(skill - 70)*0.833;  // temp should be 0 for a skill of 80
		power := power + temp;
		
		if (debug)
			SendSysMessage(me,"skill : " + item + " bonus : " + temp);
		endif
	endforeach
	
	// bad skills just subtract power
	foreach item in bad
		skill := GetAttribute (me, GetAttributeIDBySkillID (item));

		if (skill>40)
			temp := cdbl(0) - (cdbl(skill)-40)/2;
			power := power + temp;
			
			if (debug)
				SendSysMessage(me,"skill : " + item + " penalty : " + temp);
			endif
		endif
	endforeach	
	
	power := (power/count) + 1;
	
	if (debug)
		SendSysMessage(me,"skill net : " + power);
	endif
	
	// step 2 : power from experience	
	var Axp := GetOPI(me,"p_xp",{});
	var xp := VarInit(Axp[perk],0);
	
	if (xp < 0)
		xp := 0;
	elseif (xp > 49999)
		xp := 49999;
	endif

/*
	// grandfather in the old system
	// the old system also ranged from 0 to 50000, but it covered many abilities
	var expamount := GetOPI (me , "combatvirtue", 0);	
	// since each perk has it's own xp scale, 1 for 3 is quite generous.
	expamount := cint(expamount / 3);
	
	if (expamount > xp)
		xp := expamount;
	endif
*/
	
	if (debug)
		SendSysMessage(me,"xp : " + xp + " xp net : " + cdbl(xp/1000));	
	endif
		
	power := power + (cdbl(xp)/1000);
	
	
	// step 3 : perks are more powerful if they are the only ones on
	// people just starting out with perks won't care, but true masters
	// will be able to tell the difference.
	
	var powercap := 110;
	powercap := powercap - (VarInit(len(on),1)*10);
	
	// step 4 : check for endpoints and return
	if (power > powercap)
		power := powercap;
	endif


	// step 5 : halve for non-playes	
	if (mynature != 1)
		power := cint(power/2);
	endif


	// step 6 : cap checks and casting
	if (!frac)
		if (power < 1)
			power := 1;
		endif
				
		power := cint(power);	
	else
		power := power * 10;
		power := cdbl(cint(power));
		power := power / 10;
	endif
	
	if (debug)
		SendSysMessage(me,"power returned : " + power);		
	endif
	
	SetObjProperty(me,"#p_perkpower" + perk,power);
	return power;
endfunction

/*
  This function makes a list of all of the perks I can use and stores it.
  
  Call after specs change.
*/

function PerkNoteUsables(me)
	if (!GetObjProperty (me, "primary1"))
		if (GetObjProperty (me, "primary1") != 0)
			return {};
		endif
	endif

//	load specs (except for crafting)
	var spec := {};
	foreach item in {"primary1","primary2","primary3","secondary1","secondary2","secondary3","tradeskill"}
		spec.append(GetOPI(me,item,-1));
	endforeach
	
	var config := ReadConfigFile(":perks:perk");

	var total := GetConfigMaxIntKey(config);
	var i := 1;

	var must,should,cant;
	var count;
	var yes;
	var onable := {};

//	SendSysMessage (me, " s: '" + spec + "'");

//	SendSysMessage (me, SplitWords(""));
			
	for (i;i<=total;i:=i+1)
		must := IntifyArray(SplitWords(VarInit(config[i].must,"")));
		should := IntifyArray(SplitWords(VarInit(config[i].should,"")));
		cant := IntifyArray(SplitWords(VarInit(config[i].cant,"")));
		
		count := 0;
		yes := 1;

//		SendSysMessage (me, i + " must : '" + must + "'");
//		SendSysMessage (me, i + " should : '" + should + "'");
//		SendSysMessage (me, i + " cant : '" + cant + "'");
		
//		all musts must be specced
		foreach item in must
			if (InArray(item,spec))
				count := count + 1;
			else
				yes := 0;
//				SendSysMessage (me, "(must (" + item + ")) I can't use perk " + i);
			endif
		endforeach
		
//		at least one from must and should has to be specced
		if (yes)
			foreach item in should
				if (InArray(item,spec))
					count := count + 1;
				endif
			endforeach
		endif

//		no cants can be specced
		if (yes && count)		
			foreach item in cant
				if (InArray(item,spec))
//					SendSysMessage (me, "(cant " + item + ") I can't use perk " + i);
					yes := 0;
				endif
			endforeach
		endif

//		if everything is good to go, put it on the list		
		if (count && yes)
			onable.append(i); 
		endif
	endfor
	
//	SendSysMessage (me, "I can use perks " + onable);
	SetObjProperty (me,"#p_onable",onable);
	SetObjProperty (me,"#p_onablecheck",1);
	
//	if speccing disables perks, turn them off
	var on := PerkGetOnList(me);
	foreach item in on
		if (!(item in onable))
			PerkOff(item,me);
		endif
	endforeach
endfunction

/* 
  This function is called to add perk experience.  It gives a randomly
selected perk an xp boost.  The higher the xp, the less likely the xp is
to go up.

  It needs to be called wherever combat virtue was incremented.
*/

function PerkAddXP(me,award)
//	sendsysmessage(me,"perkaddxp running");
	var config := ReadConfigFile(":perks:perk");

	var Aon := GetOPI (me,"p_on",{});
	var c := len(Aon);

	// if no perks are on, leave	
	if (c<1)
		return;
	endif

	if (PerkPower(PERKID_ADRENALINE,me))
		set_critical(1);
		var adren := GetOPI (me,"p_adren",0);
		adren := adren + award;
		setobjproperty(me,"p_adren",adren);
		set_critical(0);
	endif

	var xp := GetOPI (me,"p_xpbuffer",0);
	xp := xp + award;

	var Axp := GetOPI(me,"p_xp",{});
	
//	if a perk has been turned off, leak it's xp into the award function.
	var i;
	i:=RandomInt( (GetConfigMaxIntKey(config)) +1);
//	SendSysMessage(me,"1 - Recovery selection : " + config[i].name + ".", FONT_NORMAL, 41);
	if (config[i].active == 0)
//		SendSysMessage(me,"2 - Confirmed inactive : " + config[i].name + ".", FONT_NORMAL, 41);
		if (Axp[i] > 0)
			Axp[i] := Axp[i] - 1;
			xp := xp + 1;
			SendSysMessage(me,"XP recovery : " + config[i].name + "", FONT_NORMAL, 41);
		endif
	endif
		
//	add perk xp at most three times a minute
	if (!TimeCap(me,"perkaddxp",20))		
		var r,s;
		r := Random(c)+1;		// pick one of the on perks at random
		s := Aon[r];			// get the perk id for that perk
		
		if (Random(49999) > Axp[s])	// slow the gain as xp rises.
			Axp[s] := xp + Axp[s];	// add the xp

			SendSysMessage(me,"The perk " + config[s].name + " improves!", FONT_NORMAL, 41);
			
			if (Axp[s] > 49999)
				Axp[s] := 49999;
			endif
		endif
		
		xp := 0;			// reduce the xp buffer to zero
	endif
	
	SetObjProperty (me,"p_xp",Axp);	
	SetObjProperty (me,"p_xpbuffer",xp);
endfunction

/*
All your life you had to stand in line
Still you're standing on your feet
All your choices made you change your mind
Now your calendar's complete
Don't wait for answers
Just take your chances
Don't ask me why 
*/
