// Common gump work for crafting skills

// Sets up the basic empty gump
function craftinggumpsetup(byref layout, byref data, gumpname)
	layout := {
		"nodispose",
		"page 0",
		"resizepic 50 50 5054 700 500",			// background and frame
		"gumppictiled 60 60 680 20 2624",		// title area
		"gumppictiled 60 85 680 20 2624",		// subtitle area
		"gumppictiled 60 110 235 335 2624",		// data area left
		"gumppictiled 300 110 440 335 2624",	// data area right
		"gumppictiled 60 450 680 90 2624",		// data area bottom
		"checkertrans 60 60 720 480",
		"htmlgump 60 60 740 20 0 0 0",
		"htmlgump 70 85 100 20 1 0 0",
		"htmlgump 310 85 100 20 2 0 0",
		"htmlgump 580 85 50 20 3 0 0",
		"htmlgump 650 85 50 20 4 0 0",
		"htmlgump 710 85 50 20 5 0 0"
	};
		
	data := {
		"<basefont color=#ffffff><center>" + gumpname + "</center>",
		"<basefont color=#ffffff>Item Type",
		"<basefont color=#ffffff>Selection",
		"<basefont color=#ffffff><div align=right>Skill",
		"<basefont color=#ffffff><div align=right>Material",
		"<basefont color=#ffffff>Info"
	};
endfunction

// Generic portion of craft skills gump, returns an array to translate
// button imput back to item to be made.
function craftinggump(byref layout, byref data, craftmenu, cfgfile)
	//	Add the submenus to the left panel on page 0
	var entry := FindConfigElem (cfgfile, craftmenu);
	var lineoffset := 0;
	var pageoffset := 0;
	var menuentry := array {};
	var itemarray := array {};
	foreach submenu in GetConfigStringArray(entry, "Submenu")
		layout.append("htmlgump 100 " + (120 + 20*lineoffset) + " 100 20 " + (data.size()) + " 0 0");
		layout.append("button 65 " + (117 + 20*lineoffset) + " 4005 4007 0 " + (lineoffset+3) + " 0");
		data.append("<basefont color=#ffffff>" + submenu);
		lineoffset := lineoffset + 1;
		menuentry[lineoffset] := submenu;
	endforeach

	// Add in quantity to make selections to page 2
	// deduct 100 from the return value of the button to get the quantity to be made
	layout.append("Page 2");
	var i;
	for (i := 0 ; i < 10 ; i := i + 1)
		layout.append("htmlgump 340 " + (120 + (20*i) ) + " 100 20 " + data.size() + " 0 0");
		layout.append("button 305 " + (117 + (20*i)) + " 4005 4007 1 0 " + (101 + i));
		data.append("<basefont color=#ffffff>" + (i+1));
	endfor

	// Next add the individual menu pages
	lineoffset := 0;
	foreach submenu in menuentry
		entry := FindConfigElem (cfgfile, submenu);
		layout.append("Page " + (pageoffset+3));
		foreach menuitem in GetConfigStringArray(entry, "Entry")
		// Since the above line appears to be reading the hex values as actual numbers and
		// not as strings I am going to have to deal with it myself (I hate this)
			var hexmenuitem := cstr(hex(menuitem));
			if (len (hexmenuitem) == 5)
				hexmenuitem := hexmenuitem[1,2] + "0" + hexmenuitem[3,3];
			endif
			entry := FindConfigElem (cfgfile, hexmenuitem);		
			if (entry)
				var displayname := upper(entry.name[1,1]) + entry.name[2,len(entry.name)-1];
				var materialinfo := splitcomponent(entry.material);
				layout.append("htmlgump 340 " + (120 + 20*lineoffset) + " 250 20 " + (data.size()) + " 0 0");
				// The build button for each item, to use subtract 1000 and use that as the array
				// entry in the array returned by this function
				layout.append("button 305 " + (117 + 20*lineoffset) + " 4005 4007 1 0 " + (itemarray.size()+1+1000));
				data.append("<basefont color=#ffffff>" + displayname);
				layout.append("htmlgump 580 " + (120 + 20*lineoffset) + " 50 20 " + (data.size()) + " 0 0");
				data.append("<basefont color=#ffffff><div align=right>" + entry.skill);
				layout.append("htmlgump 650 " + (120 + 20*lineoffset) + " 50 20 " + (data.size()) + " 0 0");
				data.append("<basefont color=#ffffff><div align=right>" + materialinfo[2]);
				// The info button for each item, to use subtract 2000 and use that as the array
				// entry in the array returned by this function
				layout.append("button 705 " + (117 + 20*lineoffset) + " 4011 4013 1 0 " + (itemarray.size()+1+2000));
				itemarray[itemarray.size()+1] := hexmenuitem;
				lineoffset := lineoffset + 1;
			endif
		endforeach
		pageoffset := pageoffset + 1;
		lineoffset := 0;
	endforeach

	return itemarray;
endfunction


// Displays specific data for items
function displayitemdata(character, itemarray, cfgfile, item)
	
	var layout := {
		"nodispose",
		"page 0",
		"resizepic 50 50 5054 300 400",			// background and frame
		"gumppictiled 60 60 280 20 2624",		// title area
		"gumppictiled 60 85 280 350 2624",		// data area 
		"checkertrans 60 60 280 380"
	};
		
	var data := {};
	
	var selection := 1;	
	while (selection) 
		// Label of the item being displayed
		var iteminfo := FindConfigElem (cfgfile, itemarray[item]);
		var materialinfo := splitcomponent(iteminfo.material);
		
		layout.append("htmlgump 60 60 300 20 " + data.size() + " 0 0");
		data.append("<basefont color=#ffffff><center>" + upper(iteminfo.name[1,1]) + iteminfo.name[2,len(iteminfo.name)-1] + "</center>");
		
		// Picture of the item being displayed
		if (iteminfo.graphic)
			layout.append("tilepic 240 100 " + iteminfo.graphic);
		else
			layout.append("tilepic 240 100 " + cint (itemarray[item]));
		endif
	
		// Skill required to make and for each upgrade level
		layout.append("htmlgump 70 90 250 20 " + data.size() + " 0 0");
		data.append("<basefont color=#ffffff>Skill required");
		
		layout.append("htmlgump 70 110 250 20 " + data.size() + " 0 0");
		data.append("<basefont color=#ffffff>Base item:");
		layout.append("htmlgump 150 110 50 20 " + data.size() + " 0 0");
		data.append("<basefont color=#ffffff><div align=right>"+iteminfo.skill);
		
		if (iteminfo.hasquality)
			var skill := iteminfo.skill + 15;
			if (skill > 110)
				skill := 110;
			endif
			layout.append("htmlgump 70 130 250 20 " + data.size() + " 0 0");
			data.append("<basefont color=#ffffff>Quality item:");
			layout.append("htmlgump 150 130 50 20 " + data.size() + " 0 0");
			data.append("<basefont color=#ffffff><div align=right>" + skill);
			
			skill := iteminfo.skill + 25;
			if (skill > 110)
				skill := 110;
			endif
			layout.append("htmlgump 70 150 250 20 " + data.size() + " 0 0");
			data.append("<basefont color=#ffffff>Exceptional item:");
			layout.append("htmlgump 150 150 50 20 " + data.size() + " 0 0");
			data.append("<basefont color=#ffffff><div align=right>" + skill);
		endif
		
		// Material required to make and for each upgrade level
		layout.append("htmlgump 70 180 250 20 " + data.size() + " 0 0");
		data.append("<basefont color=#ffffff>Material required");
				
		layout.append("htmlgump 70 200 250 20 " + data.size() + " 0 0");
		data.append("<basefont color=#ffffff>Base item:");
		layout.append("htmlgump 150 200 50 20 " + data.size() + " 0 0");
		data.append("<basefont color=#ffffff><div align=right>" + materialinfo[2]);
		layout.append("htmlgump 205 200 200 20 " + data.size() + " 0 0");
		data.append("<basefont color=#ffffff>" + materialinfo[1]);
		if (iteminfo.hasquality)
			layout.append("htmlgump 70 220 250 20 " + data.size() + " 0 0");
			data.append("<basefont color=#ffffff>Each upgrade:");
			layout.append("htmlgump 150 220 50 20 " + data.size() + " 0 0");
			data.append("<basefont color=#ffffff><div align=right>" + materialinfo[2]/2);
			layout.append("htmlgump 205 220 200 20 " + data.size() + " 0 0");
			data.append("<basefont color=#ffffff>" + materialinfo[1]);
		endif
		
		// previous and next buttons
		layout.append("htmlgump 95 420 100 20 " + data.size() + " 0 0");
		layout.append("button 60 417 4014 4016 1 0 1");
		data.append("<basefont color=#ffffff>Previous page");
				
		layout.append("htmlgump 210 420 100 20 " + data.size() + " 0 0");
		layout.append("button 310 417 4005 4007 1 0 2");
		data.append("<basefont color=#ffffff><div align=right>Next page");
		
		selection := senddialoggump(character, layout, data);
		selection := selection[0];
		
		if (selection == 1)
			item := item -1;
			if (item < 1)
				item := itemarray.size();
			endif
		elseif(selection == 2)
			item := item + 1;
			if (item > itemarray.size());
				item := 1;
			endif
		endif
		
		// Erase the changing parts of the gump, not very elegant but it does work
		layout.shrink(6);
		data.shrink(1);
	endwhile
endfunction




// Function returns the verbal description of the upgrade quality level
function qualitydesc(quality)
	case (quality)
		1:
			return "Basic";
		2:
			return "Quality";
		3:
			return "Exceptional";
	endcase
endfunction

// Function returns the value of the quality level (1, 1.1, or 1.2)
function qualityvalue(quality)
	case (quality)
		1:
			return 1;
		2:
			return 1.1;
		3:
			return 1.2;
	endcase
endfunction