use uo;
use os;
use basic;

include "include/client";
include "include/string";

function itemidcore ( character, the_item, verbose ) 
	if (the_item.npctemplate or the_item.acctname)
		if (verbose)
			SendSysmessage (character, "Invalid target!");
		endif
		return;
	endif
	
	if (GetObjProperty (the_item, "ownerserial") )
		if (GetObjProperty (the_item, "tname") or GetObjProperty (the_item, "prefix") or GetObjProperty (the_item, "suffix"))
			if (verbose)
				SendSysMessage (character, "You can't identify .own'ed items!");
			endif
			return;
		endif
	endif
	
	if ( getobjproperty( the_item, "power" ) )
		IdGlowingItem( character, the_item, verbose );
		return;
	endif

	if (GetObjProperty (the_item, "tname"))
		the_item.name := GetObjProperty (the_item, "tname");
		EraseObjProperty (the_item, "tname");
		EraseObjProperty (the_item, "prefix");
		EraseObjProperty (the_item, "suffix");
	elseif (GetObjProperty (the_item, "prefix") or GetObjProperty (the_item, "suffix"))
		var newname := the_item.desc;
		if (newname ["magic"])
			var space := find( the_item.desc, "c", 1 );
			var currdesc := the_item.desc;
			newname := currdesc [space+1,len(the_item.desc)];
		endif

		if (GetObjProperty (the_item, "prefix"))
			newname := GetObjProperty( the_item, "prefix" ) + newname;
		endif
		if (GetObjProperty (the_item, "suffix"))
			newname := newname + " " + GetObjProperty (the_item, "suffix");
		endif
		while (newname ["  "])
			newname ["  "] := " ";
		endwhile

		the_item.name := newname;
		EraseObjProperty (the_item, "prefix");
		EraseObjProperty (the_item, "suffix");
	endif

	var msg := "Looks like " + the_item.desc;

	var ncharges := HasCharges(the_item);
	if (ncharges)
		msg := msg + " with " + ncharges + " charges";
	endif

	var pcharges := HasPoisonProtCharges(the_item);
	if (pcharges)
		if ( ncharges ) msg := msg + " and"; endif
		msg := msg + " with " + pcharges + " poison-protection charges";
	endif

	if (verbose)
		SendSysmessage( character , msg );
	endif

	if (verbose)
		if (GetObjProperty (the_item, "flavortext") )
			var flavortext := GetObjProperty (the_item, "flavortext");
			if (GetObjProperty (the_item, "etherial") )
				flavortext := flavortext + " (Etherial: Crafted in either a different plain of existence or powered by gods or daemons, these items come with 'enormous' powers, sadly the power within them is hard to keep stable and because of this they tend to loose all their powers after a while.)";
			endif
			SendStringAsTipWindow (character, flavortext);
		endif
	endif
endfunction

function HasCharges(it)

	if (GetObjProperty(it, "charges"))
		return GetObjProperty(it, "charges");
	else
		return 0;
	endif

endfunction

function HasPoisonProtCharges( it )

	if ( getobjproperty(it,"protpoison") )
		return getobjproperty(it,"protpoison");	
	else
		return 0;
	endif

endfunction

function IdGlowingItem( who, it, verbose )

	if (!it.name[ "a glowing "])
		if (verbose)
			sendsysmessage( who, "That still looks like " + it.desc );
		endif
		return;
	endif

	var newname := it.name;
	newname[ "a glowing "] := "";

	var power := GetObjProperty( it, "power" );

	var desc := "a lesser ";
	
	if ( power > 0  and  power < 9 ) 
	 desc := "a lesser ";
	elseif ( power > 8 and power < 17 )
	 desc := "a minor ";
	elseif ( power > 16  and  power < 25 )
	 desc := "a fabled ";
	elseif ( power > 24  and power < 33 )
	 desc := "a legendary ";
	elseif ( power > 32  and  power < 41 )
	 desc := "a mythical ";
//	elseif ( power < 1  or  power > 50 )
//	 desc := "a lesser ";
	else 
	 desc := "an apocalyptic ";
	endif

	
	it.name := desc + newname;
	if (verbose)
		sendsysmessage( who, "That looks like " + it.desc );
	endif

endfunction
