use os;
use uo;
use util;

include "include/client";
include "include/objtype";
include "include/yesno";
include "include/myutil";
include "include/attributes";
include "include/dotempmods";

include "../pkg/skills/warriorskills/healing/healing";
include "../pkg/character/virtue/virtue";
include "../pkg/tools/random/random";


function BandaidHeal (healer, patient, bandages)
	SetObjProperty (healer, "#heal", ReadGameClock() + 5);
	if (!patient)
		SendSysmessage (healer, "Canceled.");
		EraseObjProperty (healer, "#heal");
		return;
	endif
	if (GetObjProperty (patient, "cut"))
		SendSysmessage (healer, "That corpse has lost its head." );
		return;
	endif
	if (getobjproperty(patient,"ghost_serial"))
		ResurrectPlayer (healer, patient, bandages);
		return;
	elseif  (GetObjProperty (patient, "townguard"))
			TrytoResurrectTownguard (healer, patient, bandages);
			return;
	elseif (patient.objtype == UOBJ_CORPSE and GetObjProperty (patient, "master"))
		var thenpctemplate := GetObjProperty (patient, "npctemplate");
		if (thenpctemplate == ":guards:warrior" or thenpctemplate == "warrior")
			TryToResurrectHenchman (healer, patient, bandages);
			return;
		elseif (GetObjProperty (patient, "pet"))
			ResurrectPet (healer, patient, bandages);
			return;
		else
			var healer_healing := GetAttribute (healer, ATTRIBUTEID_HEALING);
			var healer_anatomy := GetAttribute (healer, ATTRIBUTEID_ANATOMY);
			var res_chance := DetermineResChance (healer_healing, healer_anatomy);
			if ( !res_chance )
				SendSysMessage (healer, "You lack the skill to resurrect the dead.", FONT_NORMAL, MESSAGE_COLOR_BAD);
				EraseObjProperty (healer, "#heal");
				return;
			endif

			SendSysMessage (healer, "You begin applying a bandage...");
			var wait_time := 15 - CINT (healer_anatomy/20);
			sleep (wait_time);
			SubtractAmount (bandages, 1);

		if (Random (100) <= res_chance)
			var npc := CreateNpcFromTemplate(getobjproperty(patient,"npctemplate"), patient.x, patient.y, patient.z);
		
			if (!npc)
				SendSysMessage (healer, "didnt find template!");
				 return;
			 endif

			if ( getobjproperty( patient,"stats" ) )
				var stats := getobjproperty( patient,"stats" );
				npc.setstr( stats[1] );
				npc.setint(stats[2] );
				npc.setdex( stats[3] );
			endif

			SetVital (npc, "Life", CINT(GetVitalMaximumValue(npc, "Life")/2));
			SetVital (npc, "Statima", CINT(GetVitalMaximumValue(npc, "Statima")/2));
			SetVital (npc, "Mana", CINT(GetVitalMaximumValue(npc, "Mana")/2));

			var corpsename := patient.name;
			corpsename["A corpse of "] := "";
			corpsename["The unconscious body of "] := "";
			npc.name := corpsename;
			if ( GetObjProperty( patient, "color" ) )
				npc.color := GetObjProperty( patient, "color" );
				setobjproperty(npc,"color",npc.color);
			endif
	
			foreach item in ListEquippedItems( npc );
				DestroyItem( item );
			endforeach
			var mypack := CreateItemAtLocation(5288 , 1176 , 0, 0xE75,1);
			if (!EquipItem(npc, mypack)) DestroyItem( mypack ); endif

			mypack := npc.backpack;
			foreach item in ListRootItemsInContainer( patient )
				if ( !EquipItem( npc, item ) )
					if (!MoveItemToContainer( item, mypack ))
						var newitem := CreateItemInContainer( mypack, item.objtype,1);
						newitem.color := item.color;
						if (!EquipItem( npc, newitem ))
							DestroyItem( newitem );
						endif
					endif
				endif
			endforeach
			if ( npc.graphic == 400 )
				if ( getobjproperty(patient,"gender") )
					npc.graphic := 401;
					npc.gender := 1;
					setobjproperty(npc,"gender",npc.gender);
				endif
			endif
			setobjproperty( npc, "acctname", GetObjProperty(patient,"acctname"));
			setobjproperty( npc, "buylist", GetObjProperty(patient,"buylist"));
			setobjproperty( npc, "master", GetObjProperty(patient,"master"));
			setobjproperty( npc, "buyobj", GetObjProperty(patient,"buyobj"));
			setobjproperty( npc, "g", GetObjProperty(patient,"g"));
			setobjproperty( npc, "hp_regen_rate", GetObjProperty(patient,"hp_regen_rate"));
			setobjproperty( npc, "mn", GetObjProperty(patient,"mn"));
			setobjproperty( npc, "mypay", GetObjProperty(patient,"mypay"));
			setobjproperty( npc, "nextpay", GetObjProperty(patient,"nextpay"));
			setobjproperty( npc, "p", GetObjProperty(patient,"p"));
			setobjproperty( npc, "payments", GetObjProperty(patient,"payments"));
			setobjproperty( npc, "serial", GetObjProperty(patient,"serial"));
			setobjproperty( npc, "stamina_regen_rate", GetObjProperty(patient,"stamina_regen_rate"));
			DestroyItem( patient );
			EraseObjProperty (healer, "#heal");
		else
			SendSysmessage (healer, "You were unsuccessful at returning the patient to this world.", FONT_NORMAL, MESSAGE_COLOR_BAD);
			EraseObjProperty (healer, "#heal");
		endif
		endif
	elseif (patient.objtype == UOBJ_CORPSE )
		SendSysMessage (healer, "You cant resurrect that");
			
			return;
	elseif (!patient.npctemplate)
		HealPatient (healer, patient, bandages);
	elseif (patient.graphic == 400 or patient.graphic == 401)
		HealPatient (healer, patient, bandages);
	elseif (patient.script["tamed"])
		if (GetObjProperty (patient, "summoned") )
			SendSysMessage (healer, "And exactly how do you plan to heal that?");
			EraseObjProperty (healer, "#heal");
			return;
		endif

		var masterserial := GetObjProperty (patient, "master");
		if (!masterserial)
			SendSysMessage (healer, "You can't heal that.");
			EraseObjProperty (healer, "#heal");
			return;
		elseif (masterserial)
			HealPatient (healer, patient, bandages);
			EraseObjProperty (healer, "#heal");
			return;
		endif

		if (healer and Distance (healer, patient) < 10)
			HealPatient (healer, patient, bandages);
			EraseObjProperty (healer, "#heal");
			return;
		endif
		SendSysMessage (healer, "It looks rather skittish...");
		EraseObjProperty (healer, "#heal");
		return;
	else
		SendSysMessage (healer, "You can't heal that.");
		EraseObjProperty (healer, "#heal");
	endif	
endfunction
