use uo;
use basic;

////////////////////////////Custom gumps//////////////////////////////
// CustomGumps.inc allows a person to create easly create a gump without
// too much experience
//
// To create a gump you'll have to use the function 
//////////////
// CreateCustomMenu(
// menuname, (a string that will be used as titel)
// menutype, (either 0, 1 or 2, 0 is a simple gump where you select whatever you press, 1 is a gump with a back/cancel and forward/continue/next button, the option is a radio selection), type 2 is has the extra buttons as well but allows you to select more options)
// presistend (this is used in a menutype 1 and 2 to force the selection of a option before pressing continue/next
// textcolor, (a integer value that is used for color)
// background, (type of background, types are:
const BKGND_SILVERTRIM  := 0x0053;  // Fancy, dark-grey backing
const BKGND_SCROLL      := 0x09D8;  // Unrolling scroll style
const BKGND_GOLDTRIM    := 0x0A3C;  // Gold-press, black backing
const BKGND_PAPER       := 0x0BB8;  // Very thin edging
const BKGND_PAPER_EX    := 0x0DAC;  //  \_with fancy inner border
const BKGND_BLACKSLAB   := 0x0E10;  // Raised edge (blocky)
const BKGND_STONESLAB   := 0x13BE;  // Plain, small corners
const BKGND_STONE       := 0x13EC;  // Marble stone, rounded edge
// select_button, (this is the button infront of every option when not pressed, when pressed this value will be increased by 1 so make sure you select the right button graphics
// next_button, (this button is used in menutype 1 and 2 gumps to show a next/continue button)
// next_button, (this button is used in menutype 1 and 2 gumps to show a cancel/back button)
////////////////
//
//
// all values with exception of menuname have a default so only CreateCustomMenu(menuname) is needed for this to work.
//
// to add options to the menu you'll need to call 
////////////////
// AddOptionToCustomMenu (
// CustomMenu, (this is the return value of CreateCustomMenu())
// option (this is a string that is used behind the option/select button
///////////////
//
//
// after that you'll only need to use:
///////////////
// SelectCustomMenuOption (
// who, (the person that has to see the gump)
// CustomMenu ( the gump you created with CreateCustomMenu() and filled with AddCustomMenuOption()
/////////////
//
//
// SelectCustomMenuOption will return a array of 3 values
// array[1] is 1 if cancel/back was pressed in a Menutype 1, if not then it is always 0;
// array[2] is 1 if next/continue was pressed in a Menutype 1, if not then it is always 0;
// array[3] can be 2 things:
// 1) if menutype is not 2 then this is the selected option, if you selected the 3th item that you added into the menu then this will return 3 and so on
// 2) if menutype is 2 then this returns a array of all options, for example if (array[3][4] == 1) then the fourth option has been selected., if (array[3][2] == 0) then the second option hasn't been selected.


var aGFTlength := struct; 
aGFTlength.+charsf:=   // Space as Filler is not allowed 
         "||||||||||||||"+ //  2 
         "`',.;:::::::::"+ //  3 
         "!!!!!!!!!!!!!!"+ //  4 
         "il1[]]]]]]]]]\""+ //  5 
         "bcejot(){}==="+ //  6 
         "adfpqrszI~~~~"+ //  7 
         "ghnuvy <>----"+ //  8 
         "xJ578$?+++++++"+ //  9 
         "kCE2369^/*****"+ // 10 
         "mwABDFOP40%%"+ // 11 
         "GLNQSZ@#######"+ // 12 
         "HRT&__________"+ // 13 
         "KUYYYYYYYYYYY"+ // 14 
         "XXXXXXXXXXXXXX"+ // 15 
         "VVVVVVVVVVVVVV"+ // 16 
         "MMMMMMMMMMMMMM"+ // 18 
         "WWWWWWWWWWWWWW"; // 21 
aGFTlength.+width:= array 
       ( 
          2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 
          12, 13, 14, 15, 16, 18, 21 
       ); 

Function CreateCustomMenu (menuname, gumptype := 0, presistend := 1, textcolor := 0, background := 0x13ec, select_button := 0x138a, next_button := 0x13b2, cancel_button := 0x1450 )
	if(!CSTR(menuname) || !CINT(cancel_button) || !CINT(select_button) || !CINT(next_button) || (!CINT(textcolor) && CINT(textcolor) != 0) || !CINT(background) || (!CINT(gumptype) && CINT(gumptype) != 0))
		return 0;
	endif
	var gumpinfo := array;
	var GumpData := array; //lets empty it
	GumpData.append(menuname);
	gumpinfo[1] := GumpData;
	gumpinfo[2] := gumptype;
	gumpinfo[3] := background;
	gumpinfo[4] := select_button;
	gumpinfo[5] := next_button;
	gumpinfo[6] := cancel_button;
	gumpinfo[7] := textcolor;
	gumpinfo[8] := presistend;
	return gumpinfo;
Endfunction

Function AddOptionToCustomMenu (byref thegump, byref theoption)
	var GumpData := thegump[1];
	if(!GumpData[1] || !CSTR(theoption))
		return 0;
	endif
	GumpData.append(CSTR(theoption));
	thegump[1] := GumpData;
	return thegump;
Endfunction

Function SelectCustomMenuOption (byref who, byref thegump)
	var GumpData := thegump[1];
	if(!GumpData[1] || !who || !who.acctname)
		return 0;
	endif

	var sizeinfo := GetSizeInfo(GumpData);
	var Width := sizeinfo[1];
	if(width < 350) //not important but it looks nicer then a extremly thin gump
		width := 350;
	endif
	var Height := sizeinfo[2];
	var HeightCounter := 70;
	var select_button := thegump[4];
	var next_button := thegump[5];
	var cancel_button := thegump[6];
	var textcolor := thegump[7];
	if(thegump[2])
		Height := Height + 50;
	endif

	Var CustomMenuLayout := array;
	var CustomGumpData := array;

	CustomMenuLayout.append("nodispose");
	CustomMenuLayout.append("page 0");
	CustomMenuLayout.append("resizepic 200 20 "+CSTR(thegump[3])+" "+CSTR(Width)+" "+CSTR(Height));
	CustomMenuLayout.append("text 220 30 "+CSTR(textcolor)+" 0");
	CustomGumpData.append(GumpData[1]);

	if(thegump[2] == 2)
		CustomMenuLayout.append("group 0");
	endif

	for i := 1 to (len(GumpData)-1)
		if(thegump[2] == 2)
			CustomMenuLayout.append ("checkbox 220 "+ CSTR(HeightCounter)+" "+ CSTR(select_button)+" "+CSTR(select_button + 1)+" 0 "+CSTR(i));
		elseif(thegump[2] == 1)
			CustomMenuLayout.append ("radio 220 "+ CSTR(HeightCounter)+" "+ CSTR(select_button)+" "+CSTR(select_button + 1)+" 0 "+CSTR(i));
		else
			CustomMenuLayout.append ("button 220 "+ CSTR(HeightCounter)+" "+CSTR(select_button)+" "+CSTR(select_button + 1)+" 1 0 "+CSTR(i));
		endif
		CustomMenuLayout.append("text 250 "+CSTR(HeightCounter) + " "+CSTR(textcolor)+" "+CSTR(i));
		CustomGumpData.append(GumpData[i+1]);
		HeightCounter := HeightCounter + 25;
	endfor

	if(thegump[2])
		CustomMenuLayout.append ("button 210 "+ CSTR(HeightCounter + 20)+" "+ CSTR(cancel_button)+" "+CSTR(cancel_button + 1)+" 1 0 101"); //cancel
		CustomMenuLayout.append ("button "+ CSTR(200 + (Width - 145)) +" "+ CSTR(HeightCounter + 20)+" "+ CSTR(next_button)+" "+CSTR(next_button + 1)+" 1 0 102"); //next
	endif

	var gumpresults := SendDialogGump (who, CustomMenuLayout, CustomGumpData);
	var returnresults := array;

	if(gumpresults[0])
		returnresults[0] := gumpresults[0];
	else
		returnresults[0] := 0;
	endif

	if(thegump[2])
		if(gumpresults[101])
			returnresults[1] := gumpresults[101];
		else
			returnresults[1] := 0;
		endif

		if(gumpresults[102])
			returnresults[2] := gumpresults[102];
		else
			returnresults[2] := 0;
		endif
	else
		returnresults[1] := 0;
		returnresults[2] := 0;
	endif

	if(thegump[2] == 2)
		var resultsarray := array;
		for i := 1 to (len(GumpData)-1)
			resultsarray[i] := gumpresults[i];
		endfor
		returnresults[3] := resultsarray;
	elseif(thegump[2] == 1)
		for i := 1 to (len(GumpData)-1)
			if(gumpresults[i])
				returnresults[3] := i;
			endif
		endfor
	else
		returnresults[3] := gumpresults[0];		
	endif

	if(!returnresults[3] && returnresults[2] && thegump[8])
		SendSysMessage (who, "please, select a option",0x00, 38);
		if(thegump[2])
			SendSysMessage (who, "or press cancel", 0x00, 38);
		endif
		var tempmenu := CreateCustomMenu (GumpData[1], thegump[2], thegump[8], thegump[7], thegump[3], thegump[4], thegump[5], thegump[6]);
		for i := 2 to (len(GumpData))
			AddOptionToCustomMenu (tempmenu, GumpData[i]);
		endfor
		returnresults := SelectCustomMenuOption (who, tempmenu);
	elseif(!returnresults[3] && returnresults[3] != 0)
		returnresults[3] := 0;
	endif

	return returnresults;
Endfunction

Function GetSizeInfo (gumptexts)
	if(!(len(gumptexts)))
		return 0;
	endif

	var i;
	var biggestwidth := 0;
	var currentwidth := 0;
	for (i := len(gumptexts); i>0; i:=i-1) 
		currentwidth := GetTextWidth(gumptexts[i]);
		if(currentwidth > biggestwidth)
			biggestwidth := currentwidth;
		endif
	endfor

	var sizeinfo := array;
	sizeinfo[1] := biggestwidth + 50;
	sizeinfo[2] := ((len(gumptexts) - 1) * 25) + 60; //+60 for the main gump info, everything else for the options

	return sizeinfo;
Endfunction

Function GetTextWidth(gumptext) 
	var points:=0; 
	var j; 

	For (j:=len(gumptext); j>0; j:=j-1) 
		var i:=Find(aGFTlength.charsf, gumptext[j], 1)-1; 
		If (i>=0) 
			points:=points+aGFTlength.width[CInt(i/14)+1]; 
		EndIf 
	EndFor 

	Return (points); 
EndFunction
