///////////////////
//
//  Functions for storing and retriving properties about accounts from
//  a datafile (":character:character_data")
//
///////////////////

use uo;
use os;
use datafile;

function GetAccountProperty (acctname, property)
	set_critical (1);
	UnloadDataFile (":character:character_data");
	var acctinfodf := OpenDataFile (":character:character_data");
	if (!acctinfodf)
		acctinfodf := CreateDataFile (":character:character_data");
		if (!acctinfodf)
			Syslog ("Error opening character data file!");
			set_critical (0);
			return 0;
		endif
	endif

	var entry := acctinfodf.FindElement (acctname);
	if (!entry)
		acctinfodf.CreateElement (acctname);
		entry := acctinfodf.FindElement (acctname);
	endif
	var retvalue := entry.GetProp (property);
	set_critical (0);
	return retvalue;
endfunction


function SetAccountProperty (acctname, property, value)
	set_critical (1);
	var acctinfodf := OpenDataFile (":character:character_data");
	if (!acctinfodf)
		acctinfodf := CreateDataFile (":character:character_data");
		if (!acctinfodf)
			Syslog ("Error opening character data file!");
			set_critical (0);
			return 0;
		endif
	endif

	var entry := acctinfodf.FindElement (acctname);
	if (!entry)
		acctinfodf.CreateElement (acctname);
		entry := acctinfodf.FindElement (acctname);
	endif
	
	entry.SetProp (property, value);
	UnloadDataFile (":character:character_data");
	set_critical (0);
endfunction

function EraseAccountProperty (acctname, property)
	set_critical (1);
	var acctinfodf := OpenDataFile (":character:character_data");
	if (!acctinfodf)
		acctinfodf := CreateDataFile (":character:character_data");
		if (!acctinfodf)
			Syslog ("Error opening character data file!");
			set_critical (0);
			return 0;
		endif
	endif

	var entry := acctinfodf.FindElement (acctname);
	if (!entry)
		acctinfodf.CreateElement (acctname);
		entry := acctinfodf.FindElement (acctname);
	endif
	
	entry.EraseProp (property);
	UnloadDataFile (":character:character_data");
	set_critical (0);
endfunction



