///////////////////
//
//  Contains assorted functions related to crafting
//
///////////////////




///////////////////
//  Tries to find the bag that crafted items will go into, if not the character's main backpack.
//  Set with .options
///////////////////

function FindCraftingBag (character)
	//Make absolutely certain that they have a backpack
	if (!character.backpack)
		var newbackpack := CreateItemAtLocation (5288, 1176, 0, UOBJ_BACKPACK, 1);
		if (!EquipItem (character, newbackpack))
			DestroyItem (newbackpack);
		endif
	endif

	var craftingbagserial := GetObjProperty (character, "craftingbagserial");
	if (!craftingbagserial)
		return character.backpack;
	endif
	
	foreach item in EnumerateItemsInContainer (character.backpack)
		if (item.serial == craftingbagserial)
			if (item.isa (POLCLASS_CONTAINER))
				return item;
			endif
		endif
	endforeach

	//Still can't find it
	EraseObjProperty (character, "craftingbagserial");
	return character.backpack;
endfunction





