function DoSkillBoost( who, it, power, metalarmor := 0 )

	if ( power > 8 and randomint (100) < 10)
		power := randomint (power) + 1;
	elseif ( randomint (1000) < 10)
		ThaBomb (who, it, power);
		return;
	endif

	it.name := "";
	var skillnum := -1;
	if ( it.attribute )
		skillnum := GetSkillIDByAttributeID(it.attribute);
	elseif ( IsShield( it.objtype) ) 
		skillnum := 5;
	elseif (getobjproperty(it,"wargloves") ) 
		skillnum := 43;
	else
		repeat
			skillnum := RandomInt(49);
			var skillscfg := ReadConfigFile(":skills:skillmaster");
			if (!skillscfg[skillnum].desc ) skillnum := -1;	endif
			if (!ValidSkill( skillnum, metalarmor ) )
				skillnum := -1;
			endif
		until (skillnum != -1);
	endif

	//  Probably could have deleted this, but just in case I'll nest it in an if
	if (!it.quality)
		it.quality := 1.0;
	endif
	
	it.hp := it.maxhp;
	var skillbonus := 0;
	var itdesc := TruncateArticle( it.desc );

	var hp;

	if ( power >= 0  and  power < 9 ) 
	 	hp := 10;
		it.name := "a Fine " + itdesc;
		skillbonus := 5;
	elseif ( power > 8 and power < 17 )
	 	hp := 20;
		it.name := "a Durable " + itdesc;
		skillbonus := 10;
	elseif ( power > 16  and  power < 25 )
		hp := 30;
		it.name := "a Rugged " + itdesc;
		skillbonus := 15;
	elseif ( power > 24  and power < 33 )
	 	hp := 40;
		it.name := "a Tempered " + itdesc;
		skillbonus := 20;
	elseif ( power > 32  and  power < 41 )
	 	hp := 50;
		it.name := "a Indestructable " + itdesc;
		skillbonus := 25;
	elseif ( power < 1  or  power > 50 )
		hp := 10;
		it.name := "a Fine " + itdesc;
		skillbonus := 5;
	else 
	 	hp := 60;
		it.name := "a Legacy " + itdesc;
		skillbonus := 30;
	endif


	var basemod := cint(it.maxhp/5);
	it.hp_mod := hp + basemod;
	it.maxhp_mod := hp + basemod;
	it.hp := it.maxhp;

	itdesc := it.desc;
	if (skillnum != -1 )
		if ( ( (skillnum) or (skillnum == 0) ) and ( skillbonus ) )
			setobjproperty(it,"skilladv",skillnum);
			setobjproperty(it,"skill"+ skillnum,skillbonus);
			var skillscfg := ReadConfigFile(":skills:skillmaster");
			var skillname := skillscfg[skillnum].desc;
			it.name := itdesc + " of " + skillname;
		endif
	endif

	it.name := it.name + " [enchanted by " + who.name + "]";

endfunction

function DoResistanceThing( who, it, power )

	if ( randomint (1000) < 10)
		ThaBomb (who, it, power);
		return;
	endif

	it.name := "";
	var charges := 50+ (randomint(100)+1);

	var itdesc := it.desc;
	case ( randomint(6)+1 )
	1:
		if ( randomint (2))
			SetObjproperty(it,"resistance",DAMAGETYPE_FIRE);
			SetObjproperty(it,"charges",charges );
			it.name := itdesc + " of Fire Resistance";
		else
			SetObjproperty(it,"resistance",DAMAGETYPE_COLD);
			SetObjproperty(it,"charges",charges );
			it.name := itdesc + " of Frost Resistance";
		endif
	2:
		if ( randomint (2))	
			SetObjproperty(it,"resistance",DAMAGETYPE_ELECTRICAL);
			SetObjproperty(it,"charges",charges );
			it.name := itdesc + " of Electrical Resistance";
		else
			SetObjproperty(it,"equipspell","damageshield");
			SetObjproperty(it,"charges",charges );
			itdesc := TruncateArticle( it.desc );
			if ( randomint(2) )
				setobjproperty( it,"damagetype",1);
				it.name := "a Flaming " + itdesc;
				it.color := 1618;
			else
				setobjproperty( it,"damagetype",2);
				it.name := "an Icy " + itdesc;
				it.color := 1152;
			endif
		endif
	3:
		SetObjproperty(it,"protpoison",charges);
		var suffix := GetObjProperty( it, "suffix");
		it.name := itdesc + " of Poison Protection";
	4:
		SetObjproperty(it,"equipspell","magicreflect");
		SetObjproperty(it,"charges",charges );
		it.name := itdesc + " of Magic Reflection";
	5:
		SetObjproperty(it,"equipspell","stealthcloak");
		SetObjproperty(it,"charges",charges );
		it.name := itdesc + " of Invisibility";
	6:
		SetObjProperty(it,"equipspell","regeneration");
		SetObjProperty(it,"charges",randomint(50)+50);
		it.name := itdesc + " of Regeneration";
	endcase

	it.name := it.name + " [enchanted by " + who.name + "]";

endfunction

function DoARBoost( who, it, power )

	if ( power > 8 and randomint (100) < 10)
		power := randomint (power) + 1;
	elseif ( randomint (1000) < 10)
		ThaBomb (who, it, power);
		return;
	endif

	it.name := "";
	var itdesc := it.desc;

	if ( power >= 0  and  power < 9 ) 
	 	it.ar_mod := 11;
		it.name := it.desc + " of Defense";
	elseif ( power > 8 and power < 17 )
	 	it.ar_mod := 12;
		it.name := it.desc + " of Guarding";
	elseif ( power > 16  and  power < 25 )
		it.ar_mod := 13;
		it.name := it.desc + " of Protection";
	elseif ( power > 24  and power < 33 )
	 	it.ar_mod := 14;
		it.name := it.desc + " of Fortification";
	elseif ( power > 32  and  power < 41 )
	 	it.ar_mod := 15;
		it.name := it.desc + " of Invulnerability";
	elseif ( power < 1  or  power > 50 )
		it.ar_mod := 11;
		it.name := it.desc + " of Defense";
	else 
	 	it.ar_mod := 16;
		it.name := it.desc + " of Invincibility";
	endif

	

endfunction

function DoDamageBoost( who, it, power )

	if ( power > 8 and randomint (100) < 10)
		power := randomint (power) + 1;
	elseif ( randomint (1000) < 10)
		ThaBomb (who, it, power);
		return;
	endif

	it.name := "";
	var itdesc := it.desc;

	if ( power >= 0  and  power < 9 ) 
		if ( getobjproperty(it,"wargloves"))
			setobjproperty(it,"dmg_mod", 1);	
		else
		 	it.dmg_mod := 1;
		endif
		it.name := it.desc + " of Quality";
	elseif ( power > 8 and power < 17 )
		if ( getobjproperty(it,"wargloves"))
			setobjproperty(it,"dmg_mod", 3);	
		else
		 	it.dmg_mod := 3;
		endif
		it.name := itdesc + " of Might";
	elseif ( power > 16  and  power < 25 )
		if ( getobjproperty(it,"wargloves"))
			setobjproperty(it,"dmg_mod", 5);	
		else
		 	it.dmg_mod := 5;
		endif
		it.name := itdesc + " of Maiming";
	elseif ( power > 24  and power < 33 )
		if ( getobjproperty(it,"wargloves"))
			setobjproperty(it,"dmg_mod", 7);	
		else
		 	it.dmg_mod := 7;
		endif
		it.name := itdesc + " of Power";
	elseif ( power > 32  and  power < 41 )
		if ( getobjproperty(it,"wargloves"))
			setobjproperty(it,"dmg_mod", 9);	
		else
		 	it.dmg_mod := 9;
		endif
		it.name := itdesc + " of Destruction";
	elseif ( power < 1  or  power > 50 )
		if ( getobjproperty(it,"wargloves"))
			setobjproperty(it,"dmg_mod", 1);	
		else
		 	it.dmg_mod := 1;
		endif
		it.name := it.desc + " of Quality";
	else 
		if ( getobjproperty(it,"wargloves"))
			setobjproperty(it,"dmg_mod", 11);	
		else
		 	it.dmg_mod := 11;
		endif
		it.name := itdesc + " of Annihilation";
	endif
	

	it.name := it.name + " [enchanted by " + who.name + "]";

	if ( randomint(10)==1 )
		DoRaceSpecificWeapon( who, it );
	endif

endfunction

function DoRaceSpecificWeapon( who, it)

	var itdesc := TruncateArticle( it.desc );

	var newcolor := 0;

	var power := randomint (16) + 1;

	case (power)
	1:
		setobjproperty(it,"killspecial","orcs");
		it.name := "an Orc Slaying " + itdesc;
	2:
		setobjproperty(it,"killspecial","ratmen");
		it.name := "a Ratman Slaying " + itdesc;
	3:
		setobjproperty(it,"killspecial","terathans");
		it.name := "a Terathan Slaying " + itdesc;
	4:
		setobjproperty(it,"killspecial","lizardmen");
		it.name := "a Lizardman Skinning " + itdesc;
	5:
		setobjproperty(it,"killspecial","ophidians");
		it.name := "an Ophidian Slaying " + itdesc;
	6:
		setobjproperty(it,"killspecial","humanoids");
		it.name := "a Giant Biting " + itdesc;
	7:
		setobjproperty(it,"killspecial","trolls");
		it.name := "a Troll Reduction " + itdesc;
	8:
		setobjproperty(it,"killspecial","elementals");
		it.name := "an Elemental Destruction " + itdesc;
		newcolor := 1209;
	9:
		setobjproperty(it,"killspecial","vampires");
		it.name := "a Vampire Splitting " + itdesc;
		newcolor := 1209;
	10:
		setobjproperty(it,"killspecial","evilhumans");
		it.name := "a Evil's Bane ";
	11:
		setobjproperty(it,"killspecial","diablo");
		it.name := "a Holy " + itdesc;
		newcolor := 1154;
	12:
		setobjproperty(it,"killspecial","dragons");
		it.name := "a Dragon Cleaving " + itdesc;
	13:
		setobjproperty(it,"killspecial","lightning");
		it.name := "a Lightning " + itdesc;
	14:
		setobjproperty(it,"killspecial","vampire");
		it.name := "a Vampire " + itdesc;
	15:
	 	setobjproperty(it,"silver",1);
		it.name := "a Silver " + itdesc;
	16:
		setobjproperty(it,"killspecial","shabooli");
		it.name := "a Zulu's Bane " + itdesc;
	endcase

	if ( newcolor ) it.color := newcolor; endif

endfunction

function MakeMagicMusicalInstrument( who, it, power )

	if ( power > 8 and randomint (100) < 10)
		power := randomint (power) + 1;
	elseif ( randomint (1000) < 10)
		ThaBomb (who, it, power);
		return;
	endif

	it.name := "";

	var skillnum := 29;//musicianship
	case (randomint(3))
	0: skillnum := 22;//provoke
	1: skillnum := 9;//peacemaking
	endcase

	var skillbonus := 5;
	if ( power > 0  and  power < 9 ) 
	 	skillbonus := 5;
		it.name := it.desc + " of Sonority";
	elseif ( power > 8 and power < 17 )
	 	skillbonus := 10;
		it.name := it.desc + " of Accord";
	elseif ( power > 16  and  power < 25 )
		skillbonus := 15;
		it.name := it.desc + " of Melody";
	elseif ( power > 24  and power < 33 )
	 skillbonus := 20;
		it.name := it.desc + " of Harmony";
	elseif ( power > 32  and  power < 41 )
	 	skillbonus := 25;
		it.name := it.desc + " of Consonance";
	elseif ( power < 1  or  power > 50 )
		skillbonus := 5;
		it.name := it.desc + " of Sonority";
	else 
	 	skillbonus := 30;
		it.name := it.desc + " of Resonance";
	endif
	

	if ( ( (skillnum) or (skillnum == 0) ) and ( skillbonus ) )
		setobjproperty(it,"skillbonus",skillbonus);
	endif

	it.name := it.name + " [enchanted by " + who.name + "]";

endfunction

function ThaBomb (who, it, power)

	var range := 5 + ( power / 5);
	who.paralyzed := 1; // hahahaha
	
	//save the target's location so that the wave doesn't go wacky if they move
	PrintTextAbove (who, "*The glowie is unstable !!!!!*");
	sleepms(1250);
	PlayObjectCenteredEffect (who,0x376a, 10, 30);
	PrintTextAbove (who, "*3*");

	sleepms(1250);

	PlayObjectCenteredEffect (who,0x376a, 10, 30);
	PrintTextAbove (who, "*2*");

	sleepms(1250);

	PlayObjectCenteredEffect (who, 0x374a, 20, 20);
	PrintTextAbove (who, "*1*");

	sleepms(1000);
	destroyItem(it);

	var nearby := ListMobilesNearLocation (who.x, who.y, who.z, range);
	foreach mobile in nearby
		if (!mobile.dead)
			PlaySoundEffect (mobile, SFX_SPELL_FLAME_STRIKE);
		 	PlayObjectCenteredEffect (mobile,0x3709, 0x0a, 0x1e);
			ApplyRawDamage ( mobile, 200 ); // BOJA
		endif
	endforeach

	who.paralyzed := 0; // hello deadguy :P
endfunction

