use os;
use uo;
use cfgfile;

///////////////////
//returns an array of all the items in container of the given objtype
///////////////////

function EnumerateItemsInContainerOfObjtype (byref container, objtype)
	var ret := { };
	foreach item in enumerateItemsIncontainer(container)
		if ( item.objtype == objtype )
			ret.append(item);
		endif
	endforeach
	return ret;
endfunction




///////////////////
//returns the first item found in the container of the given objtype
///////////////////

function FindItemInContainerOfObjtype (byref container, objtype)
	foreach item in enumerateitemsincontainer(container)
		if (item.objtype == objtype)
			return item;
		endif
	endforeach
	return 0;
endfunction




//returns all the 'top-level' items in container
function ListRootItemsInContainer (byref container)

	var ret := { };
        foreach item in enumerateitemsincontainer(container)
		if ( item.container == container )
			ret.append(item);
		endif
	endforeach

	return ret;

endfunction

//returns all the 'top-level' items in container of objtype
function ListRootItemsInContainerOfObjtype (byref container, objtype)

	var ret := { };
        foreach item in enumerateitemsincontainer(container)
		if ( (item.container == container) and (item.objtype == objtype) )
			ret.append(item);
		endif
	endforeach

	return ret;

endfunction

function InInventory (byref inventory, byref it)

	foreach item in EnumerateItemsInContainer(inventory)
		if (item == it)
			return 1;
		endif
	endforeach

	return 0;

endfunction

function IsContainer (byref it)
	if (it.objtype == 0x7057)
		return 0;//trashcans don't count as containers
	endif

	if (it.isa (POLCLASS_CONTAINER))
		return 1;
	endif
	return 0;
endfunction




///////////////////
//  Determines if the given character counts as having GM status.  This is used to see if the given account
//  has permission to do things such as check the help page queue.  Characters with a cmdlevel automatically
//  count.  otherwise it checks to see if the accountname is listed in /config/gms.cfg
///////////////////

function IsAGM (character)
	if (character.cmdlevel)
		return CINT (character.cmdlevel);
	endif
	
	UnloadConfigFile ("::gms");
	var cfgfile := ReadConfigFile ("::gms");
	var elem := FindConfigElem (cfgfile, character.acctname);
	if (!elem)
		return 0;
	endif
	if (elem.cmdlevel)
		return elem.cmdlevel;
	endif

	return 0;
endfunction

function ListWornItems( who )

	var items := { };
	var excludeditems := { };

	var it;
	it := GetEquipmentByLayer( who, LAYER_BEARD );
	if (it) excludeditems.append( it ); endif

	it := GetEquipmentByLayer( who, LAYER_HAIR );
	if (it) excludeditems.append( it ); endif

	it := GetEquipmentByLayer( who, LAYER_MOUNT );
	if (it) excludeditems.append( it ); endif

	it := GetEquipmentByLayer( who, LAYER_HAIR );
	if (it) excludeditems.append( it ); endif

	it := who.backpack;
	if (it) excludeditems.append( it ); endif

	foreach item in ListEquippedItems( who )
		if (!(item in excludeditems))
			items.append( item );
		endif
	endforeach
	return items;

endfunction

///////////////////
//  Alerts the GM  to any important events in the invasion spawner
///////////////////

function alertgm (msg, syslogit := 0)
	if (syslogit)
		syslog (msg);
		print (msg);
	endif

	foreach player in EnumerateOnlineCharacters ()
		if (IsAGM (player) == 5)
			SendSysMessage (player, msg);
		endif
	endforeach
endfunction
