Const BIRD_IDX := 1;
Const DAEMON_IDX := 2;
Const DRAGON_IDX := 3;
Const MALE_IDX := 5;
Const FEMALE_IDX := 6;
Const LIZARD_IDX := 9;
Const ORC_IDX := 10;
Const OGRE_IDX := 11;
Const RATMAN_IDX := 12;
Const OBJ_BIRD := 0x6;
Const OBJ_DAEMON := 0x9;
Const OBJ_DAEMON_SWORD := 0xA;
Const OBJ_DRAGON_RED := 0x3D;
Const OBJ_DRAGON_GREY := 0xC; 
Const OBJ_MALE := 0x190;
Const OBJ_FEMALE := 0x191;
Const OBJ_LIZARD := 0x21;
Const OBJ_LIZARD_MACE := 0x24;
Const OBJ_LIZARD_SPEAR := 0x23;
Const OBJ_ORC := 0x11;
Const OBJ_ORC_CLUB := 0x29;
Const OBJ_ORC_CAPT := 0x7;
Const OBJ_OGRE := 0x1;
Const OBJ_RATMAN := 0x2A;
Const OBJ_RATMAN_SWORD := 0x2D;
Const OBJ_RATMAN_AXE := 0x2C;



//randname.inc
//
//assigns a random name from the list according to obtype and gender

use uo;
use os;
use cfgfile;
use util;
use basic;

function RandomName (byref me )

	var newname := " ";
	case( me.graphic )
	    OBJ_BIRD:			newname := AssignName( me , BIRD_IDX );
	    OBJ_DAEMON:		newname := AssignName( me , DAEMON_IDX );
	    OBJ_DAEMON_SWORD:	newname := AssignName( me , DAEMON_IDX );
	    OBJ_DRAGON_RED:		newname := AssignName( me , DRAGON_IDX );
	    OBJ_DRAGON_GREY: 	newname := AssignName( me , DRAGON_IDX );
		0x3b: 			newname := AssignName( me , DRAGON_IDX );
	    OBJ_MALE: 		newname := AssignName( me , MALE_IDX );
	    OBJ_FEMALE:		newname := AssignName( me , FEMALE_IDX );
	    OBJ_LIZARD:		newname := AssignName( me , LIZARD_IDX );
	    OBJ_LIZARD_MACE:	newname := AssignName( me , LIZARD_IDX );
	    OBJ_LIZARD_SPEAR:	newname := AssignName( me , LIZARD_IDX );
	    OBJ_ORC:		newname := AssignName( me , ORC_IDX );
	    OBJ_ORC_CLUB:	newname := AssignName( me , ORC_IDX );
	    OBJ_ORC_CAPT:	newname := AssignName( me , ORC_IDX );
	    OBJ_OGRE:		newname := AssignName( me , OGRE_IDX );
	    OBJ_RATMAN:		newname := AssignName( me , RATMAN_IDX );
	    OBJ_RATMAN_SWORD:	newname := AssignName( me , RATMAN_IDX );
	    OBJ_RATMAN_AXE:	newname := AssignName( me , RATMAN_IDX );
	    default: 		exit;
	endcase

	return(newname);
endfunction


function AssignName( me , index )

    var cfg := ReadConfigFile( ":npcs:names" );
    var elem := FindConfigElem( cfg , index );
    var number := GetConfigInt( elem , "Count" );

    var dice_str := "1d" + cstr(number);

    var choice := RandomDiceRoll( dice_str );
    var entry := "Name" + choice;

    var str := GetConfigString( elem , entry );
    var title := PreserveTitle( me );
   
    str := str + title;

    return( str );

endfunction


function PreserveTitle( me )

  var myname := me.name;
  var start := find( myname , ">" , 1 );

if( !start )
  return;
endif

  var title := myname[ start+1 , (len( myname ) - 8) ];

if( !title )
  return("");
endif

  return( title );

endfunction




