Const TOWN_BRENIN			:= 1;
Const TOWN_EIRWEN		        := 2;
Const TOWN_WYNTIR_HAVEN			:= 3;
Const TOWN_YEPA			:= 4;
Const TOWN_WYNDA			:= 5;
Const TOWN_KNIGHTON			:= 6;
Const TOWN_LUDLOW			:= 7;
Const TOWN_IBOR			:= 8;
Const TOWN_DUNRAVI		:= 9;
Const TOWN_CADARN		        := 10;
Const TOWN_ISADORA			:= 11;
Const TOWN_HYDD			:= 12;
Const TOWN_FERDAID			:= 13;


Const TOWN_START			:= 1;
Const TOWN_END				:= 13;




///////////////////
//  Figures out out if a location is within a town, and if so, what town
///////////////////

function FindTownFromLocation (x, y)
	if (x >= 2940 and x <= 991 and y >= 991 and y <= 1121)
		return TOWN_BRENIN;
	elseif (x >= 4563 and x <= 4584 and y >= 3671 and y <= 3702)
		return TOWN_EIRWEN;
	elseif (x >= 4475 and x <= 4548 and y >= 1245 and y <= 1300)
		return TOWN_WYNTIR_HAVEN;
	elseif (x >= 4713 and x <= 4548 and y >= 1144 and y <= 1198)
		return TOWN_YEPA;
	elseif (x >= 3662 and x <= 3802 and y >= 1462 and y <= 1585)
		return TOWN_WYNDA;
	elseif (x >= 3053 and x <= 3220 and y >= 2558 and y <= 2674)
		return TOWN_KNIGHTON;
	elseif (x >= 3240 and x <= 3386 and y >= 2558 and y <= 2667)
		return TOWN_LUDLOW;
	elseif (x >= 2300 and x <= 2534 and y >= 839 and y <= 900)
		return TOWN_IBOR;
	elseif (x >= 1534 and x <= 1766 and y >= 1388 and y <= 1638)
		return TOWN_DUNRAVI;
	elseif (x >= 820 and x <= 984 and y >= 2003 and y <= 2167)
		return TOWN_CADARN;
	elseif (x >= 758 and x <= 858 and y >= 659 and y <= 799)
		return TOWN_ISADORA;
	elseif (x >= 2054 and x <= 2204 and y >= 236 and y <= 332)
		return TOWN_HYDD;
	elseif (x >= 1376 and x <= 1484 and y >= 3755 and y <= 3828)
		return TOWN_FERDAID;
	endif
	return 0;
endfunction




///////////////////
//  Finds the town that a given NPC is located in
///////////////////

function FindMyTown (npc)
	return FindTownFromLocation (npc.x, npc.y);
endfunction




///////////////////
//  Determines the name of a town from its number
///////////////////

function GetNameOfTown (townnum)
		
	case (townnum)
		TOWN_BRENIN:
			return "Brenin";
		TOWN_EIRWEN:
			return "Eirwen";
		TOWN_WYNTIR_HAVEN:
			return "Wyntir Haven";
		TOWN_YEPA:
			return "Yepa";
		TOWN_WYNDA:
			return "Wynda";
		TOWN_KNIGHTON:
			return "Knighton";
		TOWN_LUDLOW:
			return "Ludlow";
		TOWN_IBOR:
			return "Ibor";
		TOWN_DUNRAVI:
			return "Dunravi";
		TOWN_CADARN:
			return "Cadarn";
		TOWN_ISADORA:
			return "Isadora";
		TOWN_HYDD:
			return "Hydd";
		TOWN_FERDAID:
			return "Ferdaid";
		
		default:
			return "";
	endcase
	return "";
endfunction




